// [=====================================================================]

//    Name:  KeyInjectModuleDlg.h     Last Modified:  
//    Author:							First Working:  
//  
// [=====================================================================]
// [  Maintenance Record                                                 ]
// [---------------------------------------------------------------------]
//    Date         Version        Author                   Description
//	  09/07/2006	  1.0.6		  
// [=====================================================================]

#if !defined(AFX_KEYINJECTMODULEDLG_H__3914DC51_90F3_43B5_8646_8EDBCAFF4862__INCLUDED_)
#define AFX_KEYINJECTMODULEDLG_H__3914DC51_90F3_43B5_8646_8EDBCAFF4862__INCLUDED_

#include "DesHelper.h"	// Added by ClassView
#include "RS232.h"	// Added by ClassView
#include "USB.H"
#include "KeyRetriver.h"	// Added by ClassView
#include "ProtocolManager.h"	// Added by ClassView
#include "PortSetter.h"	// Added by ClassView
#include <afxmt.h>
#include "DesKeyRetriver.h"	// Added by ClassView
#include "idt_usb_hid.h"
#include "DUKPT.h"
#include "DES.h"
#include "AesCipher.h"
#include "serialconn.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define DES_MODE  = 0;
#define TDES_MODE = 1;

#define USB_MODE 1
#define COM_MODE 2

#define MSG_SET_TEXT WM_USER+2000
//#define DES  = 1;
//#define TDES = 3;

//#include "keyManager.h"
/////////////////////////////////////////////////////////////////////////////
// CKeyInjectModuleDlg dialog

class CKeyInjectModuleDlg : public CDialog
{
// Construction
public:
	CString m_Method;
	void InitDlg();
	bool SendToDevice(int iProtocol, int iKeyType,bool bIsData, byte *bpRawKey ,byte* pBKCV,int *ipLength);
	BOOL m_isFrist;
	int m_iCurrentOperation;
	void MakeVisibleDebitKey();
	int DisplayMsg(CString DisMsg,CString DisVal,CString Cap,UINT type);
	CString FormatHexToStr(byte * pBKCV);
	int m_NoOfDevices;
	void MasterTDES(int keyParts);
	void MasterDES(int keyParts);
	void DUKPT_TDES(int keyParts);
	void DUKPT_DES(int keyParts);
	void CallInjector(int iencryption, int ikeyParts);
	void FreeMem(unsigned char * pCh);
	void SetToHex(const byte *inBuff, byte *outBuff,int iLen);
	int Getkey(int TYPE, byte* pRtrn);
	void Outputdata();
	byte * m_pMasterKey;
	byte * m_pMasterKcv;
    
	byte * m_pKsn;
	byte * m_pKsnKcv;
	byte * m_pBdk;
	byte * m_pBdkKcv;

	void Decryption();
	byte asctohex(byte m, byte n);	
	byte asctodec(byte m, byte n);
	CString	StrInput_Data;
	CString	StrInput;

	BYTE	m_Track1Buffer[1000];
	BYTE	m_Track2Buffer[1000];
	BYTE	m_Track3Buffer[1000];
	BYTE	m_SessionIDBuffer[16];

	
	DWORD	DataLen;
	DWORD	DataLen1;
	DWORD	DataLen2;
	DWORD	DataLen3;
	DWORD	m_CardType;
	BYTE	m_WholeCardDataBuf[400];
	UINT	WholeCardDataLen;
	CString	m_NotificationData;

	//DES type
	int m_des_index;
	CString	m_str_initial_key;

	//array for KSN
	unsigned char m_cksn[20];  
	unsigned char m_nksn[10];     

	//array for PIN
	unsigned char m_cpin[16];
	unsigned char m_npin[8];

	//array for initial key of DUKPT
	unsigned char m_cinitial_key[32];
	unsigned char m_nderivation_key[16];
	unsigned char m_ninitial_key[16];
	//PIN block
	unsigned char m_npin_block[8];

	BOOL bTrk1;
	BOOL bTrk2;
	BOOL bTrk3;

	// for decryption
	unsigned char m_cryptoKey[16];
	CDES           lcDES;
	CDUKPT         lcDUKPT;
	AesCipher	   lcAES;

	//Decryption Mode
	int bDecryptMode;
	int KBMode;
	CMenu		m_menu;
	UINT		m_Timer;

	CSerial sp_com;
	CComboBox com_combobox;

	CKeyRetriver m_KetRtrvr;
	CKeyInjectModuleDlg(CWnd* pParent = NULL);	// standard constructor
	void Received_HID_Data(); 



// Dialog Data
	//{{AFX_DATA(CKeyInjectModuleDlg)
	enum { IDD = IDD_KEYINJECTMODULE_DIALOG };
	CString	m_NoOfKeyPart;
	CString	m_Encrypt;
	CString	m_strNumDevices;
	int		m_imethod;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CKeyInjectModuleDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
	CString		StrCommand;
	// Generated message map functions
	//{{AFX_MSG(CKeyInjectModuleDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnEditchangeNoOfKeyParts();
	afx_msg void OnInjectKey();
	afx_msg void OnInject();
	afx_msg void OnExit();
	virtual void OnCancel();
	afx_msg void OnCancelDebit();
	afx_msg void OnSend();
	afx_msg void OnDecrypt();
	afx_msg void OnInputKey();
	afx_msg void OnMENUSetDefault();
	afx_msg void OnMENUReadConfiguration();
	afx_msg void OnMENUReadFirmware();
	afx_msg void OnMENUBeeperOff();
	afx_msg void OnMENUBeeperLow();
	afx_msg void OnMENUBeeperHigh();
	afx_msg void OnMENUReadBothDirections();
	afx_msg void OnMENUReadForwardDirection();
	afx_msg void OnMENUReadBackwardDirection();
	afx_msg void OnMENUReadAnyTracks();
	afx_msg void OnMENUReadTrack1();
	afx_msg void OnMENUReadTrack2();
	afx_msg void OnMENUReadTrack12();
	afx_msg void OnMENUReadTrack3();
	afx_msg void OnMENUReadTrack13();
	afx_msg void OnMENUReadTrack23();
	afx_msg void OnMENUReadAllTracks();
	afx_msg void OnMENUSendTrackSeparator();
	afx_msg void OnMENUNotSendTrackSeparator();
	afx_msg void OnMENUSendTerminator();
	afx_msg void OnMENUNotSendTerminator();
	afx_msg void OnMENUAbout();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnMenuTdes();
	afx_msg void OnMenuAes();
	afx_msg void OnMENUSetPrePANClrDataID();
	afx_msg void OnMENUSetPostPANClrDataID();
	afx_msg void OnMENUSetMaskCharID();
	afx_msg void OnEnableLRCID();
	afx_msg void OnDisableLRCID();
	afx_msg void OnRawDataID();
	afx_msg void OnMSREnableID();
	afx_msg void OnMSRDisableID();
	afx_msg void OnEnterBootloaderModeID();
	afx_msg void OnSecurityLevID();
	afx_msg void OnWSEErrorNotificationID();
	afx_msg void OnWoSEAllT2ErrorNotification();
	afx_msg void OnWSEPartialT2ErrorNotification();
	afx_msg void OnSetPreamble0123456789ID();
	afx_msg void OnSetPostamble9876543210ID();
	afx_msg void OnHIDMagTMode();
	afx_msg void OnHIDIDTMode();
	afx_msg void OnUSBKBMode();
	afx_msg void OnMENUSetBufferMode();
	afx_msg void OnMenuAtr();
	afx_msg void OnMENUReadBufferedData();
	afx_msg void OnMENUSetPollingInterval();
	afx_msg void OnMENUSetArabia();
	afx_msg void OnMENUSetUK();
	afx_msg void OnMENUSetUniversal();
	afx_msg void OnSetpollinginterval1();
	afx_msg void OnGetDeviceSN();
	afx_msg void OnSetDeviceSN();
	afx_msg void OnWSET2ErrornotificationAlt();
	afx_msg void OnEnterKey();
	afx_msg void OnMENUSetSessionID();
	afx_msg void OnMenuEnableencryption();
	afx_msg void OnMenuDisableencryption();
	afx_msg void OnActivateAuthentication();
	afx_msg void OnActivateChallengeReply();
	afx_msg void OnDeactivateChallengeReply();
	afx_msg void OnGetReaderStatus();
	afx_msg void OnMENUNewEncryptionFormat();
	afx_msg void OnMENUOldEncryptionFormat();
	afx_msg void OnMENUForceEncryptAllTracks();
	afx_msg void OnClear();
	afx_msg void OnMENUUSBSelect();
	afx_msg void OnMENUCOMSelect();
	afx_msg LRESULT OnUpdateUI(WPARAM wParam, LPARAM lParam);
	afx_msg void OnSelchangeCOMBOCom();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void ChangeSize(UINT nID, int x, int y);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	
	//int m_iEncrpt;
	CString m_strCOM;
	int m_iBrdRt;
	int m_iParity;
	int m_iDataBits;
	int m_iStopBits;
	int m_iInjectCount;
	CString		StrBuff;
	CString		StrScriptCommand;



//	RS232 m_RS232;
	CUsb	m_USB;
	CProtocolManager m_protocolMgr;
	BOOL		MakeCommand(CString& strCmd, PBYTE bysCmd, int* pcbCmd);
	BYTE		Char2Hex(char ch);	
	int  FileOpen();
	int  ExtractData();
	void ScriptData();

	bool SendCommandRequest(byte* datapool, int outLength);
	void CheckReaderConnection(void);
	void SetButtonState(bool b_state);
	void OnInitMenuPopup(CMenu *pPopupMenu, UINT nIndex,BOOL bSysMenu);
	/**************************************************/

	//unsigned char * GetXOR(const byte* key1,CString  key2,int  i);
	//unsigned char * GetXOR(const byte *key1, CString key2, int k,int iEncryptionMethod);
	
	//CString GetKeyCheckValue(CString key,int iEncrpt);
	CRect  m_rect; 
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_KEYINJECTMODULEDLG_H__3914DC51_90F3_43B5_8646_8EDBCAFF4862__INCLUDED_)
