// [=====================================================================]

//    Class Name:  CProtocolManager     Last Modified:  
//    Author:							First Working:  
		
// [=====================================================================]
// [  Maintenance Record                                                 ]
// [---------------------------------------------------------------------]
//    Date         Version        Author                   Description
//	  09/07/2006	  1.0.6		  
// [=====================================================================]

#include "stdafx.h"
#include "protocolManager.h"
#include "Utilities.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

byte keyNumber,dataCRC,protoCRC;
byte lastProtocol[60] ;
byte toBase64[40];
byte fromBase64[50];


/////////////////////////////////////////////////////////////////////////////
// CProtocolManager

CProtocolManager::CProtocolManager()
{
}

CProtocolManager::~CProtocolManager()
{
}


BEGIN_MESSAGE_MAP(CProtocolManager, CWnd)
	//{{AFX_MSG_MAP(CProtocolManager)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CProtocolManager message handlers



void CProtocolManager::getInjectData(int iProtocol, int iEncryption, byte *bpRawKey,byte *bpData, int *ipLength)
{
	switch(iProtocol)
	{
	case SYMBOL:
		 InjectSymbol(iEncryption,bpRawKey,bpData,ipLength);
		break;
	case VISA:
		 InjectVisa (iEncryption,bpRawKey,bpData,ipLength);
		break;
	default:
		break;
	}
}

int CProtocolManager::validateInject_Symbol(byte *bpResponse,byte* bpCKV)
{
	int iInjectReponseLength = 15;
	int iERROR = 29;		// uncatagorized error
	byte* bpDetect=NULL;
	byte* bpTemp;
	bpDetect = (byte*)malloc(sizeof(byte)*(iInjectReponseLength));
	bpTemp    = (byte*)malloc(sizeof(byte)*(6));

	byte decoded[11];
	


	for ( int index = 0;index < iInjectReponseLength; index ++)
	{
		*(bpDetect+index) = *(bpResponse+index+4);

	}

	from64tobits(decoded, (char*)bpDetect, iInjectReponseLength); 
	
	int count = 0;
	int len = 3;

	Hex_Ascii (bpCKV,bpTemp,&len);

	for(int i=0;i<6;i++)
	{
		if(decoded[3+i]==*(bpTemp+i))
			count++;
	}
	
    free(bpDetect);
	free(bpTemp);

	if((count==6)&&(decoded[1]==0x00)) 
		return 0;
	else 
		return iERROR;	

}

void CProtocolManager::InjectSymbol(int iEncryption, byte* bpRawKey,byte* bpSProtocol, int* ipLength)
{
	byte* bpSEncode;
	byte* bpSEncoded;
	byte* bpTemp;

	int iEncodedLen = getEncodedLength((*ipLength)*2+5);

	bpSEncode =	(byte*) malloc((sizeof(byte))*((*ipLength)*2+5+10));
	bpSEncoded = (byte*) malloc((sizeof(byte))*(iEncodedLen+10));
	bpTemp    = (byte*) malloc((sizeof(byte))*((*ipLength)*2+10));


	*bpSEncode = 0xff;
	*(bpSEncode+1) = 0x0A;
	if(*ipLength == 16)
		*(bpSEncode+2) = 0x21;
	if(*ipLength == 8)
		*(bpSEncode+2) = 0x11;


	switch(iEncryption)
	{
	case KT_DES_MS:
		*(bpSEncode+3) = 0x00;
		break;
	case KT_TDES_MS:
		*(bpSEncode+3) = 0x28;
		break;
	case KT_DES_DUKPT_KSN:
		*(bpSEncode+3) = 0x0f;
		break;
	case KT_DES_DUKPT_IK:
		*(bpSEncode+3) = 0x10;
		break;
	case KT_TDES_DUKPT_KSN:
		*(bpSEncode+3) = 0x32;//0x37;
		break;
	case KT_TDES_DUKPT_IK:
		*(bpSEncode+3) = 0x33;//0x38;
		break;

	}

	Hex_Ascii (bpRawKey,bpTemp,ipLength);
	
	for(int loop=0;loop<(*ipLength)*2;loop++)
	{
		*(bpSEncode+4+loop) = *(bpTemp+loop);

	}


//get CRC
	*(bpSEncode+((*ipLength)*2)+4) = getsCRC(bpSEncode,0x00,(*ipLength)*2+4);
//get encoded
	to64frombits(bpSEncoded,(unsigned char* )bpSEncode,((*ipLength)*2+5));

	*bpSProtocol = 0x02;
	*(bpSProtocol+1) = 0x46;
	*(bpSProtocol+2) = 0x46;

	for ( int loops = 0;loops<iEncodedLen;loops++)
	{
			*(bpSProtocol+3+loops) = *(bpSEncoded+loops);
			if(*(bpSEncoded+loops) == 0x00)
				break;
	}

	*(bpSProtocol+iEncodedLen+3) = 0x0D;
	*(bpSProtocol+iEncodedLen+4) = 0x0A;
	*(bpSProtocol+iEncodedLen+5) = 0x03;

//getCRC
    *(bpSProtocol+iEncodedLen+6) = getsCRC(bpSProtocol,0x02,iEncodedLen+6);

	*ipLength = iEncodedLen+7;
	
	free(bpSEncode); 
	free(bpSEncoded);
	free(bpTemp);
}

void CProtocolManager::InjectVisa(int iEncryption, byte *bpRawKey,byte *bpSProtocol, int *ipLength)
{
	//empty body
}
	

int CProtocolManager::getEncodedLength(int EncodeLength)
{
	int modulas = EncodeLength % 3;
	if(modulas == 0)
		return (EncodeLength/3)*4;
	else
		return ((EncodeLength/3)+1)*4;	
}

void CProtocolManager::getStatusData(byte* bpData,int iProtocol, int *ipLength)
{
		
	switch(iProtocol)
	{
	case SYMBOL:
		 StatusSymbol(bpData,ipLength);
		break;
	case VISA:
		 StatusVisa (bpData,ipLength);
		break;
	default:
		break;
	}
}

void CProtocolManager::StatusSymbol(byte* bpSProtocol,int *ipLength)
{
	byte* bpSEncode;
	byte* bpSEncoded;

	int iEncodedLen = getEncodedLength((*ipLength)*2+5);
	bpSEncode =	(byte*) malloc((sizeof(byte))*((*ipLength)*2+5)+10);
	bpSEncoded = (byte*) malloc((sizeof(byte))*(iEncodedLen + 10));

	*bpSEncode = 0xff;
	*(bpSEncode+1) = 0x13;
	*(bpSEncode+2) = 0x01;
	*(bpSEncode+3) = 0x02;
//getCRC

	*(bpSEncode+(*ipLength)+4) = getsCRC (bpSEncode,0x00,(*ipLength)*2+4); 

//get encoded
	to64frombits(bpSEncoded,(unsigned char* )bpSEncode,((*ipLength)*2+5));

	*bpSProtocol = 0x02;
	*(bpSProtocol+1) = 0x46;
	*(bpSProtocol+2) = 0x46;
	for ( int loops = 0;loops<iEncodedLen;loops++)
	{
			*(bpSProtocol+3+loops) = *(bpSEncoded+loops);
			if(*(bpSEncoded+loops) == 0x00)
				break;
	}

	*(bpSProtocol+iEncodedLen+3) = 0x0D;
	*(bpSProtocol+iEncodedLen+4) = 0x0A;
	*(bpSProtocol+iEncodedLen+5) = 0x03;

//getCRC
	*(bpSProtocol+iEncodedLen+6) = getsCRC(bpSProtocol,0x02,iEncodedLen+6);

	if(bpSEncode !=NULL)
	free(bpSEncode); 
	if(bpSEncoded !=NULL)
	free(bpSEncoded);

	*ipLength = iEncodedLen+7;

}

void CProtocolManager::StatusVisa(byte* bpSProtocol,int *ipLength)
{
	//empty body
}

int CProtocolManager::validateStatus_Symbol(byte *bpResponse)
{
	byte* bpDetect=NULL;

	int iStatusReponseLength = 7;
	int iERROR = 29; // uncatagorized error
	bpDetect = (byte*)malloc(sizeof(byte)*(4+10));
	
	
	byte decoded[5];
	

	for ( int index = 0;index < iStatusReponseLength; index ++)
	{
		*(bpDetect+index) = *(bpResponse+index+4);

	}
	from64tobits(decoded, (char*)bpDetect, iStatusReponseLength); 
	
	
	free(bpDetect);
	if(decoded[1]==0x00) 
		return 0;
	else 
		return iERROR;
		
}

byte CProtocolManager::getsCRC(byte *bpData, byte bKey, int iLen)
{
	byte CRC = 0;
	 for (int i = 0 ;i < iLen ; i++)
	 {
	  CRC = CRC  ^*(bpData+i);
	 }
	return CRC ^ bKey;


}

int CProtocolManager::validateInject_Visa(byte *bpResponse, byte *bpCKV)
{
	return 1;

}

int CProtocolManager::validateInject(int iProtocol, byte *bpResponse, byte *bpCKV)
{
	int iVal;
	
	switch(iProtocol)
	{
	case SYMBOL:
		iVal = validateInject_Symbol(bpResponse,bpCKV);
		break;
	case VISA:
		iVal = validateInject_Visa (bpResponse,bpCKV);
		break;
	default:
		break;
	}
 return iVal;


}

int CProtocolManager::validateStatus_Visa(byte *bpResponse)
{
	return 1;

}

int CProtocolManager::validateStatus(int iProtocol, byte *bpResponse)
{
	int iValidateVal;
	
	switch (iProtocol)
	{
	case SYMBOL:
		iValidateVal = validateStatus_Symbol(bpResponse);
		break;
	case VISA:
		iValidateVal = validateStatus_Visa (bpResponse);
		break;
	default:
		break;
	}
 return iValidateVal;

}

void CProtocolManager::getKSNData(int iProtocol, int iEncryption, byte *bpRawKey, byte *bpSProtocol,int* ipLength)
{
	switch(iProtocol)
	{
	case SYMBOL:
		 KSNSymbol(iEncryption,bpRawKey,bpSProtocol,ipLength);
		break;
	case VISA:
		 KSNVisa (iEncryption,bpRawKey,bpSProtocol,ipLength);
		break;
	default:
		break;
	}


}

void CProtocolManager::KSNSymbol(int iEncryption,byte* bpRawKey,byte* bpSProtocol,int* ipLength)
{
	
	byte* bpSEncode;
	byte* bpSEncoded;
	byte* bpTemp;

	int iEncodedLen = getEncodedLength((*ipLength)*2+5);

	bpSEncode =	(byte*) malloc((sizeof(byte))*((*ipLength)*2+5+10));
	bpSEncoded = (byte*) malloc((sizeof(byte))*(iEncodedLen+10));
	bpTemp    = (byte*) malloc((sizeof(byte))*((*ipLength)*2+10));


	*bpSEncode = 0xff;
	*(bpSEncode+1) = 0x0A;
	*(bpSEncode+2) = 0x11;

	switch(iEncryption)
	{
	case KT_DES_DUKPT_KSN:
		*(bpSEncode+3) = 0x0f;
		break;
	
	case KT_TDES_DUKPT_KSN:
		*(bpSEncode+3) = 0x32;//0x37;
		break;
	}

	Hex_Ascii (bpRawKey,bpTemp,ipLength);
	
	for(int loop=0;loop<(*ipLength)*2;loop++)
	{
		*(bpSEncode+4+loop) = *(bpTemp+loop);

	}


//getCRC

	*(bpSEncode+((*ipLength)*2)+4) = getsCRC(bpSEncode,0x00,(*ipLength)*2+4);

//get encoded
	to64frombits(bpSEncoded,(unsigned char* )bpSEncode,((*ipLength)*2+5));

	*bpSProtocol = 0x02;
	*(bpSProtocol+1) = 0x46;
	*(bpSProtocol+2) = 0x46;

	for ( int loops = 0;loops<iEncodedLen;loops++)
	{
			*(bpSProtocol+3+loops) = *(bpSEncoded+loops);
			if(*(bpSEncoded+loops) == 0x00)
				break;
	}

	*(bpSProtocol+iEncodedLen+3) = 0x0D;
	*(bpSProtocol+iEncodedLen+4) = 0x0A;
	*(bpSProtocol+iEncodedLen+5) = 0x03;

//getCRC
    *(bpSProtocol+iEncodedLen+6) = getsCRC(bpSProtocol,0x02,iEncodedLen+6);

	*ipLength = iEncodedLen+7;
	
	free(bpSEncode); 
	free(bpSEncoded);

}

void CProtocolManager::KSNVisa(int iEncryption,byte* bpRawKey,byte* bpSProtocol,int* ipLength)
{
	//empty body
}

void CProtocolManager::Hex_Ascii(byte *pBHex, byte *pBAscii, int *ipLen)
{
	CString strCheckVal;
	CString strTemp;
	int itemp;

	for(int k=0;k<*(ipLen);k++)
	{
		strTemp.Format("%.2x",*(pBHex+k));
		strCheckVal+= strTemp;
	}

	strCheckVal.MakeUpper ();
	for(int i=0;i<*(ipLen)*2;i++)
	{
		itemp = (int)strCheckVal.GetAt(i);
		*(pBAscii+i) = itemp;
	}
}
