/******************************************************
 *
 * serialconn.cpp : implement CONNECTOR inteface for Contactless Smart Card Reader serial port .
 * name : serialconn.cpp
 * longny yu
 * 2006.5.11
 * version 1.0
 *  
 ******************************************************/

#include "stdafx.h"
#include "serialconn.h"

///////////////////////////////////////////////////////////////////////////////

CSerial::CSerial()
{
	strcpy(cmdsettings, "baud=9600 parity=N data=8 stop=1");

	comm= NULL;
	usrInt = FALSE;
	isOpened = FALSE;
}
CSerial::~CSerial()
{
}
/*--------------------------------------------------
 * Function (api): _Open
 *
 * [In]		 pszName,the device name 
 *			 for example: com1/baud=1200/parity=N/data=8/stop=1
 *
 * [Out]
 *
 * Description:	Open RS232 port.
 *
 *---------------------------------------------------*/

int CSerial::Open(const char* pszName)
{	
	if(isOpened)
		return FALSE;
	if(NULL == pszName) 
		return FALSE;
	int sl = strlen(pszName);
	if(sl < 10 || sl > 256 )
		return FALSE;	
	char nm[256];
	char port[256];
	char * s = nm;
	char * c = (char*)pszName;	
	while(*c) 
	{
		if(*c == ' ' || *c == '\t')
		{
			c++;
			continue;
		}
		*s = *c++;
		if( *s == '/')
			*s = ' ';
		*s++;
	}
	*s = 0;
	c = nm;
	s = port;
	while(*c != ' ' && *c != 0) *s++ = *c++;
	*s = 0;
	strcpy(settings, ++c);
	DCB dcb;	
	comm = CreateFile(port,
						GENERIC_READ|GENERIC_WRITE, 
						0, 
						0, 
						OPEN_EXISTING,
						0,//FILE_FLAG_OVERLAPPED, 
						NULL);
	if(comm == INVALID_HANDLE_VALUE)
	{		
		goto IRETF;
	}	
	//
	if(!GetCommState(comm, &dcb))
	{		
		goto IRETF;
	}	
	if(!BuildCommDCB(settings, &dcb))
	{		
		goto IRETF;
	}
	dcb.fParity = 0;
  	dcb.fOutxCtsFlow = 0 ;
  	dcb.fOutxDsrFlow = 0 ;
  	dcb.fDtrControl = 1 ;
  	dcb.fDsrSensitivity = 0 ;
  	dcb.fTXContinueOnXoff = 0;
  	dcb.fOutX = 0;
  	dcb.fInX = 0;
  	dcb.fErrorChar = 0;
  	dcb.fNull = 0 ;
  	dcb.fRtsControl = 1;// = RTS_CONTROL_DISABLE;
 	dcb.fAbortOnError = 0; 	
	if(!SetCommState(comm, &dcb))
	{		
		goto IRETF;
	}
	SetupComm(comm,4096,4096);
	//set time outs
	COMMTIMEOUTS commTimeouts;
/*	commTimeouts.ReadIntervalTimeout = 55;
	commTimeouts.ReadTotalTimeoutMultiplier = 100;
	commTimeouts.ReadTotalTimeoutConstant = 0;
	commTimeouts.WriteTotalTimeoutMultiplier = 0;
	commTimeouts.WriteTotalTimeoutConstant = 0;*/
	commTimeouts.ReadIntervalTimeout = 20;
	commTimeouts.ReadTotalTimeoutMultiplier = 0;
	commTimeouts.ReadTotalTimeoutConstant = 200;
	commTimeouts.WriteTotalTimeoutMultiplier = 0;
	commTimeouts.WriteTotalTimeoutConstant = 0;
	// configure
	if (!SetCommTimeouts(comm, &commTimeouts))	
	{		
		goto IRETF;
	}
	//
	PurgeComm(comm, PURGE_RXCLEAR | PURGE_TXCLEAR | PURGE_RXABORT | PURGE_TXABORT);	
	
	
	evtr=CreateEvent(NULL, TRUE, FALSE, NULL);
	if( evtr == NULL) 
		goto IRETF;
	
	usrInt = FALSE;
	return isOpened = TRUE;

IRETF:
	CloseHandle(comm);
	return isOpened = FALSE;
}
int CSerial::OverlappedOpen(const char* pszName)
{	
	if(isOpened)
		return FALSE;
	if(NULL == pszName) 
		return FALSE;
	int sl = strlen(pszName);
	if(sl < 10 || sl > 256 )
		return FALSE;	
	char nm[256];
	char port[256];
	char * s = nm;
	char * c = (char*)pszName;	
	while(*c) 
	{
		if(*c == ' ' || *c == '\t')
		{
			c++;
			continue;
		}
		*s = *c++;
		if( *s == '/')
			*s = ' ';
		*s++;
	}
	*s = 0;
	c = nm;
	s = port;
	while(*c != ' ' && *c != 0) *s++ = *c++;
	*s = 0;
	strcpy(settings, ++c);
	DCB dcb;	
	comm = CreateFile(port,
						GENERIC_READ|GENERIC_WRITE, 
						0, 
						0, 
						OPEN_EXISTING,
						FILE_FLAG_OVERLAPPED, 
						NULL);
	if(comm == INVALID_HANDLE_VALUE)
	{		
		goto IRETF;
	}	
	//
	if(!GetCommState(comm, &dcb))
	{		
		goto IRETF;
	}	
	if(!BuildCommDCB(settings, &dcb))
	{		
		goto IRETF;
	}
	dcb.fParity = 0;
  	dcb.fOutxCtsFlow = 0 ;
  	dcb.fOutxDsrFlow = 0 ;
  	dcb.fDtrControl = 1 ;
  	dcb.fDsrSensitivity = 0 ;
  	dcb.fTXContinueOnXoff = 0;
  	dcb.fOutX = 0;
  	dcb.fInX = 0;
  	dcb.fErrorChar = 0;
  	dcb.fNull = 0 ;
  	dcb.fRtsControl = 1;// = RTS_CONTROL_DISABLE;
 	dcb.fAbortOnError = 0; 	
	if(!SetCommState(comm, &dcb))
	{		
		goto IRETF;
	}
	SetupComm(comm,4096,4096);
	//set time outs
	COMMTIMEOUTS commTimeouts;
/*	commTimeouts.ReadIntervalTimeout = 55;
	commTimeouts.ReadTotalTimeoutMultiplier = 100;
	commTimeouts.ReadTotalTimeoutConstant = 0;
	commTimeouts.WriteTotalTimeoutMultiplier = 0;
	commTimeouts.WriteTotalTimeoutConstant = 0;*/
	commTimeouts.ReadIntervalTimeout = 20;
	commTimeouts.ReadTotalTimeoutMultiplier = 0;
	commTimeouts.ReadTotalTimeoutConstant = 200;
	commTimeouts.WriteTotalTimeoutMultiplier = 0;
	commTimeouts.WriteTotalTimeoutConstant = 0;
	// configure
	if (!SetCommTimeouts(comm, &commTimeouts))	
	{		
		goto IRETF;
	}
	//
	PurgeComm(comm, PURGE_RXCLEAR | PURGE_TXCLEAR | PURGE_RXABORT | PURGE_TXABORT);	
	
	
	evtr=CreateEvent(NULL, TRUE, FALSE, NULL);
	if( evtr == NULL) 
		goto IRETF;
	
	usrInt = FALSE;
	return isOpened = TRUE;

IRETF:
	CloseHandle(comm);
	return isOpened = FALSE;
}
/*--------------------------------------------------
 * Function (api): _Close
 *
 * [In]		None
 *
 * [Out]	None
 *
 * Description:	Close RS232 port.
 *
 *---------------------------------------------------*/
void CSerial::Close()
{	
	CloseHandle(comm);
	comm = NULL;
	CloseHandle(evtr);
	evtr = NULL;
	isOpened = FALSE;
}

unsigned int CSerial::Read(unsigned char * pBuf, unsigned int iLim, long lTimeout)
{	
	DWORD rcvd=0;
	unsigned char rec[512];
	DWORD length = 0;
	RS232lock.Lock();
	do
	{
		length = 0;
		
		if(ReadFile(comm, rec , 512 , &length, NULL)== FALSE)
		{
			return -1;
		}
		if(length == 1 && rec[0] != 0x03 && rcvd == 0)
		{
			*pBuf++ = rec[0];		
			rcvd = length;
			return rcvd;
		}
		rcvd += length;
		if(rcvd > iLim)
		{
			rcvd -= length;	
			return rcvd;
		}
		for(DWORD i = 0; i < length; i++)
			*pBuf++ = rec[i];
		
	}while(length > 0);
	RS232lock.Unlock();
	return rcvd; //if use Line 107 to line lll
/*	DWORD rcvd=0;
	if(ReadFile(comm, pBuf , iLim , &rcvd, NULL)== FALSE)
	{
		return -1;
	}
	
	return rcvd;*/
}
unsigned int CSerial::OverlappedRead(unsigned char * pBuf, unsigned int iLim, long lTimeout)
{	
	DWORD rcvd=0;
	unsigned char rec[512];
	DWORD length = 0;

	do
	{
		length = 0;
		
		if(ReadFile(comm, rec, 512, &length, NULL)==FALSE)
		{
			return -1;
		}
		if(length == 1 && rec[0] != 0x03 && rcvd == 0)
		{
			*pBuf++ = rec[0];		
			rcvd = length;
			return rcvd;
		}
		rcvd += length;
		if(rcvd > iLim)
		{
			rcvd -= length;	
			return rcvd;
		}
		for(DWORD i = 0; i < length; i++)
			*pBuf++ = rec[i];
		
	}while(length > 0);
//	rcvd = length;
	return rcvd;
}

int CSerial::ReadPoint(unsigned char * pBuf, int iLim, long lTimeout)
{	
	DWORD rcvd=0;
	if(ReadFile(comm, pBuf , iLim , &rcvd, NULL)== FALSE)
	{
		return -1;
	}
	
	return rcvd;
}

int CSerial::Write(unsigned char *pbuf, unsigned int iLen, long lTimeout)
{
	DWORD sc=0;

	if(!WriteFile(comm, pbuf, iLen, &sc, NULL)) {
		return 0;	
	}

	return sc;
}

bool CSerial::BuldBaud(int baud)
{	
	DWORD   DCB_Baud;
	DCB NewDCB;	
	switch(baud)
	{
	case 0x01:
		DCB_Baud = CBR_1200;
		break;
	case 0x02:
		DCB_Baud = CBR_2400;
		break;
	case 0x03:
		DCB_Baud = CBR_4800;
		break;
	case 0x04:
		DCB_Baud = CBR_9600;
		break;
	case 0x05:
		DCB_Baud = CBR_14400;
		break;
	case 0x06:
		DCB_Baud = CBR_19200;
		break;
	case 0x07:
		DCB_Baud = CBR_38400;
		break;
	case 0x08:
		DCB_Baud = CBR_57600;
		break;
	case 0x09:
		DCB_Baud = CBR_115200;
		break;
	default:
		return 0;
	}
	if(!GetCommState(comm, &NewDCB))
	{
		return 0;
	}		
	NewDCB.BaudRate = DCB_Baud;		// Fill in the DCB structure with required settings
  	NewDCB.fParity = 0;
  	NewDCB.fOutxCtsFlow = 0;
  	NewDCB.fOutxDsrFlow = 0;
  	NewDCB.fDtrControl = DTR_CONTROL_DISABLE;
  	NewDCB.fDsrSensitivity = FALSE;
  	NewDCB.fTXContinueOnXoff = 0;
  	NewDCB.fOutX = 0;
  	NewDCB.fInX = 0;
  	NewDCB.fErrorChar = 0;
  	NewDCB.fNull = 0;
  	NewDCB.fRtsControl = RTS_CONTROL_DISABLE;
 	NewDCB.fAbortOnError = 0;
  	NewDCB.ByteSize = 8;
  	NewDCB.Parity = NOPARITY;
  	NewDCB.StopBits = ONESTOPBIT;	
	if(!SetCommState(comm, &NewDCB))
	{
		return 0;
	}
	return 1;

}

BOOL CSerial::IsOpened()
{
	return isOpened;
}
