// [=====================================================================]

//    Class Name:  CKeyInjectModuleDlg      Last Modified:  
//    Author: P.Rathnayake					First Working:  

//    Description:  This class holds ,process and call sub routings to carry out
//    all the tasks of the application.The folowong sub routing are functioning as specified

//	  GetKeyCheckValue - returns the check value for a given key
//	  GetXOR - returns the xored value  for given key parts
//	  SetDes - carry out the validation  and prepare the Key to be injected for DES
//	  SetTdes - carry out the validation  and prepare the Key to be injected for TDES

// [=====================================================================]
// [  Maintenance Record                                               ]
// [-------------------------------------------------------------------]
//    Date         Version        Author                   Description
//    22/05/2006	  1.0.1		  P.Rathnayake		       Code cleanup
//	  04/06/2006	  1.0.2		  P.Rathnayake			   Code cleanup
// [=====================================================================]


#include "stdafx.h"
#include "KeyInjectModule.h"
#include "KeyInjectModuleDlg.h"
#include "RS232.h"
#include "MSRItfUSBHID.h"
#include "DUKPT.h"
#include "DES.h"
#include "AesCipher.h"
#include "Thread.h"
#include <time.h>
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
void EnumerateSerialPorts(CUIntArray& ports);	//get com value
void ParseResponseByteToCstring(CString& strResponse1,BYTE* strIn,int ulMyRetLen);

#define SETTINGS "\\\\.\\COM%c/baud=%d/parity=%c/stop=%d/data=%d"
char settings[128];

CString StrInitialKey = "0123456789ABCDEFFEDCBA9876543210";
CString StrIDTECH_IIN = "629949";
CString StrReaderStatus = "SecuRED MSR Swipe Reader!";
int k=0,j=0;
CEvent m_Event;
CString StrResponse;
const TCHAR CR[] = {13, 0};
BYTE WResp;

BYTE glm_nksn[10];
BOOL bIK = false;
BOOL bUpdateDisplay = false;
BOOL bChecked = false;
CString StrHID_Data;
BYTE HID_Data[2048];
int HID_Data_Length;

CString StrUSBKB;
int USBKB_Data_Length;
BYTE USBKB_Data[100];

BYTE CardDataBuffer[8192];
int ResponseLength = 0;
ULONG BufferLength;
int TypeKey;
int EncodingType;
int nReader;
int OpenDev=0;
int length1=0;
int length2=0;
int length3=0;
int type13=0;
int type0=0;
int type4=0;
int length5=0;
int  start=0;
int openstart=false;
int openstart1=false;
/**************************************************/
BYTE challenge[16];
BYTE KSNglb[10];
bool bActivation = false;
/**************************************************/
CString StrKSN;
CString	StrDID;
const int LEN_SIXTEEN = 16;
const int LEN_THIRTYTWO	=32; 

int select_mode=0; // 1 usb , 2 com
BOOL sWaitReadCmd =false;
BOOL bDecrypted = false;
unsigned long PreDecrypCounter;	// for decryption, to avoid calculate cryptokey from 0 for every decrypt process
unsigned char PreDecryptKSN[10];// for decryption, to avoid calculate cryptokey from 0 for every decrypt process
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();
	
	// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUT };
	//}}AFX_DATA
	
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
	
	// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
//{{AFX_MSG_MAP(CAboutDlg)
// No message handlers
//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CKeyInjectModuleDlg dialog

CKeyInjectModuleDlg::CKeyInjectModuleDlg(CWnd* pParent /*=NULL*/)
: CDialog(CKeyInjectModuleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CKeyInjectModuleDlg)
	m_NoOfKeyPart = _T("2");
	m_Encrypt = _T("DES");
	m_strNumDevices = _T("1");
	m_imethod = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CKeyInjectModuleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CKeyInjectModuleDlg)
	DDX_CBString(pDX, IDC_NO_OF_KEY_PARTS, m_NoOfKeyPart);
	DDX_CBString(pDX, IDC_ENCPT, m_Encrypt);
	DDX_Text(pDX, IDC_NUM_DEVICES, m_strNumDevices);
	DDV_MaxChars(pDX, m_strNumDevices, 6);
	DDX_CBIndex(pDX, IDC_METHOD, m_imethod);
	DDX_Control(pDX,IDC_COMBO_Com,com_combobox);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CKeyInjectModuleDlg, CDialog)
//{{AFX_MSG_MAP(CKeyInjectModuleDlg)
ON_WM_PAINT()
ON_WM_QUERYDRAGICON()
ON_CBN_EDITCHANGE(IDC_NO_OF_KEY_PARTS, OnEditchangeNoOfKeyParts)
ON_BN_CLICKED(IDC_INJECT_KEY, OnInjectKey)
ON_BN_CLICKED(IDC_INJECT, OnInject)
ON_BN_CLICKED(IDC_EXIT, OnExit)
ON_BN_CLICKED(IDC_CANCEL_DEBIT, OnCancelDebit)
ON_BN_CLICKED(IDC_SEND, OnSend)
ON_BN_CLICKED(IDC_SCRIPT, OnDecrypt)
ON_BN_CLICKED(IDC_INPUT_KEY, OnInputKey)
ON_COMMAND(ID_MENU_SetDefault, OnMENUSetDefault)
ON_COMMAND(ID_MENU_ReadConfiguration, OnMENUReadConfiguration)
ON_COMMAND(ID_MENU_ReadFirmware, OnMENUReadFirmware)
ON_COMMAND(ID_MENU_BeeperOff, OnMENUBeeperOff)
ON_COMMAND(ID_MENU_BeeperLow, OnMENUBeeperLow)
ON_COMMAND(ID_MENU_BeeperHigh, OnMENUBeeperHigh)
ON_COMMAND(ID_MENU_ReadBothDirections, OnMENUReadBothDirections)
ON_COMMAND(ID_MENU_ReadForwardDirection, OnMENUReadForwardDirection)
ON_COMMAND(ID_MENU_ReadBackwardDirection, OnMENUReadBackwardDirection)
ON_COMMAND(ID_MENU_ReadAnyTracks, OnMENUReadAnyTracks)
ON_COMMAND(ID_MENU_ReadTrack1, OnMENUReadTrack1)
ON_COMMAND(ID_MENU_ReadTrack2, OnMENUReadTrack2)
ON_COMMAND(ID_MENU_ReadTrack12, OnMENUReadTrack12)
ON_COMMAND(ID_MENU_ReadTrack3, OnMENUReadTrack3)
ON_COMMAND(ID_MENU_ReadTrack13, OnMENUReadTrack13)
ON_COMMAND(ID_MENU_ReadTrack23, OnMENUReadTrack23)
ON_COMMAND(ID_MENU_ReadAllTracks, OnMENUReadAllTracks)
ON_COMMAND(ID_MENU_SendTrackSeparator, OnMENUSendTrackSeparator)
ON_COMMAND(ID_MENU_NotSendTrackSeparator, OnMENUNotSendTrackSeparator)
ON_COMMAND(ID_MENU_SendTerminator, OnMENUSendTerminator)
ON_COMMAND(ID_MENU_NotSendTerminator, OnMENUNotSendTerminator)
ON_COMMAND(ID_MENU_About, OnMENUAbout)
ON_WM_TIMER()
ON_COMMAND(ID_MENU_TDES, OnMenuTdes)
ON_COMMAND(ID_MENU_AES, OnMenuAes)
ON_COMMAND(ID_MENU_SetPrePANClrDataID, OnMENUSetPrePANClrDataID)
ON_COMMAND(ID_MENU_SetPostPANClrDataID, OnMENUSetPostPANClrDataID)
ON_COMMAND(ID_MENU_SetMaskCharID, OnMENUSetMaskCharID)
ON_COMMAND(EnableLRCID, OnEnableLRCID)
ON_COMMAND(DisableLRCID, OnDisableLRCID)
ON_COMMAND(RawDataID, OnRawDataID)
ON_COMMAND(MSREnableID, OnMSREnableID)
ON_COMMAND(MSRDisableID, OnMSRDisableID)
ON_COMMAND(EnterBootloaderModeID, OnEnterBootloaderModeID)
ON_COMMAND(SecurityLevID, OnSecurityLevID)
ON_COMMAND(WSEErrorNotificationID, OnWSEErrorNotificationID)
ON_COMMAND(WoSEAllT2ErrorNotification, OnWoSEAllT2ErrorNotification)
ON_COMMAND(WSEPartialT2ErrorNotification, OnWSEPartialT2ErrorNotification)
ON_COMMAND(SetPreamble0123456789ID, OnSetPreamble0123456789ID)
ON_COMMAND(SetPostamble9876543210ID, OnSetPostamble9876543210ID)
ON_COMMAND(HIDMagTMode, OnHIDMagTMode)
ON_COMMAND(HIDIDTMode, OnHIDIDTMode)
ON_COMMAND(USBKBMode, OnUSBKBMode)
ON_COMMAND(ID_MENU_SetBufferMode, OnMENUSetBufferMode)
ON_COMMAND(ID_MENU_ATR, OnMenuAtr)
ON_COMMAND(ID_MENU_ReadBufferedData, OnMENUReadBufferedData)
ON_COMMAND(ID_MENU_SetPollingInterval, OnMENUSetPollingInterval)
ON_COMMAND(ID_MENU_SetArabia, OnMENUSetArabia)
ON_COMMAND(ID_MENU_SetUK, OnMENUSetUK)
ON_COMMAND(ID_MENU_SetUniversal, OnMENUSetUniversal)
ON_COMMAND(Setpollinginterval1, OnSetpollinginterval1)
ON_COMMAND(GetDeviceSN, OnGetDeviceSN)
ON_COMMAND(SetDeviceSN, OnSetDeviceSN)
ON_COMMAND(WSET2ErrornotificationAlt, OnWSET2ErrornotificationAlt)
ON_BN_CLICKED(IDC_ENTER_KEY, OnEnterKey)
ON_COMMAND(ID_MENU_SetSessionID, OnMENUSetSessionID)
ON_COMMAND(ID_MENU_ENABLEENCRYPTION, OnMenuEnableencryption)
ON_COMMAND(ID_MENU_DISABLEENCRYPTION, OnMenuDisableencryption)
	ON_BN_CLICKED(IDC_ACTAUTH, OnActivateAuthentication)
	ON_BN_CLICKED(IDC_ACTRPLY, OnActivateChallengeReply)
	ON_BN_CLICKED(IDC_DEACTRPLY, OnDeactivateChallengeReply)
	ON_BN_CLICKED(IDC_STATUS, OnGetReaderStatus)
	ON_COMMAND(ID_MENU_NewEncryptionFormat, OnMENUNewEncryptionFormat)
	ON_COMMAND(ID_MENU_OldEncryptionFormat, OnMENUOldEncryptionFormat)
	ON_COMMAND(ID_MENU_ForceEncryptAllTracks, OnMENUForceEncryptAllTracks)
	ON_BN_CLICKED(IDC_Clear, OnClear)
	ON_COMMAND(ID_MENU_USBSelect, OnMENUUSBSelect)
	ON_COMMAND(ID_MENU_COMSelect, OnMENUCOMSelect)
	 ON_MESSAGE(MSG_SET_TEXT, OnUpdateUI) 
	ON_CBN_SELCHANGE(IDC_COMBO_Com, OnSelchangeCOMBOCom)
ON_BN_CLICKED(IDC_CANCEL, OnCancel)
	 ON_WM_INITMENUPOPUP()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKeyInjectModuleDlg message handlers
// CKeyInjectModuleDlg message handlers
static UINT ThreadProc_numopen( LPVOID pParam )
{
	CKeyInjectModuleDlg* pthis = (CKeyInjectModuleDlg *)pParam;
	BYTE BufferTmp1[1024], BufferTmp2[1024];
	ULONG	BufferLength1 =1024, BufferLength2 = 1024;
	
	INTERFACE_TYPE emMyItfType; 
	ULONG emMyItfType1; 
	INTERFACE_TYPE emMyItfType2;
	CString strDevName;
	int		m_ulDevIndex = 0;
	emMyItfType1 = '1';
    while(openstart)
	{
		if(openstart1)
		{
		
			bool bConnected = false;

			if(select_mode == COM_MODE)//serial port mode 
			{

			}
			else if(select_mode == USB_MODE)
			{
				emMyItfType2 = ITF_TYPE_USB_HID;
				
				
				CMSRItfUSBHID	MSR(emMyItfType2);
				for(m_ulDevIndex = 0; m_ulDevIndex < 20; m_ulDevIndex++)
				{
					if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
					{
						
						if(emMyItfType != emMyItfType2)			
							continue;
						else
						{
							if(MSR.OpenMSRDevice(m_ulDevIndex))
							{					
								pthis->KBMode = 0; // USB HID
								//		GetDlgItem(IDC_SCRIPT)->ShowWindow(FALSE);
								bConnected = true;					
								OpenDev=1;
								if (!bChecked&&openstart1)
								{
									
									// SecureMag USB HID						
									StrReaderStatus = _T("SecuRED MSR USB HID Reader Connected ");
									
									//	OutputDebugString("thread2");
									
									const int outLength = 5;
									BYTE datapool[outLength];
									
									
									datapool[0] = 0x02;
									datapool[1] = 0x52;
									datapool[2] = 0x4C;
									datapool[3] = 0x03;
									datapool[4] = 0x1F;

									MSR.SendCommand(datapool, outLength, BufferTmp2, &BufferLength2);
									
								
										if (BufferTmp2[4] == 0x31)			// TDES
										{
											pthis->bDecryptMode = 1;
											StrReaderStatus += _T(" ( TDES Encryption Enabled )");
										}
										
										else if ( BufferTmp2[4] == 0x32)	// AES
										{
											pthis->bDecryptMode = 2;
											StrReaderStatus += _T(" ( AES Encryption Enabled )");
										}
									
									 Sleep(500);
									datapool[0] = 0x02;
									datapool[1] = 0x52;
									datapool[2] = 0x3E;
									datapool[3] = 0x03;
									datapool[4] = 0x6d;
									MSR.SendCommand(datapool, outLength, BufferTmp2, &BufferLength2);
									
									if(BufferLength2)
									{
										if (BufferTmp2[4] == 0x5a)			// TDES
											
											TypeKey = 1;
										
										
										else
										   TypeKey= 0;
										
									}
	
									bChecked = true;
									break;
								}
							}			
						}
					}
				}
				
			
				
				if (!bConnected)
				{
					MSR.CloseMSRDevice();
					bChecked = false;
					OpenDev=0;
					openstart1=1;
					StrReaderStatus = _T("Please Connect SecuRED MSR Swipe Reader!");
				}


				   pthis->GetDlgItem(IDC_Opendevice)->SetWindowText(StrReaderStatus);
				   if(bUpdateDisplay)
				   {
					   bUpdateDisplay = false;
					   pthis->Outputdata();
				   }
				   Sleep(300);
				  
			}
				

  }
  
}
return 0;
}
static UINT ThreadSPReadCard( LPVOID pParam )
{



	CKeyInjectModuleDlg* pthis = (CKeyInjectModuleDlg *)pParam;
	BYTE DataBuffer[1024];//, BufferTmp2[1024];
	int DataLength;//len;
	CString strResponse,StringTmp;
	int LastByte;
	CString str_com=L"";
//	CSerial sp_com = (CSerial)pthis->sp_com;

	while(1)
	{
		if(!sWaitReadCmd)
			{
				DataLength=pthis->sp_com.OverlappedRead(DataBuffer,1024,1000);

				if (DataLength>0)
				{

					for (int i=DataLength - 1; i>0; i--)		
					{
						if (DataBuffer[i] == 0x03)
							LastByte = i;
						else
							break;
					}
					
					
				//	HID_Data_Length = LastByte;
					HID_Data_Length = LastByte + 2; // for compat usb code 


					CString StrTemp="";
					CString StringTemp="";
					for(int ind=0;ind<=LastByte;ind++)
				    { 
						StringTemp.Format("%02X",DataBuffer[ind]);
						StrTemp+=StringTemp;
					}
					pthis->GetDlgItem(IDC_COMMAND)->SetWindowText(StrTemp);
									
				}
			}
			Sleep(200);
	}
	return 0;
}
BOOL CKeyInjectModuleDlg::OnInitDialog()
{
	
	CDialog::OnInitDialog();
	
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	//GetClientRect(&m_rect);  //ȡԻĴС

	SetDlgItemText(IDC_NO_OF_KEY_PARTS,"2");
	GetDlgItem(IDC_DEBIT_KEY)->ShowWindow(FALSE);
	GetDlgItem(IDC_INJECT_KEY)->ShowWindow(FALSE);
	((CComboBox*)GetDlgItem(IDC_ENCPT))->SetCurSel(1);
	//SetDlgItemText(IDC_ENCPT,"TDES");
	SetDlgItemText(IDC_METHOD,"DUKPT");
	
	GetDlgItem(IDC_CANCEL)->ShowWindow(FALSE);
	GetDlgItem(IDC_CANCEL_DEBIT)->ShowWindow(FALSE);
	//	GetDlgItem(IDC_COMMAND)->SetFocus();
	
	m_pMasterKey = (byte*)malloc(sizeof(byte) * 16);
	m_pMasterKcv = (byte*)malloc(sizeof(byte) * 3);
	
	m_pKsn = (byte*)malloc(sizeof(byte) * 10);	
	m_pKsnKcv = (byte*)malloc(sizeof(byte) * 3);
	
	m_pBdk = (byte*)malloc(sizeof(byte) * 16);
	m_pBdkKcv = (byte*)malloc(sizeof(byte) * 3);
	
	// Add the Menu 
	m_menu.LoadMenu(IDR_MENU);
	SetMenu(&m_menu);

	m_menu.EnableMenuItem(1,MF_BYPOSITION | MF_ENABLED | MF_GRAYED);
	m_menu.EnableMenuItem(2,MF_BYPOSITION | MF_ENABLED | MF_GRAYED);
	SetButtonState(false);
	// Timer interval = 500ms
	//m_Timer = SetTimer(1,500, 0); 
	openstart=true;
	openstart1=true;
	// Decryption
	bDecryptMode = 0; // No Encryption
//	AfxBeginThread(ThreadProc_numopen, this);
//	AfxBeginThread(ThreadSPReadCard, this);
	// USB HID
	KBMode = 0; 
	

	
	// Thread for reading track data
	CThread* pThread;
    pThread = new CThread();
    pThread->CreateThread();
    pThread->PostThreadMessage(WM_THREADMESSAGE,NULL,NULL);
	GetDlgItem(IDC_Opendevice)->SetWindowText(StrReaderStatus);
	m_des_index=1;

	CUIntArray ports;
	EnumerateSerialPorts(ports);
	for (int i=0; i<ports.GetSize(); i++)
	{
		CString str_com=L"";
		CString str=L"";
		str.Format(_T("%d"),ports.ElementAt(i));
		str_com=L"COM"+str;
		//(*(CComboBox)GetDlgItem(IDC_COMBO_SP))->AddString(str_com);
		com_combobox.AddString(str_com);
	}
	com_combobox.SetCurSel(0);

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CKeyInjectModuleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting
		
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);
		
		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;
		
		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CKeyInjectModuleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CKeyInjectModuleDlg::SetToHex(const byte *inBuff,  byte *outBuff,int iLen)
{
	
	int j=0;
	unsigned char* tempCh2 = NULL;
	tempCh2 = (unsigned char*)malloc(sizeof(BYTE)*3);
	for (int  i = 0 ; i < iLen/2 ;i++) 
	{
		memcpy(tempCh2,inBuff+i*2,2);
		*(tempCh2+2) = 0;
		j = static_cast<int>(strtol((char *)tempCh2,NULL, 16));
		*(outBuff + i)  = j;
	}
	free(tempCh2);
	
	
}

void CKeyInjectModuleDlg::OnEditchangeNoOfKeyParts() 
{
	//empty body	
}

void CKeyInjectModuleDlg::FreeMem(unsigned char *pCh)
{
	if(pCh !=NULL)
		free(pCh);
	pCh = NULL;
}

void CKeyInjectModuleDlg::CallInjector(int iencryption, int ikeyParts)
{
	
	switch(iencryption)
	{
	case ET_DES_MS:
		m_iCurrentOperation = ET_DES_MS;
		MasterDES(ikeyParts);
		break;
	case ET_TDES_MS:
		m_iCurrentOperation = ET_TDES_MS;
		MasterTDES (ikeyParts);
		break;
	case ET_DES_DUKPT:
		m_iCurrentOperation = ET_DES_DUKPT;
		DUKPT_DES (ikeyParts);
		break;
	case ET_TDES_DUKPT:
		m_iCurrentOperation = ET_TDES_DUKPT;
		DUKPT_TDES (ikeyParts);
		break;
	};
}

void CKeyInjectModuleDlg::Outputdata()
{
	CString StrTemp="";
	CString StringTemp="";
	for(int i=1;i<HID_Data_Length;i++)
    { 
		StringTemp.Format("%02X",HID_Data[i]);
		StrTemp+=StringTemp;
	}
	GetDlgItem(IDC_COMMAND)->SetWindowText(StrTemp);
}
void CKeyInjectModuleDlg::CheckReaderConnection()  
{
	bool bConnected = false;
	
	BYTE BufferTmp1[1024], BufferTmp2[1024];
	ULONG	BufferLength1 =1024, BufferLength2 = 1024;
	
	INTERFACE_TYPE emMyItfType; 
	ULONG emMyItfType1; 
	INTERFACE_TYPE emMyItfType2;
	CString strDevName;
	int		m_ulDevIndex = 0;
	emMyItfType1 = '1';
    if(start==0)
	{
		emMyItfType2 = ITF_TYPE_USB_HID;
		
		
		CMSRItfUSBHID	MSR(emMyItfType2);
		for(m_ulDevIndex = 0; m_ulDevIndex < 50; m_ulDevIndex++)
		{
			if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
			{
				if(emMyItfType!=0&&emMyItfType!=1&&emMyItfType!=2&&emMyItfType!=3&&emMyItfType!=4&&emMyItfType!=5)
					break;
				if(emMyItfType != emMyItfType2)			
					continue;
				else
				{
					if(MSR.OpenMSRDevice(m_ulDevIndex))
					{					
						KBMode = 0; // USB HID
						//		GetDlgItem(IDC_SCRIPT)->ShowWindow(FALSE);
						bConnected = true;					
						OpenDev=1;
						if (!bChecked)
						{
							
							// SecureMag USB HID						
							StrReaderStatus = _T("SecuRED MSR USB HID Reader Connected ");
							
							
							Sleep(300);
							
							const int outLength = 5;
							BYTE datapool[outLength];
							
							
							datapool[0] = 0x02;
							datapool[1] = 0x52;
							datapool[2] = 0x4C;
							datapool[3] = 0x03;
							datapool[4] = 0x1F;
							MSR.SendCommand(datapool, outLength, BufferTmp2, &BufferLength2);
							
							if(BufferLength2)
							{
								if (BufferTmp2[4] == 0x31)			// TDES
								{
									bDecryptMode = 1;
									StrReaderStatus += _T(" ( TDES Encryption Enabled )");
								}
								
								else if ( BufferTmp2[4] == 0x32)	// AES
								{
									bDecryptMode = 2;
									StrReaderStatus += _T(" ( AES Encryption Enabled )");
								}
							}
							Sleep(500);
							datapool[0] = 0x02;
							datapool[1] = 0x52;
							datapool[2] = 0x3E;
							datapool[3] = 0x03;
							datapool[4] = 0x6d;
							MSR.SendCommand(datapool, outLength, BufferTmp2, &BufferLength2);
							
							if(BufferLength2)
							{
								if (BufferTmp2[4] == 0x5a)			// TDES
									
									TypeKey = 1;
								
								
								else
									TypeKey= 0;
								
							   }
							
							
							bChecked = true;
							break;
						}
					}			
				}
			}
		}
		
		if(m_ulDevIndex >= 50){
			emMyItfType2 = ITF_TYPE_USB_HID_KB;
			
			CMSRItfUSBHID	MSR(emMyItfType2);
			for(m_ulDevIndex = 0; m_ulDevIndex < 50; m_ulDevIndex++)
			{
				if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
				{
					if(emMyItfType!=0&&emMyItfType!=1&&emMyItfType!=2&&emMyItfType!=3&&emMyItfType!=4&&emMyItfType!=5)
						break;
					if(emMyItfType != emMyItfType2)
						continue;
					else
					{
						if(MSR.OpenMSRDevice(m_ulDevIndex))
						{		
							KBMode = 1; // USB KB						
							bConnected = true;
							OpenDev=1;
							if (!bChecked)
							{						
								// SecureMag USB KB						
								StrReaderStatus = _T("SecuRED MSR USB KB Reader Connected ");
								
								Sleep(300);
								const int outLength = 5;
								BYTE datapool[outLength];
								
								
								
								datapool[0] = 0x02;
								datapool[1] = 0x52;
								datapool[2] = 0x4C;
								datapool[3] = 0x03;
								datapool[4] = 0x1F;
								MSR.SendCommand(datapool, outLength, BufferTmp2, &BufferLength2);
								
								if(BufferLength2)
								{
									if (BufferTmp2[4] == 0x31)			// TDES
									{
										bDecryptMode = 1;
										StrReaderStatus += _T(" ( TDES Encryption Enabled )");
									}
									
									else if ( BufferTmp2[4] == 0x32)	// AES
									{
										bDecryptMode = 2;
										StrReaderStatus += _T(" ( AES Encryption Enabled )");
									}
								}
									Sleep(500);
								datapool[0] = 0x02;
								datapool[1] = 0x52;
								datapool[2] = 0x3E;
								datapool[3] = 0x03;
								datapool[4] = 0x6d;
								MSR.SendCommand(datapool, outLength, BufferTmp2, &BufferLength2);
								
								if(BufferLength2)
								{
									if (BufferTmp2[4] == 0x5a)			// TDES
										
										TypeKey = 1;
									
									
									else
										TypeKey= 0;
									
							   }
								
								
								
								
								bChecked = true;
								break;
							}						
						}
					}
				}
			}		
		}
		
		if (!bConnected)
		{
			MSR.CloseMSRDevice();
				bChecked = false;
					OpenDev=0;
					openstart1=1;
			StrReaderStatus = _T("Please Connect SecuRED MSR Swipe Reader!");
		}
   }
   else{
	   
	   if(KBMode==0) 
	   {
		   emMyItfType2 = ITF_TYPE_USB_HID;
		   
		   
		   CMSRItfUSBHID	MSR(emMyItfType2);
		   for(m_ulDevIndex = 0; m_ulDevIndex < 50; m_ulDevIndex++)
		   {
			   if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
			   {
				   if(emMyItfType != emMyItfType2)			
					   continue;
				   else
				   {
					   if(MSR.OpenMSRDevice(m_ulDevIndex))
					   {					
						   KBMode = 0; // USB HID
						   //		GetDlgItem(IDC_SCRIPT)->ShowWindow(FALSE);
						   bConnected = true;
						   OpenDev=1;
						   if (!bChecked)
						   {
							   
							   // SecureMag USB HID						
							   StrReaderStatus = _T("SecuRED MSR USB HID Reader Connected ");
							   
							   
							   
							   
							   const int outLength = 5;
							   BYTE datapool[outLength];
							   
							   
							   datapool[0] = 0x02;
							   datapool[1] = 0x52;
							   datapool[2] = 0x4C;
							   datapool[3] = 0x03;
							   datapool[4] = 0x1F;
							   MSR.SendCommand(datapool, outLength, BufferTmp2, &BufferLength2);
							   
							   if(BufferLength2)
							   {
								   if (BufferTmp2[4] == 0x31)			// TDES
								   {
									   bDecryptMode = 1;
									   StrReaderStatus += _T(" ( TDES Encryption Enabled )");
								   }
								   
								   else if ( BufferTmp2[4] == 0x32)	// AES
								   {
									   bDecryptMode = 2;
									   StrReaderStatus += _T(" ( AES Encryption Enabled )");
								   }
							   }
							   	Sleep(500);
							   datapool[0] = 0x02;
							   datapool[1] = 0x52;
							   datapool[2] = 0x3E;
							   datapool[3] = 0x03;
							   datapool[4] = 0x6d;
							   MSR.SendCommand(datapool, outLength, BufferTmp2, &BufferLength2);
							   
							   if(BufferLength2)
							   {
								   if (BufferTmp2[4] == 0x5a)			// TDES
									   
									   TypeKey = 1;
								   
								   
								   else
									   TypeKey= 0;
								   
							   }
							   
							   
							   bChecked = true;
							   break;
						   }
					   }			
				   }
			   }
			   
		   }
		   if (!bConnected)
		   {
			   MSR.CloseMSRDevice();
			   	bChecked = false;
					OpenDev=0;
					openstart1=1;
			   StrReaderStatus = _T("Please Connect SecuRED MSR Swipe Reader!");
		   }
	   }
   	   if(KBMode==1) 
	   {
		   emMyItfType2 =ITF_TYPE_USB_HID_KB;
		   
		   
		   CMSRItfUSBHID	MSR(emMyItfType2);
		   for(m_ulDevIndex = 0; m_ulDevIndex < 50; m_ulDevIndex++)
		   {
			   if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
			   {
				   if(emMyItfType != emMyItfType2)			
					   continue;
				   else
				   {
					   if(MSR.OpenMSRDevice(m_ulDevIndex))
					   {					
						   KBMode = 1; // USB HID
						   //		GetDlgItem(IDC_SCRIPT)->ShowWindow(FALSE);
						   bConnected = true;
						   OpenDev=1;
						   if (!bChecked)
						   {
							   
							   // SecureMag USB HID						
							   StrReaderStatus = _T("SecuRED MSR USB KB Reader Connected ");
							   
							   
							   
							   
							   const int outLength = 5;
							   BYTE datapool[outLength];
							   
							   
							   datapool[0] = 0x02;
							   datapool[1] = 0x52;
							   datapool[2] = 0x4C;
							   datapool[3] = 0x03;
							   datapool[4] = 0x1F;
							   MSR.SendCommand(datapool, outLength, BufferTmp2, &BufferLength2);
							   
							   if(BufferLength2)
							   {
								   if (BufferTmp2[4] == 0x31)			// TDES
								   {
									   bDecryptMode = 1;
									   StrReaderStatus += _T(" ( TDES Encryption Enabled )");
								   }
								   
								   else if ( BufferTmp2[4] == 0x32)	// AES
								   {
									   bDecryptMode = 2;
									   StrReaderStatus += _T(" ( AES Encryption Enabled )");
								   }
							   }
							   
							   	Sleep(500);
							   datapool[0] = 0x02;
							   datapool[1] = 0x52;
							   datapool[2] = 0x3E;
							   datapool[3] = 0x03;
							   datapool[4] = 0x6d;
							   MSR.SendCommand(datapool, outLength, BufferTmp2, &BufferLength2);
							   
							   if(BufferLength2)
							   {
								   if (BufferTmp2[4] == 0x5a)			// TDES
									   
									  TypeKey = 1;
								   
								   
								   else
									   TypeKey= 0;
								   
							   }
										
							   
							   
							   bChecked = true;
							   break;
						   }
					   }			
				   }
			   }
			   
		   }
		   if (!bConnected)
		   {
			   MSR.CloseMSRDevice();
			 	bChecked = false;
					OpenDev=0;
					openstart1=1;
			   StrReaderStatus = _T("Please Connect SecuRED MSR Swipe Reader!");
		   }
	   }
   }
   
   
}

void CKeyInjectModuleDlg::OnTimer(UINT nIDEvent) 
{
	
	CheckReaderConnection();
	GetDlgItem(IDC_Opendevice)->SetWindowText(StrReaderStatus);
	
	if(bUpdateDisplay)
	{
		bUpdateDisplay = false;
		Outputdata();
	}
	
	CDialog::OnTimer(nIDEvent);
}

int CKeyInjectModuleDlg::Getkey(int ilen , byte *pRtrn)
{
	int nResponse;
	int cTemp;
	int len ;
	CString strKey;
	CString strKeyConfirm;
	CString strTemp;
	int TextLen=0;
	CString strTextLen;
	byte* pBTempBuff = NULL;
	
	UpdateData(TRUE);
	
	TextLen = ilen;
	strTextLen.Format("%i",TextLen);
	
	m_KetRtrvr.m_iKeyLen = TextLen;
	nResponse =m_KetRtrvr.DoModal();
	if (nResponse == IDOK)
	{
		
		strKey = m_KetRtrvr.m_strKey;
		strKeyConfirm = m_KetRtrvr.m_strKerConfirm;
		if(strKey.Compare(strKeyConfirm) !=0)
		{
			
			m_KetRtrvr.m_strKey.Empty();
			m_KetRtrvr.m_strKerConfirm.Empty();
			AfxMessageBox("Key Mismatch, Please Re-Enter");
			return 1; // key Mismatch
			
		}
		if(strKey.GetLength() < TextLen || strKeyConfirm.GetLength() < TextLen   )
		{
			m_KetRtrvr.m_strKey.Empty();
			m_KetRtrvr.m_strKerConfirm.Empty();		
			AfxMessageBox("Length of the key should be "+strTextLen);
			return 2; // length of the key should be 32
		}
		
		len = strKey.GetLength ();
		strKey.MakeUpper ();
		
		for(int loop = 0; loop<len;loop++)
		{
			cTemp = (int) strKey.GetAt(loop);
			if(!(((cTemp >= 0x30)&&(cTemp <= 0x39)) ||((cTemp >= 0x41)&&(cTemp <= 0x46))))
			{
				m_KetRtrvr.m_strKey.Empty();
				m_KetRtrvr.m_strKerConfirm.Empty();		
				AfxMessageBox ("Invalid Key Input,Please Re-Enter");
				return 2;
			}
		}
		
		
		m_KetRtrvr.m_strKey.Empty();
		m_KetRtrvr.m_strKerConfirm.Empty();
		pBTempBuff = (byte*)malloc(sizeof(byte)*ilen);
		memcpy(pBTempBuff,strKey.GetBuffer(strKey.GetLength()),strKey.GetLength());
		strKey.ReleaseBuffer();
		SetToHex(pBTempBuff,pRtrn,ilen);
		free(pBTempBuff);
		
	}
	else if(nResponse == IDCANCEL)
	{
		m_KetRtrvr.m_strKey.Empty();
		m_KetRtrvr.m_strKerConfirm.Empty();
		AfxMessageBox("Key entry canceled");
		return 3;// Key entry canceled;
		
	}
	
	return 0;
}

void CKeyInjectModuleDlg::MakeVisibleDebitKey()
{
	GetDlgItem(IDC_DEBIT_KEY)->ShowWindow(TRUE);
	GetDlgItem(IDC_INJECT_KEY)->ShowWindow(TRUE);
	GetDlgItem(IDC_INPUT_KEY)->ShowWindow(FALSE);
	GetDlgItem(IDC_DEBIT_KEY)->ShowWindow(TRUE);
	
	GetDlgItem(IDC_ENTER_KEY)->ShowWindow(FALSE);
	GetDlgItem(IDC_IIN_LBL)->EnableWindow(FALSE);
	GetDlgItem(IDC_IIN)->EnableWindow(FALSE);
	GetDlgItem(IDC_DID_LBL)->EnableWindow(FALSE);
	GetDlgItem(IDC_DID)->EnableWindow(FALSE);
	GetDlgItem(IDC_CID_LBL)->EnableWindow(FALSE);			
	GetDlgItem(IDC_CID)->EnableWindow(FALSE);
	GetDlgItem(IDC_GID_LBL)->EnableWindow(FALSE);
	GetDlgItem(IDC_GID)->EnableWindow(FALSE);
	GetDlgItem(IDC_OK)->EnableWindow(FALSE);
	
	GetDlgItem(IDC_ENCPT)->EnableWindow(FALSE);
	GetDlgItem(IDC_ENCPT_LBL)->EnableWindow(FALSE);
	GetDlgItem(IDC_METHOD)->EnableWindow(FALSE);
	GetDlgItem(IDC_METHOD_LBL)->EnableWindow(FALSE);
	GetDlgItem(IDC_CANCEL)->ShowWindow(FALSE);
	GetDlgItem(IDC_EXIT)->ShowWindow(FALSE);
	
	GetDlgItem(IDC_CANCEL_DEBIT)->ShowWindow(TRUE);
	GetDlgItem(IDC_NUM_DEVICES)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_NUM_DEVICES_LBL)->ShowWindow(SW_HIDE);
	
}

int CKeyInjectModuleDlg::DisplayMsg(CString DisMsg, CString DisVal, CString Cap, UINT type)
{
	
	int iResponse;
	iResponse = MessageBox(DisMsg+DisVal,Cap,type);
	return iResponse;
}

CString CKeyInjectModuleDlg::FormatHexToStr(byte *pBKCV)
{
	CString strCheckVal;
	CString strTemp;
	for(int k=0;k<3;k++)
	{
		strTemp.Format("%.2x",*(pBKCV+k));
		strCheckVal = strCheckVal + strTemp;
	}
	strCheckVal.MakeUpper();
	return strCheckVal;
}

void CKeyInjectModuleDlg::DUKPT_DES(int keyParts)
{
	DUKPT_TDES(keyParts);
}

void CKeyInjectModuleDlg::DUKPT_TDES(int keyParts)
{
	CString strKey;
	CString strKeyConfirm;
	CString strTemp;
	CString strCheckVal;
	char cArray[3] ;
	
	m_KetRtrvr.m_sCaption = "Key Serial Number";
	m_KetRtrvr.m_strLabel = "KSN";
	m_KetRtrvr.m_cPasswordChar = 0;
	m_KetRtrvr.m_strCaption = "";
	
	int iEncpt=0;
	int i=0,j;
	int iRspnsCheckVal =0;
	int iReturnStatus=0;
	
	BOOL bCancel = FALSE;
	BOOL bExitMethod = FALSE;
	
	byte* ks =NULL;
	byte* keyOut = NULL;
	byte* bUserKey =NULL;
	byte* pBKCV = NULL;
	byte* pKSN = NULL;
	byte* pKCV_KSN = NULL;
	
	pKSN =(byte*)malloc(sizeof(byte) * 8);
	pKCV_KSN = (byte*)malloc(sizeof(byte) * 3);
	bUserKey =(byte*)malloc(sizeof(byte) * 16);
	pBKCV = (byte*) malloc(sizeof(byte)*3);
	keyOut = (byte*)malloc(sizeof(byte)* 16);
	ks = (byte*)malloc(sizeof(byte)* 16);
	
	for(j=0;j<1;j++)
	{
		byte* pKSN1 = NULL;
		pKSN1 =(byte*)malloc(sizeof(byte) * 16);
		
		memcpy(pKSN1,StrKSN.GetBuffer(StrKSN.GetLength()),StrKSN.GetLength());
		SetToHex(pKSN1,pKSN,16);
		
		free(pKSN1);
		
		
		if( (iReturnStatus == 2) || (iReturnStatus == 1) )
		{
			--j;
			continue;
		}
		else if(iReturnStatus == 3)
		{
			bExitMethod = TRUE;
			GetDlgItem(IDC_METHOD)->EnableWindow(TRUE);
			GetDlgItem(IDC_METHOD_LBL)->EnableWindow(TRUE);
			
			GetDlgItem(IDC_ENCPT)->EnableWindow(TRUE);
			GetDlgItem(IDC_ENCPT_LBL)->EnableWindow(TRUE);
			
			
			break;	
		}
	}
	
	if(!bExitMethod)
	{
		m_KetRtrvr.m_sCaption = "Base Derivation Key";
		m_KetRtrvr.m_strLabel = "Key Part #";
		m_KetRtrvr.m_cPasswordChar = '*';
		
		GetKeyCkeckValue(pKSN,pKCV_KSN,8,ET_DES_MS);	// KSN encrypts using des.
		
		memcpy(m_pKsn,pKSN,8);
		memcpy(m_pKsnKcv,pKCV_KSN,3);
		
		
		for(i=0;i< keyParts;i++)
		{
			
			itoa(i+1,cArray,10);
			m_KetRtrvr.m_strCaption = cArray;
			
			iReturnStatus = Getkey(LEN_THIRTYTWO,bUserKey);
			if(!iReturnStatus)
			{
				
				GetKeyCkeckValue(bUserKey,pBKCV,16,ET_TDES_DUKPT);
				strCheckVal = FormatHexToStr(pBKCV);
				iRspnsCheckVal = DisplayMsg("Check Value is : ",strCheckVal, "Key Check Value",MB_OKCANCEL);
				strCheckVal.Empty();
				if(iRspnsCheckVal ==2)
				{
					--i;
					continue;
				}
				else if (iRspnsCheckVal ==1)
				{
					if(i==0)
						memset(ks,0,16);
					GetXORKey(ks,bUserKey,keyOut,16);
					memcpy(ks,keyOut,16);
					memset(keyOut,0,16);
					
				}
			}
			else if(iReturnStatus == 1)
			{
				--i;
				continue;
			}
			else if(iReturnStatus == 2)
			{
				--i;
				continue;
			}
			else if(iReturnStatus == 3)
			{
				bCancel = TRUE;
				GetDlgItem(IDC_METHOD)->EnableWindow(TRUE);
				GetDlgItem(IDC_METHOD_LBL)->EnableWindow(TRUE);
				
				
				GetDlgItem(IDC_ENCPT)->EnableWindow(TRUE);
				GetDlgItem(IDC_ENCPT_LBL)->EnableWindow(TRUE);
				break;	
			}
			
			
		} // end of main for loop
		
		if(!bCancel)
		{
			
			iRspnsCheckVal =0;
			
			GetKeyCkeckValue(ks,pBKCV,16,ET_DES_DUKPT);
			strCheckVal.Empty();
			strCheckVal = FormatHexToStr(pBKCV);
			iRspnsCheckVal = DisplayMsg("Check Value is : ",strCheckVal, "Generated Key Check Value",MB_OKCANCEL);
			
			if(iRspnsCheckVal ==2)
			{
			}
			else if (iRspnsCheckVal ==1)
			{
				memcpy(m_pBdk,ks,16);
				memcpy(m_pBdkKcv,pBKCV,3);
				
				MakeVisibleDebitKey();
			}
		}
		
	}//bExitMethod
	
	free(pKCV_KSN);
	free(pKSN);
	free(bUserKey);
	free(pBKCV);
	free(keyOut);
	free(ks);
}


void CKeyInjectModuleDlg::MasterDES(int keyParts)
{
	CString strKey;
	CString strKeyConfirm;
	CString strTemp;
	CString strCheckVal;
	char cArray[3] ;
	
	m_KetRtrvr.m_sCaption = "Master Key";
	m_KetRtrvr.m_strLabel = "Key Part #";
	m_KetRtrvr.m_cPasswordChar = '*';
	
	int iEncpt=0;
	int i=0;
	int iRspnsCheckVal =0;
	int iReturnStatus=0;
	
	BOOL bCancel = FALSE;
	
	
	byte * pBKCV = (byte*) malloc(sizeof(byte)*3);
	byte * keyOut = (byte*)malloc(sizeof(byte) *8);
	byte * ks = (byte*)malloc(sizeof(byte) * 8);
	byte * bUserKey =(byte*)malloc(sizeof(byte) *8);
	
	for(i=0;i< keyParts;i++)
	{
		
		itoa(i+1,cArray,10);
		m_KetRtrvr.m_strCaption = cArray;
		
		iReturnStatus = Getkey(16,bUserKey);
		
		if(!iReturnStatus)
		{
			GetKeyCkeckValue(bUserKey,pBKCV,8,ET_DES_MS);
			strCheckVal = FormatHexToStr(pBKCV);
			iRspnsCheckVal = DisplayMsg("Check Value is : ",strCheckVal, "Key Check Value",MB_OKCANCEL);
			strCheckVal.Empty();
			if(iRspnsCheckVal ==2)
			{
				--i;
				continue;
			}
			else if (iRspnsCheckVal ==1)
			{
				if(i==0)
					memset(ks,0,8);
				GetXORKey(ks,bUserKey,keyOut, 8);
				memcpy(ks,keyOut,8);
				memset(keyOut,0,8);
				
			}
		}
		else if(iReturnStatus == 1)
		{
			--i;
			continue;
		}
		else if(iReturnStatus == 2)
		{
			--i;
			continue;
		}
		else if(iReturnStatus == 3)
		{
			bCancel = TRUE;
			GetDlgItem(IDC_METHOD)->EnableWindow(TRUE);
			GetDlgItem(IDC_METHOD_LBL)->EnableWindow(TRUE);
			
			GetDlgItem(IDC_ENCPT)->EnableWindow(TRUE);
			GetDlgItem(IDC_ENCPT_LBL)->EnableWindow(TRUE);
			break;	
		}
		
		
	} // end of main for loop
	
    if(!bCancel)
	{
		
		iRspnsCheckVal =0;
		
		GetKeyCkeckValue(ks,pBKCV,8,ET_DES_MS);
		strCheckVal.Empty();
		strCheckVal = FormatHexToStr(pBKCV);
		iRspnsCheckVal = DisplayMsg("Check Value is : ",strCheckVal, "Generated Key Check Value",MB_OKCANCEL);
		
		if(iRspnsCheckVal ==2)
		{
		}
		else if (iRspnsCheckVal ==1)
		{
			memcpy(m_pMasterKey,ks,8); 
			memcpy(m_pMasterKcv,pBKCV,3);
			
			MakeVisibleDebitKey();
		}
	}
	
	free(ks);
	free(bUserKey);
	free(keyOut);
	free(pBKCV);
	
}

void CKeyInjectModuleDlg::MasterTDES(int keyParts)
{
	CString strKey;
	CString strKeyConfirm;
	CString strTemp;
	CString strCheckVal;
	char cArray[3] ;
	
	m_KetRtrvr.m_sCaption = "Master Key";
	m_KetRtrvr.m_strLabel = "Key Part #";
	m_KetRtrvr.m_cPasswordChar = '*';
	
	int iEncpt=0;
	int i=0;
	int iRspnsCheckVal =0;
	int iReturnStatus=0;
	
	BOOL bCancel = FALSE;
	
	byte * ks =NULL;
	byte * keyOut = NULL;
	byte * bUserKey =NULL;
	byte * pBKCV = NULL;
	
	pBKCV = (byte*) malloc(sizeof(byte*)*3);
	keyOut = (byte*)malloc(sizeof(byte)* 16);
	ks = (byte*)malloc(sizeof(byte)* 16);
	bUserKey =(byte*)malloc(sizeof(byte) * 16);
	
	
	for(i=0;i< keyParts;i++)
	{
		
		itoa(i+1,cArray,10);
		m_KetRtrvr.m_strCaption = cArray;
		
		iReturnStatus = Getkey(LEN_THIRTYTWO,bUserKey);
		if(!iReturnStatus)
		{
			GetKeyCkeckValue(bUserKey,pBKCV,16,ET_TDES_MS);
			strCheckVal = FormatHexToStr(pBKCV);
			iRspnsCheckVal = DisplayMsg("Check Value is : ",strCheckVal, "Key Check Value",MB_OKCANCEL);
			strCheckVal.Empty();
			if(iRspnsCheckVal ==2)
			{
				--i;
				continue;
			}
			else if (iRspnsCheckVal ==1)
			{
				if(i==0)
					memset(ks,0,16);
				
				GetXORKey(ks,bUserKey,keyOut,16);
				
				memcpy(ks,keyOut,16);
				memset(keyOut,0,16);
				
			}
		}
		else if(iReturnStatus == 1)
		{
			--i;
			continue;
		}
		else if(iReturnStatus == 2)
		{
			--i;
			continue;
		}
		else if(iReturnStatus == 3)
		{
			bCancel = TRUE;
			GetDlgItem(IDC_METHOD)->EnableWindow(TRUE);
			GetDlgItem(IDC_METHOD_LBL)->EnableWindow(TRUE);
			
			GetDlgItem(IDC_ENCPT)->EnableWindow(TRUE);
			GetDlgItem(IDC_ENCPT_LBL)->EnableWindow(TRUE);
			
			break;	
		}
		
		
	} // end of main for loop
	
    if(!bCancel)
	{
		
		iRspnsCheckVal =0;
		
		GetKeyCkeckValue(ks,pBKCV,16,ET_TDES_MS);
		strCheckVal.Empty();
		strCheckVal = FormatHexToStr(pBKCV);
		iRspnsCheckVal = DisplayMsg("Check Value is : ",strCheckVal, "Generated Key Check Value",MB_OKCANCEL);
		
		if(iRspnsCheckVal ==2)
		{
		}
		else if (iRspnsCheckVal ==1)
		{
			
			memcpy(m_pMasterKey,ks,16);
			memcpy(m_pMasterKcv,pBKCV,3);
			
			MakeVisibleDebitKey();
		}
	}
	
	free(pBKCV);
	free(ks);
	free(bUserKey);
	free(keyOut);
	
}


bool CKeyInjectModuleDlg::SendToDevice(int iProtocol, int iKeyType,bool bIsData, byte *bpRawKey ,byte* pBKCV,int *ipLength)
{
	byte* bInjectData = NULL;
	bool bRetVal = false;
	m_Event.ResetEvent();
	
	INTERFACE_TYPE emMyItfType; 
	INTERFACE_TYPE emMyItfType2;
	ULONG emMyItfType1; 
	CString strDevName;
	int		m_ulDevIndex = 0;
	
	emMyItfType1 = '1';
	emMyItfType2 = ITF_TYPE_USB_HID;
	CMSRItfUSBHID	MSR(emMyItfType2);
	CString StrResponse;
	
	BYTE BufferTmp[2048];
	ULONG	BufferLength = 2048;
	
	
	// Inject KSN
	if((iKeyType == KT_DES_DUKPT_KSN) ||  (iKeyType == KT_TDES_DUKPT_KSN))
	{
		int alen = (*ipLength)*2+27+1;
		bInjectData  =	(byte*) malloc(sizeof(byte)*(alen));
		m_protocolMgr.getKSNData(iProtocol,iKeyType,bpRawKey,bInjectData,ipLength);
		
		// USB HID Interface
		for(m_ulDevIndex = 0; m_ulDevIndex < 10; m_ulDevIndex++)
		{
			if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
			{
				if(emMyItfType != emMyItfType2)			
					continue;
				else
				{
					if(MSR.OpenMSRDevice(m_ulDevIndex))
					{		
						//Show Status
						StrResponse = "Injecting KSN.....\r\nPlease Wait!";
						GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
						Invalidate();
						UpdateWindow();
						
						Sleep(500);
						// Load KSN
						MSR.SendCommand3((unsigned char*)bInjectData,(unsigned long) *ipLength,BufferTmp,&BufferLength);
					}
				}
			}
			
		}
		
		// USB KB Interface
		if(m_ulDevIndex >= 10)
		{
			emMyItfType2 = ITF_TYPE_USB_HID_KB;
			
			CMSRItfUSBHID	MSR(emMyItfType2);
			for(m_ulDevIndex = 0; m_ulDevIndex < 10; m_ulDevIndex++)
			{
				if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
				{
					if(emMyItfType != emMyItfType2)
						continue;
					else
					{
						if(MSR.OpenMSRDevice(m_ulDevIndex))
						{
							//Show Status
							StrResponse = "Injecting KSN.....\r\nPlease Wait!";
							GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
							Invalidate();
							UpdateWindow();
							
							Sleep(1000);
							
							// Load KSN
							MSR.SendCommand3((unsigned char*)bInjectData,(unsigned long) *ipLength,BufferTmp,&BufferLength);
						}
					}
				}
			}		
		}
		
	
					
		if(BufferLength)
		{

			if (( BufferTmp[0] == 6) && (m_protocolMgr.validateInject(SYMBOL,BufferTmp,pBKCV) == 0) )	
			{
				bRetVal = true;
				Sleep(100);
			}
		}
		else
		{
			StrResponse += "\r\nNo Response from reader!\r\nFail to Inject KSN!";
			GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
			Invalidate();
			UpdateWindow();
			bRetVal = false;
		}
	
		FreeMem(bInjectData);
		return bRetVal;
	}
	
	// Load Key
	else if (bIsData)	
	{
		for(m_ulDevIndex = 0; m_ulDevIndex < 10; m_ulDevIndex++)
		{
			if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
			{
				if(emMyItfType != emMyItfType2)			
					continue;
				else
				{
					MSR.OpenMSRDevice(m_ulDevIndex);
					
					//Show Status
					StrResponse = "Injecting Key.....\r\nPlease Wait!";
					GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
					Invalidate();
					UpdateWindow();
					
					bInjectData  =	(byte*) malloc(sizeof(byte)*(*(ipLength)*2+27+1));
					m_protocolMgr.getInjectData(iProtocol,iKeyType,bpRawKey,bInjectData,ipLength);
					
					Sleep(500);
					MSR.SendCommand3((unsigned char*)bInjectData,(unsigned long) *ipLength,BufferTmp,&BufferLength);

					if(BufferLength)
					{
						if ((BufferTmp[0] == 6) && (m_protocolMgr.validateInject(SYMBOL,BufferTmp,pBKCV) == 0) )
						{
							StrResponse += "\r\nKey Injection Success!";
							GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
							Invalidate();
							UpdateWindow();
							bRetVal = true;
						}
						else
						{					
							StrResponse += "\r\nFail to Inject Key!";
							GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
							Invalidate();
							UpdateWindow();
							bRetVal = false;
						}					
					}
					else
					{
						StrResponse += "\r\nNo Response from reader!\r\nFail to Inject Key!";
						GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
						Invalidate();
						UpdateWindow();
						bRetVal = false;
					}
				
					
					/*
					if (MSR.nReader == 1) // SecureMag Reader
					{
						// Exit Key Loading Mode
						BYTE datapool[8];
						datapool[0] = 0x55;
						datapool[1] = 0x01;
						datapool[2] = 0x06;
						datapool[3] = 0x08;
						datapool[4] = 0x01;
						datapool[5] = 0x01;
						datapool[6] = 0x5A;
						int outLength = 7;
						
						Sleep(500);
						MSR.SendCommand(datapool,outLength,BufferTmp,&BufferLength);
					}				
					*/
					FreeMem(bInjectData);
					return bRetVal;
				}
			}
		}
		
		// USB KB Interface
		if(m_ulDevIndex >= 10)
		{
			emMyItfType2 = ITF_TYPE_USB_HID_KB;
			
			CMSRItfUSBHID	MSR(emMyItfType2);
			for(m_ulDevIndex = 0; m_ulDevIndex < 10; m_ulDevIndex++)
			{
				if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
				{
					if(emMyItfType != emMyItfType2)
						continue;
					else
					{
						MSR.OpenMSRDevice(m_ulDevIndex);
						
						//Show Status
						StrResponse = "Injecting Key.....\r\nPlease Wait!";
						GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
						Invalidate();
						UpdateWindow();
						
						bInjectData  =	(byte*) malloc(sizeof(byte)*(*(ipLength)*2+27+1));
						m_protocolMgr.getInjectData(iProtocol,iKeyType,bpRawKey,bInjectData,ipLength);
						
						Sleep(100);
						MSR.SendCommand3((unsigned char*)bInjectData,(unsigned long) *ipLength,BufferTmp,&BufferLength);
						
						if(BufferLength)
						{
							if ((BufferTmp[0] == 6) && (m_protocolMgr.validateInject(SYMBOL,BufferTmp,pBKCV) == 0) )
							{
								StrResponse += "\r\nKey Injection Success!";
								GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
								Invalidate();
								UpdateWindow();
								bRetVal = true;
							}
							else
							{					
								StrResponse += "\r\nFail to Inject Key!";
								GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
								Invalidate();
								UpdateWindow();
								bRetVal = false;
							}					
						}
						else
						{
							StrResponse += "\r\nNo Response from reader!\r\nFail to Inject Key!";
							GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
							Invalidate();
							UpdateWindow();
							bRetVal = false;
						}
						
						
						/*
						
						if (MSR.nReader == 1) // SecureMag Reader
						{
							// Exit Key Loading Mode
							BYTE datapool[8];
							datapool[0] = 0x55;
							datapool[1] = 0x01;
							datapool[2] = 0x06;
							datapool[3] = 0x08;
							datapool[4] = 0x01;
							datapool[5] = 0x01;
							datapool[6] = 0x5A;
							int outLength = 7;
							
							Sleep(200);
							MSR.SendCommand(datapool,outLength,BufferTmp,&BufferLength);
						}
						*/
						FreeMem(bInjectData);
						return bRetVal;
					}
				}
			}		
		}
	}
	
	else // Enter Key Loading Mode
	{
		for(m_ulDevIndex = 0; m_ulDevIndex < 10; m_ulDevIndex++)
		{
			if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
			{
				if(emMyItfType != emMyItfType2)			
					continue;
				else
				{
					MSR.OpenMSRDevice(m_ulDevIndex);
					/*
					if (MSR.nReader == 1) // SecureMag Reader
					{
						
						//Enter Key Loading Mode
						StrResponse = "Entering Key Loading Mode.....\r\nPlease Wait!";
						GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
						Invalidate();
						UpdateWindow();
						
						Sleep(100);
						BYTE datapool[8];
						datapool[0] = 0x55;
						datapool[1] = 0x01;
						datapool[2] = 0x06;
						datapool[3] = 0x08;
						datapool[4] = 0x09;
						datapool[5] = 0x01;
						datapool[6] = 0x5A;
						int outLength = 7;
						
						MSR.SendCommand(datapool,outLength,BufferTmp,&BufferLength);	
					
					}
						*/
					// Get Key Status
					bInjectData =(byte*) malloc(sizeof(byte)*((*ipLength)+15+1));
					m_protocolMgr.getStatusData(bInjectData,iProtocol,ipLength);
					
					//Check Key Status
					StrResponse = "Checking Key Status.....\r\nPlease Wait!";
					GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
					Invalidate();
					UpdateWindow();
					MSR.SendCommand3((unsigned char*)bInjectData,(unsigned long) *ipLength,BufferTmp,&BufferLength);				
					
					
					if(BufferLength)
					{
						if ( (BufferTmp[0] == 6) && (m_protocolMgr.validateStatus(SYMBOL,BufferTmp)  == 0) )
						{
							bRetVal = true;
							Sleep(100);
						}
					}
					else
					{
						StrResponse += "\r\nNo Response from reader!\r\nFail to Check Key Status!";
						GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
						Invalidate();
						UpdateWindow();
						bRetVal = false;
					}

					
						bRetVal = true;						
				}
				
				FreeMem(bInjectData);
				return bRetVal;				
				
			}
		}	
		
		// USB KB Interface
		if(m_ulDevIndex >= 10)
		{
			emMyItfType2 = ITF_TYPE_USB_HID_KB;
			
			CMSRItfUSBHID	MSR(emMyItfType2);
			for(m_ulDevIndex = 0; m_ulDevIndex < 10; m_ulDevIndex++)
			{
				if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
				{
					if(emMyItfType != emMyItfType2)
						continue;
					else
					{
						MSR.OpenMSRDevice(m_ulDevIndex);
						/*
						if (MSR.nReader == 1) // SecureMag Reader
						{
							
							//Enter Key Loading Mode
							StrResponse = "Entering Key Loading Mode.....\r\nPlease Wait!";
							GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
							Invalidate();
							UpdateWindow();
							
							Sleep(100);
							BYTE datapool[8];
							datapool[0] = 0x55;
							datapool[1] = 0x01;
							datapool[2] = 0x06;
							datapool[3] = 0x08;
							datapool[4] = 0x09;
							datapool[5] = 0x01;
							datapool[6] = 0x5A;
							int outLength = 7;
							
							MSR.SendCommand(datapool,outLength,BufferTmp,&BufferLength);	
						}
						*/
						// Get Key Status
						bInjectData =(byte*) malloc(sizeof(byte)*((*ipLength)+15+1));
						m_protocolMgr.getStatusData(bInjectData,iProtocol,ipLength);
						
						//Show Status
						StrResponse = "Checking Key Status.....\r\nPlease Wait!";	// USB
						GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
						Invalidate();
						UpdateWindow();
						
						MSR.SendCommand3((unsigned char*)bInjectData,(unsigned long) *ipLength,BufferTmp,&BufferLength);				
						
							
						if(BufferLength)
						{
							if ( (BufferTmp[0] == 6) && (m_protocolMgr.validateStatus(SYMBOL,BufferTmp)  == 0) )
							{
								bRetVal = true;
								Sleep(100);
							}
						}
						else
						{
							StrResponse += "\r\nNo Response from reader!\r\nFail to Check Key Status!";
							GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
							Invalidate();
							UpdateWindow();
							bRetVal = false;
						}

					}
					
					FreeMem(bInjectData);
					return bRetVal;				
				}
			}		
		}
		
	}
	
	MSR.CloseMSRDevice();
	return bRetVal;	
}

void CKeyInjectModuleDlg::InitDlg()
{
	GetDlgItem(IDC_DEBIT_KEY)->ShowWindow(FALSE);
	GetDlgItem(IDC_INJECT_KEY)->ShowWindow(FALSE);
	GetDlgItem(IDC_INPUT_KEY)->ShowWindow(FALSE);
	
	GetDlgItem(IDC_ABOUTKEY)->ShowWindow(SW_NORMAL);
	GetDlgItem(IDC_NO_OF_KEY_PARTS)->ShowWindow(SW_NORMAL);
	GetDlgItem(IDC_KEYPART)->ShowWindow(SW_NORMAL);
	
	GetDlgItem(IDC_OK)->EnableWindow(SW_NORMAL);
	GetDlgItem(IDC_ENCPT)->ShowWindow(SW_NORMAL);
	GetDlgItem(IDC_ENCPT_LBL)->ShowWindow(SW_NORMAL);
	
	GetDlgItem(IDC_METHOD)->ShowWindow(SW_NORMAL);
	GetDlgItem(IDC_METHOD_LBL)->ShowWindow(SW_NORMAL);
	
	GetDlgItem(IDC_EXIT)->ShowWindow(TRUE);
	GetDlgItem(IDC_CANCEL)->ShowWindow(FALSE);
	GetDlgItem(IDC_CANCEL_DEBIT)->ShowWindow(FALSE);
	
	GetDlgItem(IDC_NUM_DEVICES)->ShowWindow(SW_NORMAL);
	GetDlgItem(IDC_NUM_DEVICES_LBL)->ShowWindow(SW_NORMAL);
	
	GetDlgItem(IDC_METHOD)->EnableWindow(TRUE);
	GetDlgItem(IDC_ENCPT)->EnableWindow(TRUE);
	GetDlgItem(IDC_METHOD_LBL)->EnableWindow(TRUE);
	GetDlgItem(IDC_ENCPT_LBL)->EnableWindow(TRUE);
	GetDlgItem(IDC_ALGORITHM)->ShowWindow(TRUE);
	
	GetDlgItem(IDC_ENTER_KEY)->ShowWindow(FALSE);
	GetDlgItem(IDC_KSN_GROUP)->ShowWindow(FALSE);
	GetDlgItem(IDC_IIN_LBL)->ShowWindow(FALSE);
	GetDlgItem(IDC_IIN)->ShowWindow(FALSE);
	GetDlgItem(IDC_DID_LBL)->ShowWindow(FALSE);
	GetDlgItem(IDC_DID)->ShowWindow(FALSE);
	GetDlgItem(IDC_CID_LBL)->ShowWindow(FALSE);			
	GetDlgItem(IDC_CID)->ShowWindow(FALSE);
	GetDlgItem(IDC_GID_LBL)->ShowWindow(FALSE);
	GetDlgItem(IDC_GID)->ShowWindow(FALSE);
	
}

//make the ASCII format Hex command to real hex commands.
//pcbCmd IN: the size of bysCmd buffer, OUT: the real bytes counts of the command
BOOL CKeyInjectModuleDlg::MakeCommand(CString& strCmd, PBYTE bysCmd, int* pcbCmd)
{	
	CString strTemp;
	BYTE byChkSum = 0;
	int nCount=0, nBufSize=0, i;
	
	if(bysCmd == NULL || *pcbCmd == NULL)
		return FALSE;
	nBufSize = *pcbCmd;
	
	strCmd.MakeUpper(); //Make the command upper case
	
	for (i=0; i<nBufSize/2; i++)
	{
		strTemp = strCmd.Left(2);
		bysCmd[i] = Char2Hex(strTemp[0]) << 4 | Char2Hex(strTemp[1]);		
		strCmd = strCmd.Right(nBufSize-2*i-2);
		nCount++;
	}
	
	*pcbCmd = nCount;
	
	return TRUE; 
}

// Get the Hex byte for matching char
BYTE CKeyInjectModuleDlg::Char2Hex(char ch) 
{
	if( ch >= '0' && ch <= '9')
		return BYTE(ch-'0');
	
	if(ch >= 'A' && ch <= 'F')
		return BYTE(ch-'A'+10);
	
	if(ch >= 'a' && ch <= 'f')
		return BYTE(ch-'a'+10);
	
	return 0;
}

byte CKeyInjectModuleDlg::asctohex(byte m, byte n)
{
	if(m>47 && m<58)
		m -= 48;
	else if (m>64 && m<91)
		m -= 55;
	else m -= 87;
	
	if(n>47 && n<58)
		n -= 48;
	else if (n>64 && n<91)
		n -= 55;
	else n -= 87;
	
	return (16*m+n);
	
}

byte CKeyInjectModuleDlg::asctodec(byte m, byte n)
{
	if(m>47 && m<58)
		m -= 48;
	else if (m>64 && m<91)
		m -= 55;
	else m -= 87;
	
	if(n>47 && n<58)
		n -= 48;
	else if (n>64 && n<91)
		n -= 55;
	else n -= 87;
	
	return (10*m+n);
	
}

//function:  if you click this button, it will pop up a input dialog,
//           when you enter all parameter and click OK, then it will encrypt
//           the PIN block with the PIN pad device key in DUKPT.
//           the PIN block can be formated with PIN and account number that 
//           you entered.
void CKeyInjectModuleDlg::Decryption() 
{
	unsigned long   counter;
	unsigned char  stringKSN[10];
	int bSessionIDLen;

	CDES           lcDES;
	CDUKPT         lcDUKPT;
	AesCipher	   lcAES;
	unsigned char  k=1;
	
	INT32U i;
	CString        message, strASCII, strHEX, strSessionID, strTmp,strClear;
	strASCII = _T("Data in ASCII Format \r\n");
	strHEX = _T("\r\nData in HEX Format \r\n");
	strClear = _T("\r\nClear Data: \r\n");
	strSessionID = _T("");
	message = _T("");

	
	{
		
	//GetInitalKey(stringKSN, m_nderivation_key, m_ninitial_key);
		GetIK(m_nksn, m_nderivation_key, m_ninitial_key, ET_TDES_DUKPT);
		memcpy(stringKSN, m_nksn,10);
		//calculate the counter
		counter = stringKSN[9] | (stringKSN[8] << 8) | ((stringKSN[7] & 0x1f) << 16);
		stringKSN[9] = stringKSN[8] = 0;
		stringKSN[7] &= 0xE0;
        memset(m_cryptoKey, 0, 16);
		
		//get the m_cryptoKey
		
	   lcDUKPT.IDT_LoadInitKey(m_des_index,         // indicate whether the key is single- or double-length
							   m_ninitial_key,      // init key in binary
							   stringKSN);		
	
		do
		{	       
		   lcDUKPT.IDT_EncryptPIN(m_des_index,
								  lcDUKPT.IDT_ChangeCounter(counter, k),
								  stringKSN,            // returns the 10-byte KSN
								  m_cryptoKey,
								  TypeKey); 
		   k++;
		}while(k <= lcDUKPT.IDT_GetNumOfOnes(counter));
		
		
		if(m_CardType == 0){
			message = "Card Type: ISO/ABA\r\n";
		}else if (m_CardType == 1){
			message = "Card Type: AAMVA\r\n";
		}else if (m_CardType == 2){
			message = "Card Type: CADL\r\n";
		}else if (m_CardType == 3){
			message = "Card Type: Others\r\n";
		}
		
	
		if (EncodingType < 0x80)
		{
			// TDES Decryption
			if (bDecryptMode == 1)
			{
				unsigned char init_vector[8] = {0,0,0,0,0,0,0,0};


				if (bTrk1)
				{	
					lcDES.des_cbc_decryption(1, m_Track1Buffer, m_cryptoKey, init_vector, (INT16U)((DataLen) >> 3));
					
					// Display Decrypted Data
					for(i = 0; i < (int)length5; i++)
					{
						strTmp.Format("%C", m_Track1Buffer[i]);
						strASCII += strTmp;
					}
				
					strASCII += "\r\n";
					// Display Decrypted Data
					for(i = 0; i <(int)length5; i++)
					{
						strTmp.Format("%02X", m_Track1Buffer[i]);
						strHEX += strTmp;
					}
				}	
			}

			
			else
			{
				unsigned char init_vector[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};				
				lcAES.setIV(init_vector);
				lcAES.makeRoundKey(m_cryptoKey, DEFAULT_KEY_LENGTH);				
				
				if (bTrk1)
				{	
					lcAES.decryptString(m_Track1Buffer, m_Track1Buffer, (INT32U)DataLen, CBC);
					
					// Display Decrypted Data
					for(i = 0; i <(int)length5; i++)
					{
						strTmp.Format("%C", m_Track1Buffer[i]);
						strASCII += strTmp;
					}
				
					strASCII += "\r\n";
					// Display Decrypted Data
					for(i = 0; i < (int)length5; i++)
					{
						strTmp.Format("%02X", m_Track1Buffer[i]);
						strHEX += strTmp;
					}
				}				
			}
			
			if(type0){
			
			if (!KBMode) // USB HID
			{				
				if ((HID_Data[8]) && (EncodingType==0))
				{				
					for (i=HID_Data[6]+HID_Data[7]+9; i<HID_Data[6]+HID_Data[7]+HID_Data[8]+9; i++)
					{		
						strTmp.Format("%C",HID_Data[i]);
						strClear+= strTmp;
					}
				}
			}					
			
			else	// USB KB
			{								
				if ((USBKB_Data[7]) && (EncodingType==0))
					strClear += StrUSBKB.Mid(16+k+USBKB_Data[5]+USBKB_Data[6],USBKB_Data[7]);
				
				GetDlgItem(IDC_COMMAND)->SetWindowText(_T(""));
				GetDlgItem(IDC_COMMAND)->SetFocus();				
			}
			}
			else 
			{
				if (!KBMode) // USB HID
				{				
					if ((HID_Data[8]) && (EncodingType==0))
					{				
						for (i=HID_Data[6]+HID_Data[7]+9; i<HID_Data[6]+HID_Data[7]+HID_Data[8]+9; i++)
						{		
							strTmp.Format("%C",HID_Data[i]);
							strASCII+= strTmp;
						}
					}
				}					
				
				else	// USB KB
				{								
					if ((USBKB_Data[7]) && (EncodingType==0))
						strASCII += StrUSBKB.Mid(16+k+USBKB_Data[5]+USBKB_Data[6],USBKB_Data[7]);
					
					GetDlgItem(IDC_COMMAND)->SetWindowText(_T(""));
					GetDlgItem(IDC_COMMAND)->SetFocus();				
				}
		}
			
		
			if (bActivation) // Display Section ID
			{	
				strSessionID += _T("\r\nSection ID: ");
				

				if (KBMode != 1) // USB HID
				{
					for(i = HID_Data[6]+HID_Data[7]+HID_Data[8]; i < HID_Data[6]+HID_Data[7]+HID_Data[8]+8; i++)
					{
						strTmp.Format("%02X ", m_Track1Buffer[i]);
						strSessionID += strTmp;
					}				
				}
				
				else	// USB KB			
				{
					for(i = USBKB_Data[6]+USBKB_Data[7]+USBKB_Data[8]; i < USBKB_Data[6]+USBKB_Data[7]+USBKB_Data[8]+8; i++)
					{
						strTmp.Format("%02X ", m_Track1Buffer[i]);
						strSessionID += strTmp;
					}
				}
			}

		}
		
	
		
		else // if (EncodingType >= 0x80)
		{
			// TDES Decryption
			if (bDecryptMode == 1)	
			{
				unsigned char init_vector[8] = {0,0,0,0,0,0,0,0};
				bSessionIDLen = 8;	
				
				if (bTrk1)
				{	
					lcDES.des_cbc_decryption(1, m_Track1Buffer, m_cryptoKey, init_vector, (INT16U)((DataLen1) >> 3));
					
					// Display Decrypted Data
					for(i = 0; i < length1; i++)
					{
						strTmp.Format("%C", m_Track1Buffer[i]);
						strASCII += strTmp;
					}			
					strASCII += "\r\n";

					// Display Decrypted Data
					for(i = 0; i <length1; i++)
					{
						strTmp.Format("%02X", m_Track1Buffer[i]);
						strHEX += strTmp;
					}
					strHEX += "\r\n";
				}

				if (bTrk2)
				{	
					lcDES.des_cbc_decryption(1, m_Track2Buffer, m_cryptoKey, init_vector, (INT16U)((DataLen2) >> 3));
					
					// Display Decrypted Data
					for(i = 0; i <length2; i++)
					{
						strTmp.Format("%C", m_Track2Buffer[i]);
						strASCII += strTmp;
					}			
					strASCII += "\r\n";

					// Display Decrypted Data
					for(i = 0; i < length2; i++)
					{
						strTmp.Format("%02X", m_Track2Buffer[i]);
						strHEX += strTmp;
					}
					strHEX += "\r\n";
				}

				if (bTrk3)
				{	
					lcDES.des_cbc_decryption(1, m_Track3Buffer, m_cryptoKey, init_vector, (INT16U)((DataLen3) >> 3));
					
					// Display Decrypted Data
					for(i = 0; i < length3; i++)
					{
						strTmp.Format("%C", m_Track3Buffer[i]);
						strASCII += strTmp;
					}			
					strASCII += "\r\n";

					// Display Decrypted Data
					for(i = 0; i < length3; i++)
					{
						strTmp.Format("%02X", m_Track3Buffer[i]);
						strHEX += strTmp;
					}
					strHEX += "\r\n";
				}	


				if (bActivation) // Display Section ID
				{	
					strSessionID = "\r\nSession ID: ";
					lcDES.des_cbc_decryption(1, m_SessionIDBuffer, m_cryptoKey, init_vector, (INT16U)((bSessionIDLen) >> 3));					
					
					// Display Decrypted Data
					for(i = 0; i <8; i++)
					{
					    strTmp=strSessionID;
						strSessionID.Format("%s %02X", strTmp,m_SessionIDBuffer[i]);
					
					}
				}	
			}
					
				
				
			// AES Decryption
			else if (bDecryptMode == 2)					
			{
				unsigned char init_vector[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};	
				lcAES.setIV(init_vector);
				lcAES.makeRoundKey(m_cryptoKey, DEFAULT_KEY_LENGTH);
				bSessionIDLen = 16;	
						
				if (bTrk1)
				{	
					lcAES.decryptString(m_Track1Buffer, m_Track1Buffer, (INT32U)DataLen1, CBC);
					
					// Display Decrypted Data
					for(i = 0; i < length1; i++)
					{
						strTmp.Format("%C", m_Track1Buffer[i]);
						strASCII += strTmp;
					}			
					strASCII += "\r\n";

					// Display Decrypted Data
					for(i = 0; i < length1; i++)
					{
						strTmp.Format("%02X", m_Track1Buffer[i]);
						strHEX += strTmp;
					}
					strHEX += "\r\n";
				}

				if (bTrk2)
				{	
					lcAES.decryptString(m_Track2Buffer, m_Track2Buffer, (INT32U)DataLen2, CBC);
					
					// Display Decrypted Data
					for(i = 0; i < length2; i++)
					{
						strTmp.Format("%C", m_Track2Buffer[i]);
						strASCII += strTmp;
					}			
					strASCII += "\r\n";

					// Display Decrypted Data
					for(i = 0; i <length2; i++)
					{
						strTmp.Format("%02X", m_Track2Buffer[i]);
						strHEX += strTmp;
					}
					strHEX += "\r\n";
				}

				if (bTrk3)
				{	
					lcAES.decryptString(m_Track3Buffer, m_Track3Buffer, (INT32U)DataLen3, CBC);
					
					// Display Decrypted Data
					for(i = 0; i < length3; i++)
					{
						strTmp.Format("%C", m_Track3Buffer[i]);
						strASCII += strTmp;
					}			
					strASCII += "\r\n";

					// Display Decrypted Data
					for(i = 0; i < length3; i++)
					{
						strTmp.Format("%02X", m_Track3Buffer[i]);
						strHEX += strTmp;
					}
					strHEX += "\r\n";
				}	


				if (bActivation) // Display Section ID
				{	
					strSessionID = "Session ID: ";
					lcAES.decryptString(m_SessionIDBuffer, m_SessionIDBuffer, (INT32U)bSessionIDLen, CBC);
					
					for(i = 0; i < 8; i++)
					{
					    strTmp=strSessionID;
						strSessionID.Format("%s %02X", strTmp,m_SessionIDBuffer[i]);
					
					}
				}
			}
		

			if (KBMode == 1) // USB KB
			{
				GetDlgItem(IDC_COMMAND)->SetWindowText(_T(""));
				GetDlgItem(IDC_COMMAND)->SetFocus();
			}				
		
		}
		
		/*strTmp.Format("Key Value: %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X", \
			m_cryptoKey[0],m_cryptoKey[1],m_cryptoKey[2], m_cryptoKey[3],m_cryptoKey[4],\
			m_cryptoKey[5], m_cryptoKey[6], m_cryptoKey[7],m_cryptoKey[8],m_cryptoKey[9],\
			m_cryptoKey[0x0a], m_cryptoKey[0x0b],m_cryptoKey[0x0c], \
			m_cryptoKey[0x0d], m_cryptoKey[0x0e], m_cryptoKey[0x0f]);
		
		message += strTmp;*/
		
		strTmp.Format("\r\nKSN: %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X", \
			glm_nksn[0],glm_nksn[1],glm_nksn[2], glm_nksn[3],glm_nksn[4],\
			glm_nksn[5], glm_nksn[6], glm_nksn[7],glm_nksn[8],glm_nksn[9]);
		
		message += strTmp;

		// Display Section ID
     	message +="\r\n";
		if (bActivation)
			message += strSessionID;

		 
		message += "\r\n\r\nDecrypted Data:\r\n" + strASCII + "\r\n\r\n" + strHEX;
		//MessageBox(strHEX);
		message +="\r\n";
        ((CStatic *)GetDlgItem(IDC_RESP)) -> SetWindowText(message);
		
	}
	
}

void CKeyInjectModuleDlg::Received_HID_Data() 
{
	bUpdateDisplay = true;
}




void CKeyInjectModuleDlg::OnWSET2ErrornotificationAlt() 
{
	INTERFACE_TYPE emMyItfType; 
	INTERFACE_TYPE emMyItfType2;
	CString strDevName,StrResponse,StrTmp;
	int		m_ulDevIndex = 0;
	BYTE BufferTmp[500];
	ULONG	BufferLength = 500;
	int i, j;
	
	emMyItfType2 = ITF_TYPE_USB_HID;
	
	CMSRItfUSBHID	MSR(emMyItfType2);
	
	for (i=0; i<500; i++)
		BufferTmp[i] = 0;
	
	
	BYTE datapool[7];
	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x19;
	datapool[3] = 0x01;
	datapool[4] = 0x3d;
	datapool[5] = 0x03;
	datapool[6] = 0x77;
	int outLength = 7;
	
	for(m_ulDevIndex = 0; m_ulDevIndex < 10; m_ulDevIndex++)
	{
		if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
		{
			if(emMyItfType != emMyItfType2)			
				continue;
			else
			{
				if(MSR.OpenMSRDevice(m_ulDevIndex))
				{
					Sleep(50); // make sure the device is not busy.
					MSR.SendCommand(datapool,outLength,BufferTmp,&BufferLength);
				}
			}
		}
	}
	
	if(m_ulDevIndex >= 10){
		emMyItfType2 = ITF_TYPE_USB_HID_KB;
		
		CMSRItfUSBHID	MSR(emMyItfType2);
		for(m_ulDevIndex = 0; m_ulDevIndex < 10; m_ulDevIndex++)
		{
			if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
			{
				if(emMyItfType != emMyItfType2)
					continue;
				else
				{
					if(MSR.OpenMSRDevice(m_ulDevIndex))
					{
						Sleep(50); // make sure the device is not busy.
						MSR.SendCommand(datapool,outLength,BufferTmp,&BufferLength);
					}
				}
			}
		}		
	}
	if ( BufferTmp[0] == 6)
		MessageBox("W S/E, all T2 and Error Notification Alt command was sent successfully!","Status",MB_OK);				
	else
		MessageBox("Fail to send W S/E, all T2 and Error Notification Alt!",_T("Error"),MB_OK);				
	
	for (i=BufferLength; i>0; i--)
		if (BufferTmp[i] != 0)
			break;
		
		if (( BufferTmp[0] == 6) || ( BufferTmp[0] == 21))
			for (j=0; j<i+1; j++)
			{
				StrTmp.Format("%02X ",BufferTmp[j]);
				StrResponse += StrTmp;
			}
			
			//Show command text
			StrResponse = "CMD: 02 53 19 01 3D 03 77\r\nOUT: " + StrResponse;						
			GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
			
			MSR.CloseMSRDevice();		
}


/**************************************************/
/* Methods of Dialog
/**************************************************/


/**************************************************/
/* Events of Dialog
/**************************************************/
void CKeyInjectModuleDlg::OnInject() 
{
	UpdateData(TRUE);
	
	m_isFrist = TRUE;
	m_iInjectCount = 1;
	
	
	int iKeyPartVal = atoi(m_NoOfKeyPart);
	int iNumDevices = atoi(m_strNumDevices);
	
	m_NoOfDevices = iNumDevices;
	
	CString strMode = m_Encrypt;
	
	if((iNumDevices<1) || (iNumDevices>489335))
	{
		AfxMessageBox ("Number of Devices should be in Range: 1 - 489,335");
	}
	else
	{
		GetDlgItem(IDC_INPUT_KEY)->EnableWindow(FALSE);
		GetDlgItem(IDC_INJECT)->EnableWindow(FALSE);
		GetDlgItem(IDC_METHOD)->ShowWindow(FALSE);
		GetDlgItem(IDC_METHOD_LBL)->ShowWindow(FALSE);
		GetDlgItem(IDC_ENCPT)->ShowWindow(FALSE);
		GetDlgItem(IDC_ENCPT_LBL)->ShowWindow(FALSE);
		GetDlgItem(IDC_KEYPART)->ShowWindow(FALSE);
		GetDlgItem(IDC_NO_OF_KEY_PARTS)->ShowWindow(FALSE);
		GetDlgItem(IDC_NUM_DEVICES_LBL)->ShowWindow(FALSE);
		GetDlgItem(IDC_NUM_DEVICES)->ShowWindow(FALSE);
		GetDlgItem(IDC_ALGORITHM)->ShowWindow(FALSE);
		GetDlgItem(IDC_ABOUTKEY)->ShowWindow(FALSE);
		
		
		GetDlgItem(IDC_DEBIT_KEY)->ShowWindow(TRUE);
		GetDlgItem(IDC_KSN_GROUP)->ShowWindow(TRUE);
		
		GetDlgItem(IDC_IIN_LBL)->EnableWindow(TRUE);
		GetDlgItem(IDC_IIN_LBL)->ShowWindow(TRUE);
		GetDlgItem(IDC_IIN)->EnableWindow(TRUE);
		GetDlgItem(IDC_IIN)->SetWindowText(StrIDTECH_IIN);
		GetDlgItem(IDC_IIN)->ShowWindow(TRUE);
		
		GetDlgItem(IDC_DID_LBL)->EnableWindow(TRUE);
		GetDlgItem(IDC_DID_LBL)->ShowWindow(TRUE);
		
		
		CFile fDeviceID;
		CFileException ex;
		TCHAR *DID_Data;
		
		// Read Device ID from file
		if(fDeviceID.Open(".\\DID.txt", CFile::modeRead, &ex))		
		{
			int len = fDeviceID.GetLength();
			DID_Data = new TCHAR[len + 1];
			DID_Data[len] = '\0';
			fDeviceID.Read(DID_Data, len);
			CString szBuff(DID_Data);
			
			StrDID = szBuff;	
			fDeviceID.Close();
		}
		
		else
			StrDID = _T("000000");
		
		
		
		GetDlgItem(IDC_DID)->SetWindowText(StrDID);
		GetDlgItem(IDC_DID)->EnableWindow(TRUE);
		GetDlgItem(IDC_DID)->ShowWindow(TRUE);
		
		GetDlgItem(IDC_CID_LBL)->EnableWindow(TRUE);			
		GetDlgItem(IDC_CID_LBL)->ShowWindow(TRUE);			
		GetDlgItem(IDC_CID)->EnableWindow(TRUE);
		GetDlgItem(IDC_CID)->SetWindowText(_T("01"));
		GetDlgItem(IDC_CID)->ShowWindow(TRUE);
		
		
		char	dateStr[9];
		BYTE	Month, Year;
		CString StrGID;
		
		_strdate( dateStr);
		Month = asctodec(dateStr[0],dateStr[1]);
		Year = asctodec(dateStr[6],dateStr[7]) - 9;
		
		StrGID.Format("%01X%01X",Year,Month);			
		GetDlgItem(IDC_GID)->SetWindowText(StrGID);
		GetDlgItem(IDC_GID)->EnableWindow(TRUE);
		GetDlgItem(IDC_GID)->ShowWindow(TRUE);
		GetDlgItem(IDC_GID_LBL)->EnableWindow(TRUE);
		GetDlgItem(IDC_GID_LBL)->ShowWindow(TRUE);
		
		GetDlgItem(IDC_ENTER_KEY)->ShowWindow(TRUE);			
	}
}

void CKeyInjectModuleDlg::OnCancel() 
{
	free(m_pMasterKey);
	free(m_pMasterKcv);
	free(m_pKsn);
	free(m_pKsnKcv);
	free(m_pBdk);
	free(m_pBdkKcv);
	
	CDialog::OnCancel();
}

void CKeyInjectModuleDlg::OnEnterKey() 
{
	CString CStrTemp_IIN,CStrTemp_CID,CStrTemp_GID;
	
	GetDlgItem(IDC_IIN)->GetWindowText(CStrTemp_IIN);
	GetDlgItem(IDC_CID)->GetWindowText(CStrTemp_CID);
	GetDlgItem(IDC_GID)->GetWindowText(CStrTemp_GID);
	GetDlgItem(IDC_DID)->GetWindowText(StrDID);
	
	
	StrKSN = CStrTemp_IIN + CStrTemp_CID + CStrTemp_GID + StrDID;
//	StrKSN = "FFFF9876543210E0";
	CallInjector (ET_TDES_DUKPT,atoi(m_NoOfKeyPart));
}

void CKeyInjectModuleDlg::OnInjectKey() 
{
	
	BOOL bExitMethod=FALSE;
	
	int nResponse;
	int len =0;
	int iKEY_TYPE;
	int iKEY_TYPE_KSN;
	int iInjectLen=0;
	
	bool bRtrn=false;
	bool bKsnInject = true;
	
	CString strParity;
	
	byte* bInjectData = NULL;
	byte* pBKEY = (byte*)malloc(sizeof(byte) * 16);
	byte* pBKCV_Key = (byte*)malloc(sizeof(byte) * 3);
	byte* pBKSN = (byte*)malloc(sizeof(byte) * 10);
	byte* pBKCV_Ksn = (byte*) malloc(sizeof(byte)* 3);
	byte* pIK = (byte*) malloc(sizeof(byte)* 16);
	byte* pKCV_IK = (byte*) malloc(sizeof(byte)* 3);
	
	
	nResponse = 0;
	
	if((m_iCurrentOperation == ET_DES_MS) || (m_iCurrentOperation == ET_TDES_MS))
	{
		
		if(m_iCurrentOperation == ET_DES_MS)
		{
			
			memcpy(pBKEY,m_pMasterKey,8);
			iKEY_TYPE = KT_DES_MS;
			iInjectLen = 8;
			
		}
		else
		{
			memcpy(pBKEY,m_pMasterKey,16);
			iKEY_TYPE = KT_TDES_MS;
			iInjectLen = 16;
		}
		
		memcpy(pBKCV_Key,m_pMasterKcv,3);
		
	}
	else if(m_iCurrentOperation == ET_DES_DUKPT)
	{			
		if(m_iInjectCount == 1)
		{
			GetInitialKSN(m_pKsn);
		}
		else
		{
			GetNextKSN(m_pKsn);	
		}
		
		memcpy(pBKSN,m_pKsn,10);
		GetKeyCkeckValue(m_pKsn,pBKCV_Ksn,8,ET_DES_MS);
		
		GetIK(m_pKsn,m_pBdk,pIK,ET_DES_DUKPT);
		memcpy(pBKEY,pIK,8);
		
		GetKeyCkeckValue(pIK,pKCV_IK,16,ET_DES_MS);
		memcpy(pBKCV_Key,pKCV_IK,3);
		
		iInjectLen = 8;
		iKEY_TYPE = KT_DES_DUKPT_IK;
		iKEY_TYPE_KSN  = KT_DES_DUKPT_KSN;
		
	}
	else if(m_iCurrentOperation == ET_TDES_DUKPT) 
	{
		
		if(m_iInjectCount == 1)			
			GetInitialKSN(m_pKsn);
		
		else			
			GetNextKSN(m_pKsn);	
		
		byte ppp[16];
		memcpy(pBKSN,m_pKsn,10);
		GetKeyCkeckValue(m_pKsn,pBKCV_Ksn,8,ET_DES_MS);
		
		GetIK(m_pKsn,m_pBdk,pIK,ET_TDES_DUKPT);
		memcpy(pBKEY,pIK,16);
		
		memcpy(ppp,pIK,16);
		GetKeyCkeckValue(pIK,pKCV_IK,16,ET_TDES_DUKPT);
		memcpy(pBKCV_Key,pKCV_IK,3);
		
		iInjectLen = 16;
		iKEY_TYPE = KT_TDES_DUKPT_IK;
		iKEY_TYPE_KSN  = KT_TDES_DUKPT_KSN;
		
		
	}
	
	if(nResponse != 1)
	{
		{
			int ipINT =0;
			bRtrn = SendToDevice(SYMBOL,0,false,NULL,NULL,&ipINT);
			if(!bRtrn)
			{
				MessageBox("Fail to enter Key Loading Mode","Status",MB_OK);
				bExitMethod=TRUE;
				
			}
			
			
			if(!bExitMethod)
			{
				{
					if( (m_iCurrentOperation == ET_DES_DUKPT) || ( m_iCurrentOperation == ET_TDES_DUKPT)  )
					{							
						int iInjectLenKsn = 8;
						
						bRtrn = SendToDevice(SYMBOL,iKEY_TYPE_KSN,true,pBKSN,pBKCV_Ksn,&iInjectLenKsn);
						
						if(!bRtrn)
						{
							MessageBox("Fail to load KSN","Status",MB_OK);
							bKsnInject = false;
							
						}
						if(bKsnInject)
						{
							
							bRtrn = SendToDevice(SYMBOL,iKEY_TYPE,true,pBKEY,pBKCV_Key,&iInjectLen);
							if(!bRtrn)
							{
								MessageBox("Fail to load Key! Key Injection Failed!","Status",MB_OK);
								
							}
							else
							{
								if( (m_iCurrentOperation != ET_DES_DUKPT) ||  (m_iCurrentOperation != ET_TDES_DUKPT)  )
								{
									
									MessageBox("Key Injection Success!","Status",MB_OK);
									
									BYTE DID_Buffer[6];
									long unsigned int lDeviceID = 0;
									
									// Get Current DeviceID
									for (int i=0; i<3; i++)
									{
										DID_Buffer[i] = asctohex(StrDID.GetAt(2*i),StrDID.GetAt(2*i+1));
										lDeviceID = lDeviceID*256 + DID_Buffer[i];
									}
									
									// Update the new Device and write it to the file
									lDeviceID+=0x20;		
									
									if (lDeviceID > 0xFFFFFF)
										MessageBox("Device ID has exceeds its limit!");
									
									StrDID.Format("%06X",lDeviceID);
									
									CFile fDeviceID;
									CFileException ex;
									
									fDeviceID.Remove(".\\DID.txt");
									
									if(fDeviceID.Open(".\\DID.txt", CFile::modeWrite|CFile::modeCreate, &ex))		
										fDeviceID.Write(StrDID, 6);
									
									fDeviceID.Close();
									
									
								}
							}
							bKsnInject = true;
						}
						
					}
					
					if((m_iCurrentOperation == ET_DES_MS) || (m_iCurrentOperation == ET_TDES_MS) )
					{
						bRtrn = SendToDevice(SYMBOL,iKEY_TYPE,true,pBKEY,pBKCV_Key,&iInjectLen);
						
						if(!bRtrn)
							MessageBox("Key Injection Failed","Status",MB_OK);															
						
						else
						{
							if( (m_iCurrentOperation != ET_DES_DUKPT) ||  (m_iCurrentOperation != ET_TDES_DUKPT)  )
								MessageBox("Key Injection Success!","Status",MB_OK);
						}
						
					}
					
				}
			}		
			
		}
	}
	
	free(pBKEY);
	free(pBKCV_Key);
	free(pBKSN);
	free(pIK);
	free(pKCV_IK);
	free(pBKCV_Ksn);
	
	if((m_iInjectCount == m_NoOfDevices) && (nResponse != 1))
	{
		if( m_NoOfDevices !=1)	
		{
			AfxMessageBox("Reached The Final Key Serial Number");		
			
		}
		
		InitDlg();
		GetDlgItem(IDC_INPUT_KEY)->ShowWindow(TRUE);
		
		
	}
	if(nResponse != 1) 
		++m_iInjectCount ;
	
	if (m_NoOfDevices == 1)
	{
		GetDlgItem(IDC_INPUT_KEY)->ShowWindow(TRUE);
		GetDlgItem(IDC_ALGORITHM)->ShowWindow(TRUE);
		
		GetDlgItem(IDC_ENTER_KEY)->ShowWindow(FALSE);
		GetDlgItem(IDC_KSN_GROUP)->ShowWindow(FALSE);
		GetDlgItem(IDC_IIN_LBL)->ShowWindow(FALSE);
		GetDlgItem(IDC_IIN)->ShowWindow(FALSE);
		GetDlgItem(IDC_DID_LBL)->ShowWindow(FALSE);
		GetDlgItem(IDC_DID)->ShowWindow(FALSE);
		GetDlgItem(IDC_CID_LBL)->ShowWindow(FALSE);			
		GetDlgItem(IDC_CID)->ShowWindow(FALSE);
		GetDlgItem(IDC_GID_LBL)->ShowWindow(FALSE);
		GetDlgItem(IDC_GID)->ShowWindow(FALSE);
	}

	GetDlgItem(IDC_EXIT)->ShowWindow(TRUE);
	GetDlgItem(IDC_INPUT_KEY)->EnableWindow(TRUE);
}

void CKeyInjectModuleDlg::OnCancelDebit() 
{
	m_isFrist = TRUE;
	
	SetDlgItemText(IDC_NO_OF_KEY_PARTS,"2");
	GetDlgItem(IDC_DEBIT_KEY)->ShowWindow(FALSE);
	GetDlgItem(IDC_INJECT_KEY)->ShowWindow(FALSE);
	GetDlgItem(IDC_INPUT_KEY)->ShowWindow(TRUE);
	SetDlgItemText(IDC_ENCPT,"TDES");
	SetDlgItemText(IDC_METHOD,"Master/Session");			
	
	GetDlgItem(IDC_DEBIT_KEY)->ShowWindow(FALSE);
	GetDlgItem(IDC_ABOUTKEY)->ShowWindow(SW_NORMAL);
	GetDlgItem(IDC_NO_OF_KEY_PARTS)->ShowWindow(SW_NORMAL);
	GetDlgItem(IDC_KEYPART)->ShowWindow(SW_NORMAL);
	
	GetDlgItem(IDC_OK)->EnableWindow(TRUE);
	
	GetDlgItem(IDC_ENCPT)->ShowWindow(SW_NORMAL);
	GetDlgItem(IDC_ENCPT_LBL)->ShowWindow(SW_NORMAL);
	
	GetDlgItem(IDC_METHOD)->ShowWindow(SW_NORMAL);
	GetDlgItem(IDC_METHOD_LBL)->ShowWindow(SW_NORMAL);
	
	GetDlgItem(IDC_CANCEL)->ShowWindow(FALSE);
	GetDlgItem(IDC_EXIT)->ShowWindow(TRUE);
	
	GetDlgItem(IDC_CANCEL_DEBIT)->ShowWindow(FALSE);
	
	GetDlgItem(IDC_NUM_DEVICES)->ShowWindow(SW_NORMAL);
	GetDlgItem(IDC_NUM_DEVICES_LBL)->ShowWindow(SW_NORMAL);
	
	GetDlgItem(IDC_METHOD)->EnableWindow(TRUE);
	GetDlgItem(IDC_ENCPT)->EnableWindow(TRUE);
	GetDlgItem(IDC_METHOD_LBL)->EnableWindow(TRUE);
	GetDlgItem(IDC_ENCPT_LBL)->EnableWindow(TRUE);
	
	GetDlgItem(IDC_KSN_GROUP)->ShowWindow(FALSE);
	GetDlgItem(IDC_IIN_LBL)->ShowWindow(FALSE);
	GetDlgItem(IDC_IIN)->ShowWindow(FALSE);
	GetDlgItem(IDC_DID_LBL)->ShowWindow(FALSE);
	GetDlgItem(IDC_DID)->ShowWindow(FALSE);
	GetDlgItem(IDC_CID_LBL)->ShowWindow(FALSE);			
	GetDlgItem(IDC_CID)->ShowWindow(FALSE);
	GetDlgItem(IDC_GID_LBL)->ShowWindow(FALSE);
	GetDlgItem(IDC_GID)->ShowWindow(FALSE);
	
	GetDlgItem(IDC_ALGORITHM)->ShowWindow(TRUE);
}

void CKeyInjectModuleDlg::OnInputKey() 
{
	CString strKey;
	CString strKeyConfirm;
	CString strTemp;
	CString strCheckVal;
	m_KetRtrvr.m_sCaption = "INPUT BDK";
	m_KetRtrvr.m_strLabel = "BDK";
	m_KetRtrvr.m_cPasswordChar = 0;
	m_KetRtrvr.m_strCaption = "";
	
	int iEncpt=0;
	int i=0;
	int iRspnsCheckVal =0;
	int iReturnStatus=0;
	
	BOOL bCancel = FALSE;
	BOOL bExitMethod = FALSE;
	
	byte* pInitialKey = NULL;
	pInitialKey =(byte*)malloc(sizeof(byte) * 16);
	
	for(int j=0;j<1;j++)
	{
		iReturnStatus = Getkey(32,pInitialKey);
		if( (iReturnStatus == 2) || (iReturnStatus == 1) )
		{
			--j;
			continue;
		}
		else if(iReturnStatus == 3)
		{
			bExitMethod = TRUE;
			break;
		}
	}
	
	for (i=0; i<16; i++)
		m_nderivation_key[i] = pInitialKey[i];
	
	bIK = true;
	
	free(pInitialKey);

	GetDlgItem(IDC_COMMAND)->SetFocus();
}

void CKeyInjectModuleDlg::OnSend() 
{
	
	int nSize,i;
	BOOL bRet=TRUE;
	BYTE CmdBuf[2048], CmdBuf2[2048], LRC = 0;
	CString		StrResponse, StrTmp;
	unsigned long RespLen = 3;

	if(select_mode == COM_MODE)//serial port mode 
	{

		sWaitReadCmd =true;
	//-----------get input command
		GetDlgItem(IDC_COMMAND)->GetWindowText(StrCommand);
						
		StrCommand.Remove(_T(' ')); //remove space
		StrCommand.Remove(_T('\t')); //remove tab
		
		
		if(StrCommand.IsEmpty())  // Check if the command string is empty
		{
			MessageBox(_T("Please Input the Command String!"), _T("Error"), MB_OK);
			return;
		}
		
		nSize = StrCommand.GetLength();

		// Convert the command to hex formart
		bRet = MakeCommand(StrCommand, CmdBuf, &nSize);
		
		if(nSize>256)
		{
			MessageBox(_T("The command text is too long or invalid!"), _T("Error"), MB_OK);
			return;;
		}
		CmdBuf2[0] = 2;
		
		for(i=0; i<nSize; i++)
			CmdBuf2[i+1] = CmdBuf[i];
		
		CmdBuf2[i+1] = 3;
		
		for(i=0; i<nSize+2; i++)
			LRC ^= CmdBuf2[i];
		
		CmdBuf2[i] = LRC;
		
		
		nSize = i+1;
	    
		//MSR.SendCommand2(CmdBuf2, nSize, StrResponse);
	//------------end get input command

		int res = 0;
		BYTE rec[512];

		res = sp_com.Write(CmdBuf2,nSize,100); //sp write
		if(res != nSize)
		{
			AfxMessageBox("Fail to send command!");
			GetDlgItem(IDC_COMMAND)->SetFocus();
			sWaitReadCmd = false;
		//	sp_com.Close();
			return;
		}
		Sleep(300);
		res = sp_com.Read(rec, 512, 500);
		ParseResponseByteToCstring(StrResponse,rec,res);
		//StrResponse.Format(_T("%s"), rec);

		sWaitReadCmd = false;
	//	sp_com.Close();

		if( CmdBuf2[2]==0x4c&&CmdBuf2[4]==0x31&&strcmp(StrResponse.GetBuffer(StrResponse.GetLength()),"06 ")==0)
		{	
			
				StrReaderStatus = _T("SecuRED MSR Serial Port Reader Connected( TDES Encryption Enabled ) ");
	                 bDecryptMode = 1;
		}
	    else if(CmdBuf2[2]==0x4c&&CmdBuf2[4]==0x32&&strcmp(StrResponse.GetBuffer(StrResponse.GetLength()),"06 ")==0) 
		{
			StrReaderStatus = _T("SecuRED MSR Serial Port Reader Connected( AES Encryption Enabled ) ");
			bDecryptMode = 2;
		}

	
	}
	else if(select_mode == USB_MODE) // usb hid mode
	{
		INTERFACE_TYPE emMyItfType; 
		ULONG emMyItfType1; 
		INTERFACE_TYPE emMyItfType2;
		CString strDevName;
		int		m_ulDevIndex = 0;
		
		emMyItfType1 = '1';
		emMyItfType2 = ITF_TYPE_USB_HID;
		
		
		CMSRItfUSBHID	MSR(emMyItfType2);
		for(m_ulDevIndex = 0; m_ulDevIndex < 50; m_ulDevIndex++)
		{
			if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
			{
				if(emMyItfType != emMyItfType2)			
					continue;
				else
				{
					if(MSR.OpenMSRDevice(m_ulDevIndex))
					{
						Sleep(50); // make sure the device is not busy.
						
						//get command text
						GetDlgItem(IDC_COMMAND)->GetWindowText(StrCommand);
						
						StrCommand.Remove(_T(' ')); //remove space
						StrCommand.Remove(_T('\t')); //remove tab
						
						
						if(StrCommand.IsEmpty())  // Check if the command string is empty
						{
							MessageBox(_T("Please Input the Command String!"), _T("Error"), MB_OK);
							return;
						}
						
						nSize = StrCommand.GetLength();
			
						// Convert the command to hex formart
						bRet = MakeCommand(StrCommand, CmdBuf, &nSize);
						
						if(nSize>256)
						{
							MessageBox(_T("The command text is too long or invalid!"), _T("Error"), MB_OK);
							return;;
						}
						
						
						CmdBuf2[0] = 2;
						
						for(i=0; i<nSize; i++)
							CmdBuf2[i+1] = CmdBuf[i];
						
						CmdBuf2[i+1] = 3;
						
						for(i=0; i<nSize+2; i++)
							LRC ^= CmdBuf2[i];
						
						CmdBuf2[i] = LRC;
						
						
						nSize = i+1;
					    
						MSR.SendCommand2(CmdBuf2, nSize, StrResponse);
						
					}
					
					else
					{
						printf("Fail to open device! \n");
						MSR.CloseMSRDevice();
					}
				}
			}
		}
		
		if(m_ulDevIndex >= 50){
			emMyItfType2 = ITF_TYPE_USB_HID_KB;
			
			CMSRItfUSBHID	MSR(emMyItfType2);
			for(m_ulDevIndex = 0; m_ulDevIndex < 50; m_ulDevIndex++)
			{
				if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
				{
					if(emMyItfType != emMyItfType2)
						continue;
					else
					{
						if(MSR.OpenMSRDevice(m_ulDevIndex))
						{
							Sleep(50); // make sure the device is not busy.
							
							//get command text
							GetDlgItem(IDC_COMMAND)->GetWindowText(StrCommand);
							
							StrCommand.Remove(_T(' ')); //remove space
							StrCommand.Remove(_T('\t')); //remove tab
							
							
							
							if(StrCommand.IsEmpty())  // Check if the command string is empty
							{
								MessageBox(_T("Please Input the Command String!"), _T("Error"), MB_OK);
								return;
							}
							
							nSize = StrCommand.GetLength();
							if(nSize>256)
							{
								MessageBox(_T("The command text is too long or invalid!"), _T("Error"), MB_OK);
								return;;
							}
							// Convert the command to hex formart
							bRet = MakeCommand(StrCommand, CmdBuf, &nSize);
							
							
							
							CmdBuf2[0] = 2;
							
							for(i=0; i<nSize; i++)
								CmdBuf2[i+1] = CmdBuf[i];
							
							CmdBuf2[i+1] = 3;
							
							for(i=0; i<nSize+2; i++)
								LRC ^= CmdBuf2[i];
							
							CmdBuf2[i] = LRC;
							
							
							nSize = i+1;
							
							MSR.SendCommand2(CmdBuf2, nSize, StrResponse);
						}
						
						else
						{
							printf("Fail to open device! \n");
							MSR.CloseMSRDevice();
						}
					}
				}
			}		
		}
		GetDlgItem(IDC_COMMAND)->SetFocus();	
		
	EXIT:
		{
			
		}
		MSR.CloseMSRDevice();

		
		if( CmdBuf2[2]==0x4c&&CmdBuf2[4]==0x31&&strcmp(StrResponse.GetBuffer(StrResponse.GetLength()),"06 ")==0)
		{	
			
				StrReaderStatus = _T("SecuRED MSR USB HID Reader Connected( TDES Encryption Enabled ) ");
	                 bDecryptMode = 1;
		}
	    else if(CmdBuf2[2]==0x4c&&CmdBuf2[4]==0x32&&strcmp(StrResponse.GetBuffer(StrResponse.GetLength()),"06 ")==0) 
		{
			StrReaderStatus = _T("SecuRED MSR USB HID Reader Connected( AES Encryption Enabled ) ");
			bDecryptMode = 2;
		}
	}//end else	
	StrCommand = "";
	for (i=0; i<nSize; i++)
	{
		StrTmp.Format("%02X ", CmdBuf2[i]);
		StrCommand += StrTmp;
	}
	StrResponse = "CMD: " + StrCommand + "\r\nOUT: " + StrResponse;
	
	GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
	
	StrCommand = "";
	GetDlgItem(IDC_COMMAND)->SetWindowText(StrCommand);
	GetDlgItem(IDC_COMMAND)->SetFocus();	
	
}

void CKeyInjectModuleDlg::OnDecrypt() 
{
	BYTE BufferTmp1[1024], BufferTmp2[1024];
	ULONG	BufferLength1 =1024, BufferLength2 = 1024;
	bool bConnected = false;


	if(select_mode == COM_MODE)
	{
	
		sWaitReadCmd = true;
		
		KBMode = 0; // USB HID
		//		GetDlgItem(IDC_SCRIPT)->ShowWindow(FALSE);
		bConnected = true;					

		if (!bChecked&&openstart1)
		{
			
			// SecureMag USB HID						
			StrReaderStatus = _T("SecuRED MSR SERIAL PORT Reader Connected ");
			
			//	OutputDebugString("thread2");
			
			const int outLength = 5;
			BYTE datapool[outLength];
			int len;
			
			
			datapool[0] = 0x02;
			datapool[1] = 0x52;
			datapool[2] = 0x4C;
			datapool[3] = 0x03;
			datapool[4] = 0x1F;

		//	MSR.SendCommand(datapool, outLength, BufferTmp2, &BufferLength2);
			len = sp_com.Write(datapool,outLength,100); //sp write
			if(len != outLength)
			{
				AfxMessageBox("Fail to send command!");
				GetDlgItem(IDC_RESP)->SetFocus();
				sWaitReadCmd = false;
			//	sp_com.Close();
				return;
			}
			Sleep(300);
			len= sp_com.Read(BufferTmp2, 512, 500);
		
				if (BufferTmp2[4] == 0x31)			// TDES
				{
				bDecryptMode = 1;
					StrReaderStatus += _T(" ( TDES Encryption Enabled )");
				}
				
				else if ( BufferTmp2[4] == 0x32)	// AES
				{
				bDecryptMode = 2;
					StrReaderStatus += _T(" ( AES Encryption Enabled )");
				}
			
			 Sleep(500);
			datapool[0] = 0x02;
			datapool[1] = 0x52;
			datapool[2] = 0x3E;
			datapool[3] = 0x03;
			datapool[4] = 0x6d;
		//	MSR.SendCommand(datapool, outLength, BufferTmp2, &BufferLength2);
			len = sp_com.Write(datapool,outLength,100); //sp write
			if(len != outLength)
			{
				AfxMessageBox("Fail to send command!");
				GetDlgItem(IDC_RESP)->SetFocus();
				sWaitReadCmd = false;
			//	sp_com.Close();
				return;
			}
			Sleep(300);
			len= sp_com.Read(BufferTmp2, 512, 500);
			
			if(BufferLength2)
			{
				if (BufferTmp2[4] == 0x5a)			// TDES
					
					TypeKey = 1;
				
				
				else
				   TypeKey= 0;
				
			}
		
			bChecked = true;
			
		}
		sWaitReadCmd = false;
	//	sp_com.Close();
		
	}
	else if(select_mode == USB_MODE)
	{



		
	INTERFACE_TYPE emMyItfType; 
	ULONG emMyItfType1; 
	INTERFACE_TYPE emMyItfType2;
	CString strDevName;
	int		m_ulDevIndex = 0;
	emMyItfType1 = '1';
	emMyItfType2 = ITF_TYPE_USB_HID;
				
				
				CMSRItfUSBHID	MSR(emMyItfType2);
				for(m_ulDevIndex = 0; m_ulDevIndex < 20; m_ulDevIndex++)
				{
					if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
					{
						
						if(emMyItfType != emMyItfType2)			
							continue;
						else
						{
							if(MSR.OpenMSRDevice(m_ulDevIndex))
							{					
								KBMode = 0; // USB HID
								//		GetDlgItem(IDC_SCRIPT)->ShowWindow(FALSE);
								bConnected = true;					
							
								if (!bChecked&&openstart1)
								{
									
									// SecureMag USB HID						
									StrReaderStatus = _T("SecuRED MSR USB HID Reader Connected ");
									
									//	OutputDebugString("thread2");
									
									const int outLength = 5;
									BYTE datapool[outLength];
									
									
									datapool[0] = 0x02;
									datapool[1] = 0x52;
									datapool[2] = 0x4C;
									datapool[3] = 0x03;
									datapool[4] = 0x1F;

									MSR.SendCommand(datapool, outLength, BufferTmp2, &BufferLength2);
									
								
										if (BufferTmp2[4] == 0x31)			// TDES
										{
										bDecryptMode = 1;
											StrReaderStatus += _T(" ( TDES Encryption Enabled )");
										}
										
										else if ( BufferTmp2[4] == 0x32)	// AES
										{
										bDecryptMode = 2;
											StrReaderStatus += _T(" ( AES Encryption Enabled )");
										}
									
									 Sleep(500);
									datapool[0] = 0x02;
									datapool[1] = 0x52;
									datapool[2] = 0x3E;
									datapool[3] = 0x03;
									datapool[4] = 0x6d;
									MSR.SendCommand(datapool, outLength, BufferTmp2, &BufferLength2);
									
									if(BufferLength2)
									{
										if (BufferTmp2[4] == 0x5a)			// TDES
											
											TypeKey = 1;
										
										
										else
										   TypeKey= 0;
										
									}
										
									
									
									
									bChecked = true;
									break;
								}
							}			
						}
					}
				}
				
				if(m_ulDevIndex >= 20){
					emMyItfType2 = ITF_TYPE_USB_HID_KB;
					
					CMSRItfUSBHID	MSR(emMyItfType2);
					for(m_ulDevIndex = 0; m_ulDevIndex <20; m_ulDevIndex++)
					{
						if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
						{
							
							if(emMyItfType != emMyItfType2)
								continue;
							else
							{
								if(MSR.OpenMSRDevice(m_ulDevIndex))
								{		
								KBMode = 1; // USB KB						
									bConnected = true;
									OpenDev=1;
									if (!bChecked&&openstart1)
									{						
										
										StrReaderStatus = _T("SecuRED MSR USB KB Reader Connected ");
										
										const int outLength = 5;
										BYTE datapool[outLength];
										
										//OutputDebugString("thread1");
										
										datapool[0] = 0x02;
										datapool[1] = 0x52;
										datapool[2] = 0x4C;
										datapool[3] = 0x03;
										datapool[4] = 0x1F;
										MSR.SendCommand(datapool, outLength, BufferTmp2, &BufferLength2);
									
											if (BufferTmp2[4] == 0x31)			// TDES
											{
											bDecryptMode = 1;
												StrReaderStatus += _T(" ( TDES Encryption Enabled )");
											}
											
											else if ( BufferTmp2[4] == 0x32)	// AES
											{
											bDecryptMode = 2;
												StrReaderStatus += _T(" ( AES Encryption Enabled )");
											}
									
										
                                       
                                       Sleep(500);
										datapool[0] = 0x02;
										datapool[1] = 0x52;
										datapool[2] = 0x3E;
										datapool[3] = 0x03;
										datapool[4] = 0x6d;
										MSR.SendCommand(datapool, outLength, BufferTmp2, &BufferLength2);
										
										if(BufferLength2)
										{
											if (BufferTmp2[4] == 0x5a)			// TDES
										
												TypeKey = 1;
										
											
											else
											TypeKey= 0;
											
										}
										

										
										
										
										
										
										bChecked = true;
										break;
									}						
								}
							}
						}
					}		
				}



				if (!bConnected)
				{
					MSR.CloseMSRDevice();
					bChecked = false;
				
			
				}

	}

/*if(OpenDev==0)
	{
		bChecked = false;
					OpenDev=0;
					openstart1=1;
		MessageBox("Please Connect SRED MSR Swipe Reader!","Error",MB_OK);
		return;
	}*/


	const TCHAR CR[] = {13, 0};
	BOOL bDecryption = false;
	
	unsigned char len = 0;
	unsigned char berror = 0;
	unsigned long counter;
	CString StringTmp, StrTmp;
	
	bTrk1 = bTrk2 = bTrk3 = false;
	
	int i;
	int EncryptedTrackLength = 0;
	int EncryptedTrack1Length = 0;
	int EncryptedTrack2Length = 0;
	int EncryptedTrack3Length = 0;
	
	int UnencryptedLength = 0;	
	int shiftSize = 0;
	m_des_index=1;
	
	if (bDecryptMode)
	{
		if (!KBMode) // USB HID
		{
			
			int Length;		
			BYTE TempLRC=0;
			BYTE TempCheckSum=0;
			CString StrTemp;
			GetDlgItem(IDC_COMMAND)->GetWindowText(StrTmp);
			int	Data_Length = StrTmp.GetLength();
			if(Data_Length==0)
			{	MessageBox("No Data to Decrypt");	GetDlgItem(IDC_COMMAND)->SetFocus();return;}
			if(Data_Length%2)
			{	MessageBox("Data Error");	GetDlgItem(IDC_COMMAND)->SetFocus();return;}
			else {
				memset(HID_Data,2048,0);
				for(i=0;i<Data_Length/2;i++)
					
					HID_Data[i+1] = asctohex(StrTmp.GetAt(2*i), StrTmp.GetAt(2*i+1));
			}
			// Check Length
			Length = HID_Data[3]*256 + HID_Data[2];	
			
			StrTemp.Format("Data Error");
			
			
			if ( Length != HID_Data_Length-7||HID_Data[1]!=0x02||HID_Data[Data_Length/2]!=0x03)
			{
				MessageBox(StrTemp);
				GetDlgItem(IDC_COMMAND)->SetFocus();
				return;
			}
			
			
			
			
			
			
			
			
			
			
			EncodingType = HID_Data[4];
			
			if (EncodingType < 0x80)
			{
				
				// Non ISO/ABA Data Output Format
				if (0)
				{
					type13=1;
					StrTmp = "Reader Output: (Non ISO/ABA Data Output Format)\r\n";
					for (i=1; i<HID_Data_Length; i++)
					{		
						StringTmp.Format("%02X",HID_Data[i]);
						StrTmp += StringTmp;
					}
					
					
					StrTmp += "\r\n\r\nCard Data:\r\n";
					if (HID_Data[6])
					{				
						for (i=0; i<HID_Data[6]; i++)
						{		
							StringTmp.Format("%C",HID_Data[i+9]);
							StrTmp += StringTmp;
						}
						StrTmp+="\r\t";	
					}
					
					if (HID_Data[7])
					{				
						for (i=HID_Data[6]+9; i<HID_Data[6]+HID_Data[7]+9; i++)
						{		
							StringTmp.Format("%C",HID_Data[i]);
							StrTmp += StringTmp;
						}
						StrTmp+="\r\t";	
					}
					
					
					if (HID_Data[8])
					{				
						for (i=HID_Data[6]+HID_Data[7]+9; i<HID_Data[6]+HID_Data[7]+HID_Data[8]+9; i++)
						{		
							StringTmp.Format("%C",HID_Data[i]);
							StrTmp += StringTmp;
						}
					}
					
					
					
					
					GetDlgItem(IDC_RESP) -> SetWindowText(StrTmp);
				}
				
				// ISO/ABA Data Output Format
				else if (EncodingType == 0||(EncodingType == 1) || (EncodingType == 3))				
				{
					type0=1;
					StrTmp += "Reader Output: (ISO/ABA Data Output Format)";
					for (i=0; i<10; i++)
						glm_nksn[i] = HID_Data[i+HID_Data_Length-13];
					
					for (i=1; i<HID_Data_Length; i++)
					{		
						StringTmp.Format("%02X",HID_Data[i]);
						StrTmp += StringTmp;
					}
					
					
					StrTmp += "\r\n\r\nMasked Data: ";
					if (HID_Data[6])
					{	
						StrTmp += "\r\nTrack 1: ";
						
						for (i=0; i<HID_Data[6]; i++)
						{		
							StringTmp.Format("%C",HID_Data[i+9]);
							StrTmp += StringTmp;
						}
						StrTmp+="\r\t";	
					}
					
					if (HID_Data[7])
					{
						StrTmp += "\r\nTrack 2: ";
						
						for (i=HID_Data[6]+9; i<HID_Data[6]+HID_Data[7]+9; i++)
						{		
							StringTmp.Format("%C",HID_Data[i]);
							StrTmp += StringTmp;
						}
						StrTmp+="\r\t";	
					}
					
					if (HID_Data[8])
					{
						StrTmp += "\r\nTrack 3: ";
						
						for (i=HID_Data[6]+HID_Data[7]+9; i<HID_Data[6]+HID_Data[7]+HID_Data[8]+9; i++)
						{		
							StringTmp.Format("%C",HID_Data[i]);
							StrTmp += StringTmp;
						}
					}
					
					
					UnencryptedLength = HID_Data[6]+HID_Data[7]+HID_Data[8];
					
					
					// Security Level=4
					if (bActivation)
						shiftSize = 8;
					else
						shiftSize = 0;
					
					
					if (bDecryptMode == 1) // TDES
					{
						if (((HID_Data[6] + HID_Data[7]+shiftSize) % 8) == 0)
							EncryptedTrackLength = HID_Data[6] + HID_Data[7]+shiftSize;
						else
							EncryptedTrackLength = ((HID_Data[6] + HID_Data[7]+shiftSize) / 8 + 1) * 8;
					}
					
					else if (bDecryptMode == 2) // AES
					{
						if (((HID_Data[6] + HID_Data[7]+shiftSize) % 16) == 0)
							EncryptedTrackLength = HID_Data[6] + HID_Data[7]+shiftSize;
						else
							EncryptedTrackLength = ((HID_Data[6] + HID_Data[7]+shiftSize) / 16 + 1) * 16;
					}
					
					DataLen = EncryptedTrackLength;
					length5=HID_Data[6] + HID_Data[7]+shiftSize;
					for (i = 0; i<EncryptedTrackLength; i++)
						m_Track1Buffer[i] = HID_Data[i+UnencryptedLength+9];
					
					bTrk1 = true;
					bDecryption = true;	
					
					GetDlgItem(IDC_RESP)->SetWindowText(StrTmp);
					
					
					for(i=0; i<10; i++)	
						m_nksn[i] = glm_nksn[i];			
					
					//Initial key
					if (!bIK)
					{
						m_str_initial_key = StrInitialKey;
						len = m_str_initial_key.GetLength();
						
						for(i=0; i<len/2; i++)							
							m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
					}
					
					
					counter = m_nksn[9] | (m_nksn[8] << 8) | ((m_nksn[7] & 0x1f) << 16) ;
					if(!counter) 
					{
						berror = 1;
						MessageBox("The KSN can not be 0", "Warning", MB_ICONWARNING);			
					}				
					
					Decryption();
				}
				
				
				// Raw Data Output Format
				else if (EncodingType == 4)				
				{
					type4=1;
					StrTmp += "Reader Output: (Raw Data Output Format)";
					for (i=0; i<10; i++)
						glm_nksn[i] = HID_Data[i+HID_Data_Length-13];
					
					for (i=1; i<HID_Data_Length; i++)
					{		
						StringTmp.Format("%02X",HID_Data[i]);
						StrTmp += StringTmp;
					}				
					
					int UnencryptedLength = HID_Data[6]+HID_Data[7]+HID_Data[8];
					
					// Security Level=4
					if (bActivation)
						shiftSize = 8;
					else
						shiftSize = 0;
					
					
					if (bDecryptMode == 1) // TDES
					{
						if (((HID_Data[6]+HID_Data[7]+HID_Data[8]+shiftSize) % 8) == 0)
							EncryptedTrackLength = HID_Data[6]+HID_Data[7]+HID_Data[8]+shiftSize;
						else
							EncryptedTrackLength = ((HID_Data[6]+HID_Data[7]+HID_Data[8]+shiftSize) / 8 + 1) * 8;
					}
					
					else if (bDecryptMode == 2) // AES
					{
						if (((HID_Data[6]+HID_Data[7]+HID_Data[8]+shiftSize) % 16) == 0)
							EncryptedTrackLength = HID_Data[6]+HID_Data[7]+HID_Data[8]+shiftSize;
						else
							EncryptedTrackLength = ((HID_Data[6]+HID_Data[7]+HID_Data[8]+shiftSize) / 16 + 1) * 16;
					}
					
					DataLen = EncryptedTrackLength;
					length5=HID_Data[6] + HID_Data[7]+HID_Data[8]+shiftSize;
					for (i = 0; i<EncryptedTrackLength; i++)
						m_Track1Buffer[i] = HID_Data[i+9];
					
					bTrk1 = true;
					bDecryption = true;	
					
					//GetDlgItem(IDC_COMMAND)->SetWindowText(StrTmp);
					
					
					for(i=0; i<10; i++)	
						m_nksn[i] = glm_nksn[i];			
					
					//Initial key
					if (!bIK)
					{
						m_str_initial_key = StrInitialKey;
						len = m_str_initial_key.GetLength();
						
						for(i=0; i<len/2; i++)							
							m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
					}
					
					Decryption();
				}
				
			}
			
			
			else // if (EncodingType >= 0x80)
			{
				
				// Non ISO/ABA Data Output Format
				if (0)
				{
					
				/*
				Encrypted data sent status
				bit 0: if 1-tk1 encrypted data present 
				bit 1: if 1-tk2 encrypted data present
				bit 2: if 1-tk3 encrypted data present
				bit 3: if 1-tk1 hash data present
				bit 4: if 1-tk2 hash data present
				bit 5: if 1-tk3 hash data present
				Bit 6: if 1-session ID present 
				Bit 7: if 1-KSN present
					*/
					BYTE bEncryptedDataStatus = HID_Data[10];		
					
					if((bEncryptedDataStatus&0x07) > 0)
					{
						for (i=0; i<10; i++)
							glm_nksn[i] = HID_Data[i+HID_Data_Length-13];					
						
						if (HID_Data[6])
						{
							bTrk1 = true;
							
							if (bDecryptMode == 1) // TDES
							{
								if ((HID_Data[6] % 8) == 0)
									EncryptedTrack1Length = HID_Data[6];
								else
									EncryptedTrack1Length = (HID_Data[6]/ 8 + 1) * 8;
							}
							
							else if (bDecryptMode == 2) // AES
							{
								if ((HID_Data[6] % 16) == 0)
									EncryptedTrack1Length = HID_Data[6];
								else
									EncryptedTrack1Length = (HID_Data[6] / 16 + 1) * 16;
							}
							
							DataLen1 = EncryptedTrack1Length;
							length1=HID_Data[6];
						}
						
						
						if (HID_Data[7])
						{
							bTrk2 = true;
							
							if (bDecryptMode == 1) // TDES
							{
								if ((HID_Data[7] % 8) == 0)
									EncryptedTrack2Length = HID_Data[7];
								else
									EncryptedTrack2Length = (HID_Data[7] / 8 + 1) * 8;
							}
							
							else if (bDecryptMode == 2) // AES
							{
								if ((HID_Data[7] % 16) == 0)
									EncryptedTrack2Length = HID_Data[7];
								else
									EncryptedTrack2Length = (HID_Data[7] / 16 + 1) * 16;
							}
							
							DataLen2 = EncryptedTrack2Length;
							length2=HID_Data[7];
						}
						
						
						if (HID_Data[8])
						{
							bTrk3 = true;
							
							if (bDecryptMode == 1) // TDES
							{
								if ((HID_Data[8] % 8) == 0)
									EncryptedTrack3Length = HID_Data[8];
								else
									EncryptedTrack3Length = (HID_Data[8] / 8 + 1) * 8;
							}
							
							else if (bDecryptMode == 2) // AES
							{
								if ((HID_Data[8] % 16) == 0)
									EncryptedTrack3Length = HID_Data[8];
								else
									EncryptedTrack3Length = (HID_Data[8] / 16 + 1) * 16;
							}
							
							DataLen3 = EncryptedTrack3Length;
							length3=HID_Data[8];
						}
						
						
						if (bTrk1)
							for (i = 0; i<EncryptedTrack1Length; i++)
								m_Track1Buffer[i] = HID_Data[i+11];
							
							if (bTrk2)
								for (i = 0; i<EncryptedTrack2Length; i++)
									m_Track2Buffer[i] = HID_Data[i+EncryptedTrack1Length+11];
								
								
								if (bTrk3)
									for (i = 0; i<EncryptedTrack3Length; i++)
										m_Track3Buffer[i] = HID_Data[i+EncryptedTrack1Length+EncryptedTrack2Length+11];
									
									// Security Level=4
									if (bActivation)
									{	
										if (bDecryptMode == 1) // TDES
										{
											for (i = 0; i<8; i++)
												m_SessionIDBuffer[i] = HID_Data[i+EncryptedTrack1Length+EncryptedTrack2Length+EncryptedTrack3Length+11];
										}
										
										else if (bDecryptMode == 2) // AES
										{
											for (i = 0; i<16; i++)
												m_SessionIDBuffer[i] = HID_Data[i+EncryptedTrack1Length+EncryptedTrack2Length+EncryptedTrack3Length+11];
										}
									}
									
									
									bDecryption = true;	
									
									//GetDlgItem(IDC_COMMAND)->SetWindowText(StrTmp);
									
									
									for(i=0; i<10; i++)	
										m_nksn[i] = glm_nksn[i];			
									
									//Initial key
									if (!bIK)
									{
										m_str_initial_key = StrInitialKey;
										len = m_str_initial_key.GetLength();
										
										for(i=0; i<len/2; i++)							
											m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
									}
									
									
									Decryption();
					}
					
					else
					{
						StrTmp = "Reader Output: (Non ISO/ABA Enhanced Data Output Format)\r\n";
						for (i=1; i<HID_Data_Length; i++)
						{		
							StringTmp.Format("%02X",HID_Data[i]);
							StrTmp += StringTmp;
						}
						
						
						StrTmp += "\r\n\r\nCard Data:\r\n";
						if (HID_Data[6])
						{				
							for (i=0; i<HID_Data[6]; i++)
							{		
								StringTmp.Format("%C",HID_Data[i+11]);
								StrTmp += StringTmp;
								
							}
							StrTmp+="\r\t";	
						}
						
						if (HID_Data[7])
						{				
							for (i=HID_Data[6]+11; i<HID_Data[6]+HID_Data[7]+11; i++)
							{		
								StringTmp.Format("%C",HID_Data[i]);
								StrTmp += StringTmp;
							}
							StrTmp+="\r\t";	
						}
						
						
						if (HID_Data[8])
						{				
							for (i=HID_Data[6]+HID_Data[7]+11; i<HID_Data[6]+HID_Data[7]+HID_Data[8]+11; i++)
							{		
								StringTmp.Format("%C",HID_Data[i]);
								StrTmp += StringTmp;
							}
						}
						
						//	GetDlgItem(IDC_COMMAND)->SetWindowText(StrTmp);
						
						
						GetDlgItem(IDC_RESP) -> SetWindowText(StrTmp);
					}
				}
				
				// ISO/ABA Data Output Format
				else if (EncodingType == 0x80||(EncodingType == 0x81) || (EncodingType == 0x83))				
				{				
					
					StrTmp += "Reader Output: (ISO/ABA Enhanced Data Output Format)";
					for (i=0; i<10; i++)
						glm_nksn[i] = HID_Data[i+HID_Data_Length-13];
					
					for (i=1; i<HID_Data_Length; i++)
					{		
						StringTmp.Format("%02X",HID_Data[i]);
						StrTmp += StringTmp;
					}
					
					
					/*
					Clear/mask data sent status byte:
					bit 0: 1--- if TK1 clear/mask data present 
					bit 1: 1--- if TK2 clear/mask data present
					bit 2: 1--- if TK3 clear/mask data present
					Bit 3:0-0
					Bit 4:0-0
					Bit 5:0-0
					*/
					BYTE bClearMaskDataStatus = HID_Data[9];
					
					if (bClearMaskDataStatus)
						StrTmp += "\r\n\r\nMasked Data: ";
					
					
					if (HID_Data[6])
					{
						bTrk1 = true;
						
						if (bClearMaskDataStatus & 1)
						{	
							StrTmp += "\r\nTrack 1: ";
							
							for (i=0; i<HID_Data[6]; i++)
							{		
								StringTmp.Format("%C",HID_Data[i+11]);
								StrTmp += StringTmp;
							}
							
							UnencryptedLength += HID_Data[6];
							StrTmp+="\r\t";	
						}
						
						if (bDecryptMode == 1) // TDES
						{
							if ((HID_Data[6] % 8) == 0)
								EncryptedTrack1Length = HID_Data[6];
							else
								EncryptedTrack1Length = (HID_Data[6] / 8 + 1) * 8;
						}
						
						else if (bDecryptMode == 2) // AES
						{
							if ((HID_Data[6] % 16) == 0)
								EncryptedTrack1Length = HID_Data[6];
							else
								EncryptedTrack1Length = (HID_Data[6] / 16 + 1) * 16;
						}
						
						
						DataLen1 = EncryptedTrack1Length;
						length1=HID_Data[6];
						
					}
					
					
					if (HID_Data[7])
					{
						bTrk2 = true;
						
						if (bClearMaskDataStatus & 2)
						{
							StrTmp += "\r\nTrack 2: ";
							
							for (i=UnencryptedLength+11; i<UnencryptedLength+HID_Data[7]+11; i++)
							{		
								StringTmp.Format("%C",HID_Data[i]);
								StrTmp += StringTmp;
							}
							UnencryptedLength += HID_Data[7];
							StrTmp+="\r\t";	
						}
						
						
						if (bDecryptMode == 1) // TDES
						{
							if ((HID_Data[7] % 8) == 0)
								EncryptedTrack2Length = HID_Data[7];
							else
								EncryptedTrack2Length = (HID_Data[7] / 8 + 1) * 8;
						}
						
						else if (bDecryptMode == 2) // AES
						{
							if ((HID_Data[7] % 16) == 0)
								EncryptedTrack2Length = HID_Data[7];
							else
								EncryptedTrack2Length = (HID_Data[7] / 16 + 1) * 16;
						}
						
						
						DataLen2 = EncryptedTrack2Length;
						length2=HID_Data[7];
					}
					
					
					if (HID_Data[8])
					{
						bTrk3 = true;
						
						if (bClearMaskDataStatus & 4)
						{
							StrTmp += "\r\nTrack 3: ";
							
							for (i=UnencryptedLength+11; i<UnencryptedLength+HID_Data[8]+11; i++)
							{		
								StringTmp.Format("%C",HID_Data[i]);
								StrTmp += StringTmp;
							}
							UnencryptedLength += HID_Data[8];
						}
						
						
						if (bDecryptMode == 1) // TDES
						{
							if ((HID_Data[8] % 8) == 0)
								EncryptedTrack3Length = HID_Data[8];
							else
								EncryptedTrack3Length = (HID_Data[8] / 8 + 1) * 8;
						}
						
						else if (bDecryptMode == 2) // AES
						{
							if ((HID_Data[8] % 16) == 0)
								EncryptedTrack3Length = HID_Data[8];
							else
								EncryptedTrack3Length = (HID_Data[8] / 16 + 1) * 16;
						}
						
						
						DataLen3 = EncryptedTrack3Length;
						length3=HID_Data[8];
					}
					
					if (bTrk1)
						for (i = 0; i<EncryptedTrack1Length; i++)
							m_Track1Buffer[i] = HID_Data[i+UnencryptedLength+11];
						
						if (bTrk2)
							for (i = 0; i<EncryptedTrack2Length; i++)
								m_Track2Buffer[i] = HID_Data[i+UnencryptedLength+EncryptedTrack1Length+11];
							
							
							if (bTrk3)
								for (i = 0; i<EncryptedTrack3Length; i++)
									m_Track3Buffer[i] = HID_Data[i+UnencryptedLength+EncryptedTrack1Length+EncryptedTrack2Length+11];
								
								// Security Level=4
								if (bActivation)
								{	
									if (bDecryptMode == 1) // TDES
									{
										for (i = 0; i<8; i++)
											m_SessionIDBuffer[i] = HID_Data[i+UnencryptedLength+EncryptedTrack1Length+EncryptedTrack2Length+EncryptedTrack3Length+11];
									}
									
									else if (bDecryptMode == 2) // AES
									{
										for (i = 0; i<16; i++)
											m_SessionIDBuffer[i] = HID_Data[i+UnencryptedLength+EncryptedTrack1Length+EncryptedTrack2Length+EncryptedTrack3Length+11];
									}
								}
								
								
								/*
								Encrypted data sent status
								bit 0: if 1-tk1 encrypted data present 
								bit 1: if 1-tk2 encrypted data present
								bit 2: if 1-tk3 encrypted data present
								bit 3: if 1-tk1 hash data present
								bit 4: if 1-tk2 hash data present
								bit 5: if 1-tk3 hash data present
								Bit 6: if 1-session ID present 
								Bit 7: if 1-KSN present
								*/
								BYTE bEncryptedDataStatus = HID_Data[10];		
								
								
								bDecryption = true;	
								
								//GetDlgItem(IDC_COMMAND)->SetWindowText(StrTmp);
								
								
								for(i=0; i<10; i++)	
									m_nksn[i] = glm_nksn[i];			
								
								//Initial key
								if (!bIK)
								{
									m_str_initial_key = StrInitialKey;
									len = m_str_initial_key.GetLength();
									
									for(i=0; i<len/2; i++)							
										m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
								}
								
								Decryption();
				}
				
				
				// Raw Data Output Format
				else if (EncodingType == 0x84)				
				{
					StrTmp += "Reader Output: (Raw Data Enhanced Output Format)";						
					
					for (i=0; i<10; i++)
						glm_nksn[i] = HID_Data[i+HID_Data_Length-13];
					
					for (i=1; i<HID_Data_Length; i++)
					{		
						StringTmp.Format("%02X",HID_Data[i]);
						StrTmp += StringTmp;
					}
					
					
					if (HID_Data[6])
					{
						bTrk1 = true;
						
						if (bDecryptMode == 1) // TDES
						{
							if ((HID_Data[6] % 8) == 0)
								EncryptedTrack1Length = HID_Data[6];
							else
								EncryptedTrack1Length = (HID_Data[6]/ 8 + 1) * 8;
						}
						
						else if (bDecryptMode == 2) // AES
						{
							if ((HID_Data[6] % 16) == 0)
								EncryptedTrack1Length = HID_Data[6];
							else
								EncryptedTrack1Length = (HID_Data[6] / 16 + 1) * 16;
						}
						
						
						DataLen1 = EncryptedTrack1Length;
						length1=HID_Data[6];
						
					}
					
					
					if (HID_Data[7])
					{
						bTrk2 = true;
						
						if (bDecryptMode == 1) // TDES
						{
							if ((HID_Data[7] % 8) == 0)
								EncryptedTrack2Length = HID_Data[7];
							else
								EncryptedTrack2Length = (HID_Data[7] / 8 + 1) * 8;
						}
						
						else if (bDecryptMode == 2) // AES
						{
							if ((HID_Data[7] % 16) == 0)
								EncryptedTrack2Length = HID_Data[7];
							else
								EncryptedTrack2Length = (HID_Data[7] / 16 + 1) * 16;
						}
						
						
						DataLen2 = EncryptedTrack2Length;
						length2=HID_Data[7];
					}
					
					
					if (HID_Data[8])
					{
						bTrk3 = true;
						
						if (bDecryptMode == 1) // TDES
						{
							if ((HID_Data[8] % 8) == 0)
								EncryptedTrack3Length = HID_Data[8];
							else
								EncryptedTrack3Length = (HID_Data[8] / 8 + 1) * 8;
						}
						
						else if (bDecryptMode == 2) // AES
						{
							if ((HID_Data[8] % 16) == 0)
								EncryptedTrack3Length = HID_Data[8];
							else
								EncryptedTrack3Length = (HID_Data[8] / 16 + 1) * 16;
						}
						
						
						DataLen3 = EncryptedTrack3Length;
						length3=HID_Data[8];
					}
					
					
					if (bTrk1)
						for (i = 0; i<EncryptedTrack1Length; i++)
							m_Track1Buffer[i] = HID_Data[i+11];
						
						if (bTrk2)
							for (i = 0; i<EncryptedTrack2Length; i++)
								m_Track2Buffer[i] = HID_Data[i+EncryptedTrack1Length+11];
							
							
							if (bTrk3)
								for (i = 0; i<EncryptedTrack3Length; i++)
									m_Track3Buffer[i] = HID_Data[i+EncryptedTrack1Length+EncryptedTrack2Length+11];
								
								// Security Level=4
								if (bActivation)
								{	
									if (bDecryptMode == 1) // TDES
									{
										for (i = 0; i<8; i++)
											m_SessionIDBuffer[i] = HID_Data[i+EncryptedTrack1Length+EncryptedTrack2Length+EncryptedTrack3Length+11];
									}
									
									else if (bDecryptMode == 2) // AES
									{
										for (i = 0; i<16; i++)
											m_SessionIDBuffer[i] = HID_Data[i+EncryptedTrack1Length+EncryptedTrack2Length+EncryptedTrack3Length+11];
									}
								}
								
								/*
								Encrypted data sent status
								bit 0: if 1-tk1 encrypted data present 
								bit 1: if 1-tk2 encrypted data present
								bit 2: if 1-tk3 encrypted data present
								bit 3: if 1-tk1 hash data present
								bit 4: if 1-tk2 hash data present
								bit 5: if 1-tk3 hash data present
								Bit 6: if 1-session ID present 
								Bit 7: if 1-KSN present
								*/
								BYTE bEncryptedDataStatus = HID_Data[10];		
								
								
								bDecryption = true;	
								
								GetDlgItem(IDC_COMMAND)->SetWindowText(StrTmp);
								
								
								for(i=0; i<10; i++)	
									m_nksn[i] = glm_nksn[i];			
								
								//Initial key
								if (!bIK)
								{
									m_str_initial_key = StrInitialKey;
									len = m_str_initial_key.GetLength();
									
									for(i=0; i<len/2; i++)							
										m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
								}
								
								Decryption();
				}
			}
			
			
		}
		
		else	// USB KB
		{
			
			GetDlgItem(IDC_COMMAND)->GetWindowText(StrUSBKB);
			USBKB_Data_Length = StrUSBKB.GetLength();
			if(USBKB_Data_Length==0)
			{	MessageBox("No Data to Decrypt");	GetDlgItem(IDC_COMMAND)->SetFocus();return;}
			CString temp=StrUSBKB;
			if (USBKB_Data_Length > 0)
			{		
				
				int Length;
				BYTE TempData[1000];
				BYTE TempLRC=0;
				BYTE TempCheckSum=0;
				CString StrTemp;
				for(k=0;k<30;k++)
				{
					if((StrUSBKB.GetAt(k)=='0'&&StrUSBKB.GetAt(k+1)=='2')&&((StrUSBKB.GetAt(k+7)<='4'&&StrUSBKB.GetAt(k+6)>='0')||(StrUSBKB.GetAt(k+7)<='4'&&StrUSBKB.GetAt(k+6)>='8')))
						break;
				}
				
				for (int j=0;j<10; j++)
					USBKB_Data[j] = asctohex(StrUSBKB.GetAt(2*j+k),StrUSBKB.GetAt(2*j+k+1));
				
				
				// Check Length
				Length = USBKB_Data[2]*256 + USBKB_Data[1];	
				
				int templength=USBKB_Data_Length-k-12-Length;
		     	if(templength>15||k>15||StrUSBKB.GetAt(0)!='0'||StrUSBKB.GetAt(1)!='2'||StrUSBKB.GetAt(USBKB_Data_Length-2)!='0'||StrUSBKB.GetAt(USBKB_Data_Length-1)!='3')
				{
					MessageBox("Data Error");	GetDlgItem(IDC_COMMAND)->SetFocus(); return;
				}
				
				for (i=0; i<USBKB_Data_Length; i++)
					TempData[i] = StrUSBKB.GetAt(i);
				
				
				
				
				
				EncodingType = USBKB_Data[3];
				
				if (EncodingType < 0x80)
				{
					// Non ISO/ABA Data Output Format
					if (0)
					{
						StrTmp = "Reader Output: (Non ISO/ABA Data Output Format)\r\n";																
						if (USBKB_Data[5])										
						{StrTmp += StrUSBKB.Mid(16+k,USBKB_Data[5]);						
						StrTmp+="\r\t";}
						if (USBKB_Data[6])
						{	StrTmp += StrUSBKB.Mid(16+k+USBKB_Data[5],USBKB_Data[6]);						
						StrTmp+="\r\t";	}
						if (USBKB_Data[7])
							StrTmp += StrUSBKB.Mid(16+k+USBKB_Data[5]+USBKB_Data[6],USBKB_Data[7]);		
						
						
						
						
						GetDlgItem(IDC_RESP) -> SetWindowText(StrTmp);
					}
					
					// ISO/ABA Data Output Format
					else if (EncodingType == 0||(EncodingType == 1) || (EncodingType == 3))				
					{			
						// Security Level=4
						type0=1;
						if (bActivation)
							shiftSize = 8;
						else
							shiftSize = 0;
						
						if (bDecryptMode == 1) // TDES
						{
							if (((USBKB_Data[5]+USBKB_Data[6]+shiftSize)%8) == 0)
								EncryptedTrackLength = USBKB_Data[5]+USBKB_Data[6]+shiftSize;
							else
								EncryptedTrackLength = ((USBKB_Data[5]+USBKB_Data[6]+shiftSize)/8 + 1)*8; 
						}
						
						else if (bDecryptMode == 2) // AES
						{
							if (((USBKB_Data[5]+USBKB_Data[6]+shiftSize)%16) == 0)
								EncryptedTrackLength = USBKB_Data[5]+USBKB_Data[6]+shiftSize;
							else
								EncryptedTrackLength = ((USBKB_Data[5]+USBKB_Data[6]+shiftSize)/16 + 1)*16; 
							
						}
						
						DataLen = EncryptedTrackLength;
						length5= USBKB_Data[5]+USBKB_Data[6]+shiftSize;
						
						UnencryptedLength = USBKB_Data[5]+USBKB_Data[6]+USBKB_Data[7];
						
						for (i = 0; i<EncryptedTrackLength; i++)
							m_Track1Buffer[i] = asctohex(StrUSBKB.GetAt(UnencryptedLength+16+k+2*i),StrUSBKB.GetAt(UnencryptedLength+17+k+2*i));
						
						
						
						
						
						for (i=0; i<10; i++)			
							glm_nksn[i] = asctohex(StrUSBKB.GetAt(USBKB_Data_Length-26+2*i-templength),StrUSBKB.GetAt(USBKB_Data_Length-25+2*i-templength));	
						
						bTrk1 = true;
						bDecryption = true;	
						
						for(i=0; i<10; i++)	
							m_nksn[i] = glm_nksn[i];			
						
						//Initial key
						if (!bIK)
						{
							m_str_initial_key = StrInitialKey;
							len = m_str_initial_key.GetLength();
							
							for(i=0; i<len/2; i++)							
								m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
						}
						
						counter = m_nksn[9] | (m_nksn[8] << 8) | ((m_nksn[7] & 0x1f) << 16) ;
						if(!counter) 
						{
							berror = 1;
							MessageBox("The KSN can not be 0", "Warning", MB_ICONWARNING);	
							return;
						}
						
						//GetInitalKey(m_nksn, m_nderivation_key, m_ninitial_key);
						GetIK(m_nksn, m_nderivation_key, m_ninitial_key, ET_TDES_DUKPT);
						
						Decryption();
						
					}
					
					
					// Raw Data Output Format
					else if (EncodingType == 4)				
					{			
						// Security Level=4
						if (bActivation)
							shiftSize = 8;
						else
							shiftSize = 0;
						
						if (bDecryptMode == 1) // TDES
						{
							if (((USBKB_Data[5]+USBKB_Data[6]+USBKB_Data[7]+shiftSize)%8) == 0)
								EncryptedTrackLength = USBKB_Data[5]+USBKB_Data[6]+USBKB_Data[7]+shiftSize;
							else
								EncryptedTrackLength = ((USBKB_Data[5]+USBKB_Data[6]+USBKB_Data[7]+shiftSize)/8 + 1)*8; 
						}
						
						else if (bDecryptMode == 2) // AES
						{
							if (((USBKB_Data[5]+USBKB_Data[6]+USBKB_Data[7]+shiftSize)%16) == 0)
								EncryptedTrackLength = USBKB_Data[5]+USBKB_Data[6]+USBKB_Data[7]+shiftSize;
							else
								EncryptedTrackLength = ((USBKB_Data[5]+USBKB_Data[6]+USBKB_Data[7]+shiftSize)/16 + 1)*16; 
							
						}
						
						DataLen = EncryptedTrackLength;
						length5=USBKB_Data[5]+USBKB_Data[6]+USBKB_Data[7]+shiftSize;
						for (i = 0; i<EncryptedTrackLength; i++)
							m_Track1Buffer[i] = asctohex(StrUSBKB.GetAt(16+k+2*i),StrUSBKB.GetAt(17+k+2*i));
						
						
						for (i=0; i<10; i++)			
							glm_nksn[i] = asctohex(StrUSBKB.GetAt(USBKB_Data_Length-26+2*i-templength),StrUSBKB.GetAt(USBKB_Data_Length-25+2*i-templength));	
						
						
						bTrk1 = true;
						bDecryption = true;	
						
						for(i=0; i<10; i++)	
							m_nksn[i] = glm_nksn[i];			
						
						//Initial key
						if (!bIK)
						{
							m_str_initial_key = StrInitialKey;
							len = m_str_initial_key.GetLength();
							
							for(i=0; i<len/2; i++)							
								m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
						}
						
						Decryption();
						
					}
				}
				
				
				
				else // if (EncodingType >= 0x80)
				{
					// Non ISO/ABA Data Output Format
					if (0)
					{
					/*
					Encrypted data sent status
					bit 0: if 1-tk1 encrypted data present 
					bit 1: if 1-tk2 encrypted data present
					bit 2: if 1-tk3 encrypted data present
					bit 3: if 1-tk1 hash data present
					bit 4: if 1-tk2 hash data present
					bit 5: if 1-tk3 hash data present
					Bit 6: if 1-session ID present 
					Bit 7: if 1-KSN present
						*/
						BYTE bEncryptedDataStatus = USBKB_Data[9];		
						
						if ((bEncryptedDataStatus & 0x07) > 0)
						{				
							
							if (USBKB_Data[5])
							{
								bTrk1 = true;													
								
								if (bDecryptMode == 1) // TDES
								{
									if ((USBKB_Data[5]% 8) == 0)
										EncryptedTrack1Length = USBKB_Data[5];
									else
										EncryptedTrack1Length = (USBKB_Data[5] / 8 + 1) * 8;
								}
								
								else if (bDecryptMode == 2) // AES
								{
									if ((USBKB_Data[5] % 16) == 0)
										EncryptedTrack1Length = USBKB_Data[5];
									else
										EncryptedTrack1Length = (USBKB_Data[5] / 16 + 1) * 16;
								}
								
								for (i = 0; i<EncryptedTrack1Length; i++)
									m_Track1Buffer[i] = asctohex(StrUSBKB.GetAt(k+20+2*i),StrUSBKB.GetAt(k+21+2*i));
								
								DataLen1 = EncryptedTrack1Length;
								length1=USBKB_Data[5];
								
							}
							
							
							if (USBKB_Data[6])
							{
								bTrk2 = true;
								
								if (bDecryptMode == 1) // TDES
								{
									if ((USBKB_Data[6] % 8) == 0)
										EncryptedTrack2Length = USBKB_Data[6];
									else
										EncryptedTrack2Length = (USBKB_Data[6] / 8 + 1) * 8;
								}
								
								else if (bDecryptMode == 2) // AES
								{
									if ((USBKB_Data[6] % 16) == 0)
										EncryptedTrack2Length = USBKB_Data[6];
									else
										EncryptedTrack2Length = (USBKB_Data[6] / 16 + 1) * 16;
								}
								
								for (i = 0; i<EncryptedTrack2Length; i++)
									m_Track2Buffer[i] = asctohex(StrUSBKB.GetAt(EncryptedTrack1Length*2+k+20+2*i),StrUSBKB.GetAt(EncryptedTrack1Length*2+k+21+2*i));
								
								DataLen2 = EncryptedTrack2Length;
								length2=USBKB_Data[6];
							}
							
							
							if (USBKB_Data[7])
							{
								bTrk3 = true;
								
								if (bDecryptMode == 1) // TDES
								{
									if ((USBKB_Data[7] % 8) == 0)
										EncryptedTrack3Length = USBKB_Data[7];
									else
										EncryptedTrack3Length = (USBKB_Data[7] / 8 + 1) * 8;
								}
								
								else if (bDecryptMode == 2) // AES
								{
									if ((USBKB_Data[7] % 16) == 0)
										EncryptedTrack3Length = USBKB_Data[7];
									else
										EncryptedTrack3Length = (USBKB_Data[7] / 16 + 1) * 16;
								}
								
								for (i = 0; i<EncryptedTrack3Length; i++)
									m_Track3Buffer[i] = asctohex(StrUSBKB.GetAt(EncryptedTrack1Length*2+EncryptedTrack2Length*2+k+20+2*i),StrUSBKB.GetAt(EncryptedTrack1Length*2+EncryptedTrack2Length*2+k+21+2*i));
								
								DataLen3 = EncryptedTrack3Length;
								length3=USBKB_Data[7];
							}
							
							// Security Level=4
							if (bActivation)
							{	
								if (bDecryptMode == 1) // TDES
								{
									for (i = 0; i<8; i++)
										m_SessionIDBuffer[i] = asctohex(StrUSBKB.GetAt(EncryptedTrack1Length*2+EncryptedTrack2Length*2+EncryptedTrack3Length*2+20+2*i),StrUSBKB.GetAt(EncryptedTrack1Length*2+EncryptedTrack2Length*2+EncryptedTrack3Length*2+21+2*i));
								}
								
								else if (bDecryptMode == 2) // AES
								{
									for (i = 0; i<16; i++)
										m_SessionIDBuffer[i] = asctohex(StrUSBKB.GetAt(EncryptedTrack1Length*2+EncryptedTrack2Length*2+EncryptedTrack3Length*2+20+2*i),StrUSBKB.GetAt(EncryptedTrack1Length*2+EncryptedTrack2Length*2+EncryptedTrack3Length*2+21+2*i));
								}
							}
							
							
							for (i=0; i<10; i++)			
								glm_nksn[i] = asctohex(StrUSBKB.GetAt(USBKB_Data_Length-26+2*i-templength),StrUSBKB.GetAt(USBKB_Data_Length-25+2*i-templength));	
							
							
							bDecryption = true;	
							
							for(i=0; i<10; i++)	
								m_nksn[i] = glm_nksn[i];			
							
							//Initial key
							if (!bIK)
							{
								m_str_initial_key = StrInitialKey;
								len = m_str_initial_key.GetLength();
								
								for(i=0; i<len/2; i++)							
									m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
							}
							
							
							Decryption();
							
						}
						
						else
						{
							
							
							StrTmp = "Reader Output: (Non ISO/ABA Data Output Format)\r\n";																
							
							if (USBKB_Data[5])										
							{	StrTmp += StrUSBKB.Mid(20+k,USBKB_Data[5]);	StrTmp+="\r\t";	}						
							if (USBKB_Data[6])
							{	StrTmp += StrUSBKB.Mid(20+k+USBKB_Data[5],USBKB_Data[6]);						
							StrTmp+="\r\t";	}
							if (USBKB_Data[7])
								StrTmp += StrUSBKB.Mid(20+k+USBKB_Data[5]+USBKB_Data[6],USBKB_Data[7]);		
							
							
							
							
							
							GetDlgItem(IDC_RESP) -> SetWindowText(StrTmp);
						}
					}
					
					
					// ISO/ABA Data Output Format
					else if (EncodingType == 0x80||(EncodingType == 0x81) || (EncodingType == 0x83))				
					{		
						
					/*
					Clear/mask data sent status byte:
					bit 0: 1--- if TK1 clear/mask data present 
					bit 1: 1--- if TK2 clear/mask data present
					bit 2: 1--- if TK3 clear/mask data present
					Bit 3:0-0
					Bit 4:0-0
					Bit 5:0-0
						*/
						BYTE bClearMaskDataStatus = USBKB_Data[8];
						
						
						//		UnencryptedLength = USBKB_Data[6]+USBKB_Data[7]+USBKB_Data[8];	
						
						if (USBKB_Data[5])
						{
							bTrk1 = true;
							
							if (bClearMaskDataStatus & 1)							
								UnencryptedLength += USBKB_Data[5];
							
							
							if (bDecryptMode == 1) // TDES
							{
								if ((USBKB_Data[5] % 8) == 0)
									EncryptedTrack1Length = USBKB_Data[5];
								else
									EncryptedTrack1Length = (USBKB_Data[5] / 8 + 1) * 8;
							}
							
							else if (bDecryptMode == 2) // AES
							{
								if ((USBKB_Data[5] % 16) == 0)
									EncryptedTrack1Length = USBKB_Data[5];
								else
									EncryptedTrack1Length = (USBKB_Data[5] / 16 + 1) * 16;
							}													
							
							DataLen1 = EncryptedTrack1Length;
							length1=USBKB_Data[5];
							
						}
						
						
						if (USBKB_Data[6])
						{
							bTrk2 = true;
							
							if (bClearMaskDataStatus & 2)							
								UnencryptedLength += USBKB_Data[6];
							
							if (bDecryptMode == 1) // TDES
							{
								if ((USBKB_Data[6] % 8) == 0)
									EncryptedTrack2Length = USBKB_Data[6];
								else
									EncryptedTrack2Length = (USBKB_Data[6] / 8 + 1) * 8;
							}
							
							else if (bDecryptMode == 2) // AES
							{
								if ((USBKB_Data[6] % 16) == 0)
									EncryptedTrack2Length = USBKB_Data[6];
								else
									EncryptedTrack2Length = (USBKB_Data[6] / 16 + 1) * 16;
							}
							
							
							DataLen2 = EncryptedTrack2Length;
							length2=USBKB_Data[6];
						}
						
						
						if (USBKB_Data[7])
						{
							bTrk3 = true;
							
							if (bClearMaskDataStatus & 4)							
								UnencryptedLength += USBKB_Data[7];
							
							if (bDecryptMode == 1) // TDES
							{
								if ((USBKB_Data[7] % 8) == 0)
									EncryptedTrack3Length = USBKB_Data[7];
								else
									EncryptedTrack3Length = (USBKB_Data[7] / 8 + 1) * 8;
							}
							
							else if (bDecryptMode == 2) // AES
							{
								if ((USBKB_Data[7] % 16) == 0)
									EncryptedTrack3Length = USBKB_Data[7];
								else
									EncryptedTrack3Length = (USBKB_Data[7] / 16 + 1) * 16;
							}
							
							
							DataLen3 = EncryptedTrack3Length;
							length3=USBKB_Data[7];
						}
						
						
						if (bTrk1)
							for (i = 0; i<EncryptedTrack1Length; i++)
								m_Track1Buffer[i] = asctohex(StrUSBKB.GetAt(UnencryptedLength+20+k+2*i),StrUSBKB.GetAt(UnencryptedLength+k+21+2*i));
							
							if (bTrk2)
								for (i = 0; i<EncryptedTrack2Length; i++)
									m_Track2Buffer[i] = asctohex(StrUSBKB.GetAt(UnencryptedLength+EncryptedTrack1Length*2+k+20+2*i),StrUSBKB.GetAt(UnencryptedLength+EncryptedTrack1Length*2+k+21+2*i));
								
								
								if (bTrk3)
									for (i = 0; i<EncryptedTrack3Length; i++)
										m_Track3Buffer[i] = asctohex(StrUSBKB.GetAt(UnencryptedLength+EncryptedTrack1Length*2+EncryptedTrack2Length*2+k+20+2*i),StrUSBKB.GetAt(UnencryptedLength+EncryptedTrack1Length*2+EncryptedTrack2Length*2+k+21+2*i));
									
									
									
									// Security Level=4
									if (bActivation)
									{	
										if (bDecryptMode == 1) // TDES
										{
											for (i = 0; i<8; i++)
												m_SessionIDBuffer[i] = asctohex(StrUSBKB.GetAt(UnencryptedLength+EncryptedTrack1Length*2+EncryptedTrack2Length*2+EncryptedTrack3Length*2+20+k+2*i),StrUSBKB.GetAt(UnencryptedLength+EncryptedTrack1Length*2+EncryptedTrack2Length*2+EncryptedTrack3Length*2+k+21+2*i));
										}
										
										else if (bDecryptMode == 2) // AES
										{
											for (i = 0; i<16; i++)
												m_SessionIDBuffer[i] = asctohex(StrUSBKB.GetAt(UnencryptedLength+EncryptedTrack1Length*2+k+EncryptedTrack2Length*2+EncryptedTrack3Length*2+20+2*i),StrUSBKB.GetAt(UnencryptedLength+EncryptedTrack1Length*2+k+EncryptedTrack2Length*2+EncryptedTrack3Length*2+21+2*i));
										}
									}
									
									
									for (i=0; i<10; i++)			
										glm_nksn[i] = asctohex(StrUSBKB.GetAt(USBKB_Data_Length-26-templength+2*i),StrUSBKB.GetAt(USBKB_Data_Length-25-templength+2*i));
									
									
									bDecryption = true;	
									
									for(i=0; i<10; i++)	
										m_nksn[i] = glm_nksn[i];			
									
									//Initial key
									if (!bIK)
									{
										m_str_initial_key = StrInitialKey;
										len = m_str_initial_key.GetLength();
										
										for(i=0; i<len/2; i++)							
											m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
									}
									
									counter = m_nksn[9] | (m_nksn[8] << 8) | ((m_nksn[7] & 0x1f) << 16) ;
									if(!counter) 
									{
										berror = 1;
										MessageBox("The KSN can not be 0", "Warning", MB_ICONWARNING);			
									}
									
									
										GetIK(m_nksn, m_nderivation_key, m_ninitial_key, ET_TDES_DUKPT);
									
									Decryption();
									
									
					}
					
					
					// Raw Data Output Format
					else if (EncodingType == 0x84)				
					{	
						
						if (USBKB_Data[5])
						{
							bTrk1 = true;													
							
							if (bDecryptMode == 1) // TDES
							{
								if ((USBKB_Data[5] % 8) == 0)
									EncryptedTrack1Length = USBKB_Data[5];
								else
									EncryptedTrack1Length = (USBKB_Data[5] / 8 + 1) * 8;
							}
							
							else if (bDecryptMode == 2) // AES
							{
								if ((USBKB_Data[5] % 16) == 0)
									EncryptedTrack1Length = USBKB_Data[5];
								else
									EncryptedTrack1Length = (USBKB_Data[5] / 16 + 1) * 16;
							}
							
							for (i = 0; i<EncryptedTrack1Length; i++)
								m_Track1Buffer[i] = asctohex(StrUSBKB.GetAt(20+k+2*i),StrUSBKB.GetAt(21+k+2*i));
							
							DataLen1 = EncryptedTrack1Length;
							length1=USBKB_Data[5];
						}
						
						
						if (USBKB_Data[6])
						{
							bTrk2 = true;
							
							if (bDecryptMode == 1) // TDES
							{
								if ((USBKB_Data[6] % 8) == 0)
									EncryptedTrack2Length = USBKB_Data[6];
								else
									EncryptedTrack2Length = (USBKB_Data[6] / 8 + 1) * 8;
							}
							
							else if (bDecryptMode == 2) // AES
							{
								if ((USBKB_Data[6] % 16) == 0)
									EncryptedTrack2Length = USBKB_Data[6];
								else
									EncryptedTrack2Length = (USBKB_Data[6] / 16 + 1) * 16;
							}
							
							for (i = 0; i<EncryptedTrack2Length; i++)
								m_Track2Buffer[i] = asctohex(StrUSBKB.GetAt(EncryptedTrack1Length*2+k+20+2*i),StrUSBKB.GetAt(EncryptedTrack1Length*2+k+21+2*i));
							
							DataLen2 = EncryptedTrack2Length;
							length2=USBKB_Data[6];
						}
						
						
						if (USBKB_Data[7])
						{
							bTrk3 = true;
							
							if (bDecryptMode == 1) // TDES
							{
								if ((USBKB_Data[7] % 8) == 0)
									EncryptedTrack3Length = USBKB_Data[7];
								else
									EncryptedTrack3Length = (USBKB_Data[7] / 8 + 1) * 8;
							}
							
							else if (bDecryptMode == 2) // AES
							{
								if ((USBKB_Data[7] % 16) == 0)
									EncryptedTrack3Length = USBKB_Data[7];
								else
									EncryptedTrack3Length = (USBKB_Data[7] / 16 + 1) * 16;
							}
							
							for (i = 0; i<EncryptedTrack3Length; i++)
								m_Track3Buffer[i] = asctohex(StrUSBKB.GetAt(EncryptedTrack1Length*2+EncryptedTrack2Length*2+k+20+2*i),StrUSBKB.GetAt(EncryptedTrack1Length*2+EncryptedTrack2Length*2+21+k+2*i));
							
							DataLen3 = EncryptedTrack3Length;
							length3=USBKB_Data[7];
						}
						
						// Security Level=4
						if (bActivation)
						{	
							if (bDecryptMode == 1) // TDES
							{
								for (i = 0; i<8; i++)
									m_SessionIDBuffer[i] = asctohex(StrUSBKB.GetAt(EncryptedTrack1Length*2+EncryptedTrack2Length*2+EncryptedTrack3Length*2+20+2*i),StrUSBKB.GetAt(EncryptedTrack1Length*2+EncryptedTrack2Length*2+EncryptedTrack3Length*2+21+2*i));
							}
							
							else if (bDecryptMode == 2) // AES
							{
								for (i = 0; i<16; i++)
									m_SessionIDBuffer[i] = asctohex(StrUSBKB.GetAt(EncryptedTrack1Length*2+EncryptedTrack2Length*2+EncryptedTrack3Length*2+20+2*i),StrUSBKB.GetAt(EncryptedTrack1Length*2+EncryptedTrack2Length*2+EncryptedTrack3Length*2+21+2*i));
							}
						}
						
						
						for (i=0; i<10; i++)			
							glm_nksn[i] = asctohex(StrUSBKB.GetAt(USBKB_Data_Length-26+2*i-templength),StrUSBKB.GetAt(USBKB_Data_Length-25+2*i-templength));	
						
						
						bDecryption = true;	
						
						for(i=0; i<10; i++)	
							m_nksn[i] = glm_nksn[i];			
						
						//Initial key
						if (!bIK)
						{
							m_str_initial_key = StrInitialKey;
							len = m_str_initial_key.GetLength();
							
							for(i=0; i<len/2; i++)							
								m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
						}
						
						Decryption();
						
					}
				}
				
			}
			GetDlgItem(IDC_COMMAND)->SetWindowText(temp);
		}
	}
	
	
	else
	{
		if (!KBMode)	// ID Tech USB HID Mode
		{
			if ((nReader == 1) || (nReader == 2) || (nReader == 3))
			{
				for (i=10; i<HID_Data_Length; i++)
				{		
					if (HID_Data[i] == 13)
						StrTmp += "\r\n";		
					else
					{
						StringTmp.Format("%C",(BYTE)HID_Data[i]);
						StrTmp += StringTmp;		
					}
				}
				GetDlgItem(IDC_COMMAND)->SetWindowText(StrTmp);
			}
			
			
			else if (nReader == 7)	
			{
				for (i=8; i<HID_Data_Length; i++)
				{		
					if (HID_Data[i] == 13)
						StrTmp += "\r\n";		
					else
					{
						StringTmp.Format("%C",(BYTE)HID_Data[i]);
						StrTmp += StringTmp;		
					}
				}
				GetDlgItem(IDC_COMMAND)->SetWindowText(StrTmp);
			}
			
			// Unknown reader type
			else
			{
				for (i=0; i<HID_Data_Length; i++)
				{		
					if (HID_Data[i] == 13)
						StrTmp += "\r\n";		
					else
					{
						StringTmp.Format("%C",(BYTE)HID_Data[i]);
						StrTmp += StringTmp;		
					}
				}
				GetDlgItem(IDC_COMMAND)->SetWindowText(StrTmp);
			}
			
		}
		
	}
	GetDlgItem(IDC_COMMAND)->SetFocus();
	
}
void CKeyInjectModuleDlg::OnExit() 
{
	OnCancel();
}


/**************************************************/
/* Methods of Main Menu
/**************************************************/
bool CKeyInjectModuleDlg::SendCommandRequest(byte* datapool, int outLength)
{
	CString strDevName, StrTmp;
	int	m_ulDevIndex = 0;
	int i, j;
	bool isFound = false;
	bool cmdSucceed = false;

	if(select_mode == COM_MODE)
	{
		sWaitReadCmd =true;

		
		int res = 0;
		res = sp_com.Write(datapool,outLength,100); //sp write
		if(res != outLength)
		{
			AfxMessageBox("Fail to send command!");
			GetDlgItem(IDC_RESP)->SetFocus();
	//		sp_com.Close();
			sWaitReadCmd =false;
			return cmdSucceed;
		}
		Sleep(300);
		BufferLength= sp_com.Read(CardDataBuffer, 512, 500);


		if (CardDataBuffer[0] == 6)
			cmdSucceed = true;


		// Show command text
		StrResponse = _T("CMD: ");
		for (i=0; i<outLength; i++)
		{
			StrTmp.Format("%02X ", datapool[i]);
			StrResponse += StrTmp;
		}

		for (i=BufferLength; i>0; i--)
		{
			if (CardDataBuffer[i] != 0)
				break;
		} 
		int LastByte=i;

		// Output all response
		StrResponse += _T("\r\nOUT: ");
		if(CardDataBuffer[0]==0x06&&CardDataBuffer[1]!=0x02)
		{
			StrTmp.Format("%02X ",CardDataBuffer[0]);
				StrResponse += StrTmp;
			
		}
		else
		{
			for (i=0; i<LastByte; i++)
			{
				if(CardDataBuffer[i]==0x03)
				{
	                int lrc=0;
					for(int k=1;k<=i;k++)
						lrc=lrc^CardDataBuffer[k];
					if(lrc==CardDataBuffer[i+1])
					{
					StrTmp.Format("%02X %02X ",CardDataBuffer[i],CardDataBuffer[i+1]);
					StrResponse += StrTmp;
					
					
					break;
					}
					else {
						StrTmp.Format("%02X ",CardDataBuffer[i]);
					StrResponse += StrTmp;
					}
					
				}
				else {
					StrTmp.Format("%02X ",CardDataBuffer[i]);
					StrResponse += StrTmp;
				
				}
			}

		}

		sWaitReadCmd =false;
	//	sp_com.Close();

		GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
		
	}
	else if(select_mode == USB_MODE)
		{
		INTERFACE_TYPE emMyItfType; 
		INTERFACE_TYPE emMyItfType2;

		emMyItfType2 = ITF_TYPE_USB_HID;
		CMSRItfUSBHID MSR(emMyItfType2);

		// Initiate all values
		for (i=0; i<BufferLength; i++)
			CardDataBuffer[i] = 0;

		// Scan for device interface
		for(m_ulDevIndex = 0; m_ulDevIndex <  20; m_ulDevIndex++)
		{
			if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
			{
				if(emMyItfType != emMyItfType2)
					continue;
				else
				{
					if(MSR.OpenMSRDevice(m_ulDevIndex))
					{
						Sleep(50); // make sure the device is not busy

						MSR.SendCommand(datapool, outLength, CardDataBuffer, &BufferLength);
						isFound = true;

						break;
					}
				}
			}
		}
		
		if(!isFound)
		{
			emMyItfType2 = ITF_TYPE_USB_HID_KB;
			
			CMSRItfUSBHID MSR(emMyItfType2);

			for(m_ulDevIndex = 0; m_ulDevIndex <20; m_ulDevIndex++)
			{
				if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
				{
					if(emMyItfType != emMyItfType2)
						continue;
					else
					{
						if(MSR.OpenMSRDevice(m_ulDevIndex))
						{
							Sleep(200); // make sure the device is not busy.

							MSR.SendCommand(datapool, outLength, CardDataBuffer, &BufferLength);
							isFound = true;

							break;
						}
					}
				}
			}		
		}

		if(!isFound)
			MessageBox("Fail to detect device!", _T("Error"), MB_OK);

		if (CardDataBuffer[0] == 6)
			cmdSucceed = true;


		// Show command text
		StrResponse = _T("CMD: ");
		for (i=0; i<outLength; i++)
		{
			StrTmp.Format("%02X ", datapool[i]);
			StrResponse += StrTmp;
		}

		for (i=BufferLength; i>0; i--)
		{
			if (CardDataBuffer[i] != 0)
				break;
		} 
		int LastByte=i;

		// Output all response
		StrResponse += _T("\r\nOUT: ");
		if(CardDataBuffer[0]==0x06&&CardDataBuffer[1]!=0x02)
		{
			StrTmp.Format("%02X ",CardDataBuffer[0]);
				StrResponse += StrTmp;
			
		}
		else
		{
			for (i=0; i<LastByte; i++)
			{
				if(CardDataBuffer[i]==0x03)
				{
	                int lrc=0;
					for(int k=1;k<=i;k++)
						lrc=lrc^CardDataBuffer[k];
					if(lrc==CardDataBuffer[i+1])
					{
					StrTmp.Format("%02X %02X ",CardDataBuffer[i],CardDataBuffer[i+1]);
					StrResponse += StrTmp;
					
					
					break;
					}
					else {
						StrTmp.Format("%02X ",CardDataBuffer[i]);
					StrResponse += StrTmp;
					}
					
				}
				else {
					StrTmp.Format("%02X ",CardDataBuffer[i]);
					StrResponse += StrTmp;
				
				}
			}

		}

		


		GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);

		MSR.CloseMSRDevice();
	}
	return cmdSucceed;
}

/**************************************************/
/* Events of Main Menu - General Setting
/**************************************************/
void CKeyInjectModuleDlg::OnMENUSetDefault() 
{
	const int outLength = 5;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x18;
	datapool[3] = 0x03;
	datapool[4] = 0x4A;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUReadConfiguration() 
{
	const int outLength = 5;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x52;
	datapool[2] = 0x1F;
	datapool[3] = 0x03;
	datapool[4] = 0x4C;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUReadFirmware() 
{
	bool cmdSucceed;
	const int outLength = 5;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x52;
	datapool[2] = 0x22;
	datapool[3] = 0x03;
	datapool[4] = 0x71;

	cmdSucceed = SendCommandRequest(datapool, outLength);

	if(cmdSucceed)
	{
		int i, j;
		CString StrResponse, StrTmp;
		
		// Get command request and response string
		GetDlgItem(IDC_RESP)->GetWindowText(StrResponse);

		// Get the end of card data
		for (i=BufferLength; i>0; i--)
			if (CardDataBuffer[i] != 0)
				break;

		// Append extra information
		StrResponse += "\r\nFirmware Version: ";
		for (j=2; j<i; j++)
		{
			StrTmp.Format("%C",CardDataBuffer[j]);
			StrResponse += StrTmp;
		}

		// Output with extra information
		GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
	}
}

void CKeyInjectModuleDlg::OnMENUBeeperOff() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x11;
	datapool[3] = 0x01;
	datapool[4] = 0x30;
	datapool[5] = 0x03;
	datapool[6] = 0x72;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUBeeperLow() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x11;
	datapool[3] = 0x01;
	datapool[4] = 0x31;
	datapool[5] = 0x03;
	datapool[6] = 0x73;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUBeeperHigh() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x11;
	datapool[3] = 0x01;
	datapool[4] = 0x32;
	datapool[5] = 0x03;
	datapool[6] = 0x70;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMSREnableID() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x1A;
	datapool[3] = 0x01;
	datapool[4] = 0x31;
	datapool[5] = 0x03;
	datapool[6] = 0x78;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMSRDisableID() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x1A;
	datapool[3] = 0x01;
	datapool[4] = 0x30;
	datapool[5] = 0x03;
	datapool[6] = 0x79;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnRawDataID() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x1D;
	datapool[3] = 0x01;
	datapool[4] = 0x30;
	datapool[5] = 0x03;
	datapool[6] = 0x7E;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUReadBothDirections() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x1D;
	datapool[3] = 0x01;
	datapool[4] = 0x31;
	datapool[5] = 0x03;
	datapool[6] = 0x7F;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUReadForwardDirection() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x1D;
	datapool[3] = 0x01;
	datapool[4] = 0x32;
	datapool[5] = 0x03;
	datapool[6] = 0x7C;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUReadBackwardDirection() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x1D;
	datapool[3] = 0x01;
	datapool[4] = 0x33;
	datapool[5] = 0x03;
	datapool[6] = 0x7D;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnSetPreamble0123456789ID() 
{
	const int outLength = 22;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0xD2;
	datapool[3] = 0x10;
	datapool[4] = 0x0f;
	datapool[5] = '0';
	datapool[6] = '1';
	datapool[7] = '2';
	datapool[8] = '3';
	datapool[9] = '4';
	datapool[10] = '5';
	datapool[11] = '6';
	datapool[12] = '7';
	datapool[13] = '8';
	datapool[14] = '9';
	datapool[15] = 'a';
	datapool[16] = 'b';
	datapool[17] = 'c';
	datapool[18] = 'd';
	datapool[19] = 'e';
	datapool[20] = 0x03;
	datapool[21] = 0xff;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnSetPostamble9876543210ID() 
{
	const int outLength = 22;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0xD3;
	datapool[3] = 0x10;
	datapool[4] = 0x0f;
	datapool[5] = 'e';
	datapool[6] = 'd';
	datapool[7] = 'c';
	datapool[8] = 'b';
	datapool[9] = 'a';
	datapool[10] = '9';
	datapool[11] = '8';
	datapool[12] = '7';
	datapool[13] = '6';
	datapool[14] = '5';
	datapool[15] = '4';
	datapool[16] = '3';
	datapool[17] = '2';
	datapool[18] = '1';
	datapool[19] = '0';
	datapool[20] = 0x03;
	datapool[21] = 0xfe;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUSetBufferMode() 
{
	// TODO: the result is not confirmed yet
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x1A;
	datapool[3] = 0x01;
	datapool[4] = 0x32;
	datapool[5] = 0x03;
	datapool[6] = 0x7B;

	SendCommandRequest(datapool, outLength);	
}

void CKeyInjectModuleDlg::OnMenuAtr() 
{
	// TODO: the result is not confirmed yet
	const int outLength = 6;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x50;
	datapool[2] = 0x01;
	datapool[3] = 0x30;
	datapool[4] = 0x03;
	datapool[5] = 0x60;

	SendCommandRequest(datapool, outLength);	
}

void CKeyInjectModuleDlg::OnMENUReadBufferedData() 
{
	// TODO: the result is not confirmed yet
/*
	bool cmdSucceed;
	const int outLength = 6;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x51;
	datapool[2] = 0x01;
	datapool[3] = 0x30;
	datapool[4] = 0x03;
	datapool[5] = 0x61;

	cmdSucceed = SendCommandRequest(datapool, outLength);

	if(cmdSucceed)
	{
		int i, j;
		CString StrResponse, StrTmp;

		// Get command request and response string
		GetDlgItem(IDC_RESP)->GetWindowText(StrResponse);

		// Get the end of card data
		for (i=BufferLength; i>0; i--)
			if (CardDataBuffer[i] != 0)
				break;

		// Append extra information
		StrResponse += "\r\n\r\nBuffered Data: \r\n";

		if (!HIDMode)			// ID Tech USB HID Mode
		{
			for (j=11; j<i-1; j++)
			{
				StrTmp.Format("%C",CardDataBuffer[j]);
				StrResponse += StrTmp;
			}
		}
		else if (HIDMode == 2)	// MagTek USB HID Mode
		{
			for (j=9; j<i-1; j++)
			{
				StrTmp.Format("%C",CardDataBuffer[j]);
				StrResponse += StrTmp;
			}
		}

		// Output with extra information
		GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
	}
*/

	INTERFACE_TYPE emMyItfType; 
	INTERFACE_TYPE emMyItfType2;
	CString strDevName,StrResponse,StrTmp;
	int		m_ulDevIndex = 0;
	BYTE BufferTmp[500];
	ULONG	BufferLength = 500;
	int i, j;

	emMyItfType2 = ITF_TYPE_USB_HID;

	CMSRItfUSBHID	MSR(emMyItfType2);

	for (i=0; i<500; i++)
		BufferTmp[i] = 0;

	BYTE datapool[6];
	datapool[0] = 0x02;
	datapool[1] = 0x51;
	datapool[2] = 0x01;
	datapool[3] = 0x30;
	datapool[4] = 0x03;
	datapool[5] = 0x61;
	int outLength = 6;

	for(m_ulDevIndex = 0; m_ulDevIndex < 10; m_ulDevIndex++)
	{
		if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
		{
			if(emMyItfType != emMyItfType2)			
				continue;
			else
			{
				if(MSR.OpenMSRDevice(m_ulDevIndex))
				{
					Sleep(50); // make sure the device is not busy.
					MSR.SendCommand(datapool,outLength,BufferTmp,&BufferLength);
				}
			}
		}
	}
	if(m_ulDevIndex >= 10){
	  emMyItfType2 = ITF_TYPE_USB_HID_KB;

	  CMSRItfUSBHID	MSR(emMyItfType2);
	  for(m_ulDevIndex = 0; m_ulDevIndex < 10; m_ulDevIndex++)
	  {
		if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
		{
			if(emMyItfType != emMyItfType2)
				continue;
			else
			{
				if(MSR.OpenMSRDevice(m_ulDevIndex))
				{
					Sleep(50); // make sure the device is not busy.
					MSR.SendCommand(datapool,outLength,BufferTmp,&BufferLength);
				}
			}
		}
	  }		
	}
//	if ( BufferTmp[0] == 6)
//		MessageBox("Read Buffered Data command was sent successfully!","Status",MB_OK);				
//	else
//		MessageBox("Fail to Read Buffered Data!",_T("Error"),MB_OK);				
	
	for (i=BufferLength; i>0; i--)
		if (BufferTmp[i] != 0)
			break;

	if (( BufferTmp[0] == 6) || ( BufferTmp[0] == 21))
		for (j=0; j<i+1; j++)
		{
			StrTmp.Format("%02X ",BufferTmp[j]);
			StrResponse += StrTmp;
		}

	if (( BufferTmp[0] == 6) && ( i > 3))
	{
		StrResponse += "\r\n\r\nBuffered Data: \r\n";

		if (!KBMode)	// ID Tech USB HID Mode
			for (j=11; j<i-1; j++)
			{
				StrTmp.Format("%C",BufferTmp[j]);
				StrResponse += StrTmp;
			}
		else if (KBMode == 2)	// MagTek USB HID Mode
			for (j=9; j<i-1; j++)
			{
				StrTmp.Format("%C",BufferTmp[j]);
				StrResponse += StrTmp;
			}
	}

	//Show command text
	StrResponse = "CMD: 02 51 01 30 03 61\r\nOUT: " + StrResponse;
	GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
	MSR.CloseMSRDevice();					

}

void CKeyInjectModuleDlg::OnHIDMagTMode() 
{
	bool cmdSucceed;
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x23;
	datapool[3] = 0x01;
	datapool[4] = 0x31;
	datapool[5] = 0x03;
	datapool[6] = 0x41;

	cmdSucceed = SendCommandRequest(datapool, outLength);

//	if(cmdSucceed)
		KBMode = 2;	// MagTek USB HID Mode

	GetDlgItem(IDC_SCRIPT)->ShowWindow(FALSE);
}

void CKeyInjectModuleDlg::OnHIDIDTMode() 
{
	
  
	openstart1=false;
	bChecked=false;
    KBMode = 0;

	
	bool cmdSucceed;
	const int outLength = 7;
	BYTE datapool[outLength];
	
	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x23;
	datapool[3] = 0x01;
	datapool[4] = 0x30;
	datapool[5] = 0x03;
	datapool[6] = 0x40;
	
	cmdSucceed = SendCommandRequest(datapool, outLength);
    OpenDev=0;
    Sleep(200);
	openstart=true;
    openstart1=true;
}

void CKeyInjectModuleDlg::OnUSBKBMode() 
{   

	openstart1=false;
	bChecked=false;
	
	KBMode = 1;
  
	
	bool cmdSucceed;
	const int outLength = 7;
	BYTE datapool[outLength];
	
	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x23;
	datapool[3] = 0x01;
	datapool[4] = 0x38;
	datapool[5] = 0x03;
	datapool[6] = 0x48;
	
	cmdSucceed = SendCommandRequest(datapool, outLength);
    OpenDev=0;
    Sleep(200);
	openstart=true;
	openstart1=true;
}


/**************************************************/
/* Events of Main Menu - Track Setting
/**************************************************/
void CKeyInjectModuleDlg::OnMENUReadAnyTracks() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x13;
	datapool[3] = 0x01;
	datapool[4] = 0x30;
	datapool[5] = 0x03;
	datapool[6] = 0x70;

	SendCommandRequest(datapool, outLength);	
}

void CKeyInjectModuleDlg::OnMENUReadTrack1() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x13;
	datapool[3] = 0x01;
	datapool[4] = 0x31;
	datapool[5] = 0x03;
	datapool[6] = 0x71;

	SendCommandRequest(datapool, outLength);	
}

void CKeyInjectModuleDlg::OnMENUReadTrack2() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x13;
	datapool[3] = 0x01;
	datapool[4] = 0x32;
	datapool[5] = 0x03;
	datapool[6] = 0x72;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUReadTrack12() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x13;
	datapool[3] = 0x01;
	datapool[4] = 0x33;
	datapool[5] = 0x03;
	datapool[6] = 0x73;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUReadTrack3() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x13;
	datapool[3] = 0x01;
	datapool[4] = 0x34;
	datapool[5] = 0x03;
	datapool[6] = 0x74;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUReadTrack13() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x13;
	datapool[3] = 0x01;
	datapool[4] = 0x35;
	datapool[5] = 0x03;
	datapool[6] = 0x75;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUReadTrack23() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x13;
	datapool[3] = 0x01;
	datapool[4] = 0x36;
	datapool[5] = 0x03;
	datapool[6] = 0x76;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUReadAllTracks() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x13;
	datapool[3] = 0x01;
	datapool[4] = 0x37;
	datapool[5] = 0x03;
	datapool[6] = 0x77;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUSendTrackSeparator() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x17;
	datapool[3] = 0x01;
	datapool[4] = 0x0D;
	datapool[5] = 0x03;
	datapool[6] = 0x49;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUNotSendTrackSeparator() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x17;
	datapool[3] = 0x01;
	datapool[4] = 0x00;
	datapool[5] = 0x03;
	datapool[6] = 0x44;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUSendTerminator() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x21;
	datapool[3] = 0x01;
	datapool[4] = 0x0D;
	datapool[5] = 0x03;
	datapool[6] = 0x7F;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUNotSendTerminator() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x21;
	datapool[3] = 0x01;
	datapool[4] = 0x00;
	datapool[5] = 0x03;
	datapool[6] = 0x72;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnEnableLRCID() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x60;
	datapool[3] = 0x01;
	datapool[4] = 0x31;
	datapool[5] = 0x03;
	datapool[6] = 0x02;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnDisableLRCID() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x60;
	datapool[3] = 0x01;
	datapool[4] = 0x30;
	datapool[5] = 0x03;
	datapool[6] = 0x03;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnWSEErrorNotificationID() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x19;
	datapool[3] = 0x01;
	datapool[4] = 0x35;
	datapool[5] = 0x03;
	datapool[6] = 0x7F;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnWoSEAllT2ErrorNotification() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x19;
	datapool[3] = 0x01;
	datapool[4] = 0x34;
	datapool[5] = 0x03;
	datapool[6] = 0x7E;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnWSEPartialT2ErrorNotification() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x19;
	datapool[3] = 0x01;
	datapool[4] = 0x37;
	datapool[5] = 0x03;
	datapool[6] = 0x7D;

	SendCommandRequest(datapool, outLength);
}


/**************************************************/
/* Events of Main Menu - MSR Security
/**************************************************/
void CKeyInjectModuleDlg::OnMENUSetPrePANClrDataID() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x49;
	datapool[3] = 0x01;
	datapool[4] = 0x06;
	datapool[5] = 0x03;
	datapool[6] = 0x1C;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUSetPostPANClrDataID() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x4A;
	datapool[3] = 0x01;
	datapool[4] = 0x03;
	datapool[5] = 0x03;
	datapool[6] = 0x1A;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUSetMaskCharID() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x4B;
	datapool[3] = 0x01;
	datapool[4] = 0x23;
	datapool[5] = 0x03;
	datapool[6] = 0x3B;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnSecurityLevID() 
{
	const int outLength = 5;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x52;
	datapool[2] = 0x7E;
	datapool[3] = 0x03;
	datapool[4] = 0x2D;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnGetDeviceSN() 
{
	const int outLength = 5;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x52;
	datapool[2] = 0x4e;
	datapool[3] = 0x03;
	datapool[4] = 0x1d;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnSetDeviceSN() 
{
	bool cmdSucceed;
	const int outLength = 15;
	BYTE datapool[outLength];

	CFile fSN;
	CFileException ex;
	CString	StrBuff;
	BYTE LRC=0;

	// Read SN from file
	if(fSN.Open(".\\SN.txt", CFile::modeRead, &ex))		
	{
		int len = fSN.GetLength();
		TCHAR *SNData = new TCHAR[len + 1];
		SNData[len] = '\0';
		fSN.Read(SNData, len);
		CString szBuff(SNData);
		
		StrBuff = szBuff;
		fSN.Close();
	}
	else
	{
		StrBuff = _T("00000001");
	}


	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x4e;
	datapool[3] = 0x09;
	datapool[4] = 0x08;

	for (int i=0; i<8; i++)
		datapool[i+5] = StrBuff.GetAt(i);

	datapool[13] = 0x03;
	
	for (i=0; i<14; i++)
		LRC ^= datapool[i];
	
	datapool[14] = LRC;
	
	
	cmdSucceed = SendCommandRequest(datapool, outLength);

	if(cmdSucceed)
	{
		MessageBox("Set Device SN command was sent successfully!","Status",MB_OK);
		
		fSN.Remove(".\\SN.txt");
		
		long SerialNo = atoi(StrBuff);
		SerialNo+=1;	
		StrBuff.Format("%08ld",SerialNo);
		
		// Update the new serial number and write it to the file
		if(fSN.Open(".\\SN.txt", CFile::modeWrite|CFile::modeCreate, &ex))
			fSN.Write(StrBuff, 8);
		
		fSN.Close();
	}
	else
	{
		MessageBox("Fail to Set Device SN!",_T("Error"),MB_OK);
	}
}

void CKeyInjectModuleDlg::OnMenuTdes() 
{
	bool cmdSucceed;
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x4C;
	datapool[3] = 0x01;
	datapool[4] = 0x31;
	datapool[5] = 0x03;
	datapool[6] = 0x2E;

	cmdSucceed = SendCommandRequest(datapool, outLength);

	if(cmdSucceed)

	{
		bDecryptMode = 1;	
    	StrReaderStatus = _T("SecuRED MSR USB HID&KB Reader Connected( TDES Encryption Enabled ) ");
	}
		
		// DES Mode
}

void CKeyInjectModuleDlg::OnMenuAes() 
{
	bool cmdSucceed;
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x4C;
	datapool[3] = 0x01;
	datapool[4] = 0x32;
	datapool[5] = 0x03;
	datapool[6] = 0x2D;
	
	cmdSucceed = SendCommandRequest(datapool, outLength);

	if(cmdSucceed)
	{	bDecryptMode = 2;
		StrReaderStatus = _T("SecuRED MSR USB HID&KB Reader Connected( AES Encryption Enabled ) ");
	}
		
		// AES mode
}

void CKeyInjectModuleDlg::OnMENUSetSessionID() 
{
	// TODO: the result is not confirmed yet
	const int outLength = 14;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x54;
	datapool[3] = 0x08;
	datapool[4] = 0x55;
	datapool[5] = 0x55;
	datapool[6] = 0x55;
	datapool[7] = 0x55;
	datapool[8] = 0x55;
	datapool[9] = 0x55;
	datapool[10] = 0x55;
	datapool[11] = 0x55;
	datapool[12] = 0x03;
	datapool[13] = 0x0E;
	
	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMenuEnableencryption() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x4C;
	datapool[3] = 0x01;
	datapool[4] = 0x31;
	datapool[5] = 0x03;
	datapool[6] = 0x2E;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMenuDisableencryption() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x4C;
	datapool[3] = 0x01;
	datapool[4] = 0x30;
	datapool[5] = 0x03;
	datapool[6] = 0x2F;

	SendCommandRequest(datapool, outLength);
}


/**************************************************/
/* Events of Main Menu - USB KB Setting
/**************************************************/
void CKeyInjectModuleDlg::OnSetpollinginterval1() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x14;
	datapool[3] = 0x01;
	datapool[4] = 0x01;
	datapool[5] = 0x03;
	datapool[6] = 0x46;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUSetPollingInterval() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x14;
	datapool[3] = 0x01;
	datapool[4] = 0x0a;
	datapool[5] = 0x03;
	datapool[6] = 0x4d;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUSetArabia() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x24;
	datapool[3] = 0x01;
	datapool[4] = 0x3d;
	datapool[5] = 0x03;
	datapool[6] = 0x4A;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUSetUK() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x24;
	datapool[3] = 0x01;
	datapool[4] = 0x39;
	datapool[5] = 0x03;
	datapool[6] = 0x4E;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUSetUniversal() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x24;
	datapool[3] = 0x01;
	datapool[4] = 0x3a;
	datapool[5] = 0x03;
	datapool[6] = 0x4d;

	SendCommandRequest(datapool, outLength);
}


/**************************************************/
/* Events of Main Menu - Firmware Upgrade
/**************************************************/
void CKeyInjectModuleDlg::OnEnterBootloaderModeID() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x70;
	datapool[3] = 0x01;
	datapool[4] = 0xFF;
	datapool[5] = 0x03;
	datapool[6] = 0xDC;

	SendCommandRequest(datapool, outLength);
}


/**************************************************/
/* Events of Main Menu - Help
/**************************************************/
void CKeyInjectModuleDlg::OnMENUAbout() 
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();		
}

void CKeyInjectModuleDlg::OnActivateAuthentication() 
{
	// TODO: the result is not confirmed yet

	BYTE BufferTmp1[1024], BufferTmp2[1024];
	ULONG	BufferLength1 =1024, BufferLength2 = 1024;
	bool bConnected = false;


	if(select_mode == COM_MODE)//serial port mode 
	{

		sWaitReadCmd = true;
	//	KBMode = 0; // USB HID
		//		GetDlgItem(IDC_SCRIPT)->ShowWindow(FALSE);
		bConnected = true;			
		int len;
	
		if (!bChecked&&openstart1)
		{
			
			// SecureMag USB HID						
			StrReaderStatus = _T("SecuRED MSR USB HID Reader Connected ");
			
			//	OutputDebugString("thread2");
			
			const int outLength = 5;
			BYTE datapool[outLength];
			
			
			datapool[0] = 0x02;
			datapool[1] = 0x52;
			datapool[2] = 0x4C;
			datapool[3] = 0x03;
			datapool[4] = 0x1F;

	//		MSR.SendCommand(datapool, outLength, BufferTmp2, &BufferLength2);
			len = sp_com.Write(datapool,outLength,100); //sp write
			if(len != outLength)
			{
				AfxMessageBox("Fail to send command!");
				GetDlgItem(IDC_RESP)->SetFocus();
				sWaitReadCmd = false;
			//	sp_com.Close();
				return;
			}
			Sleep(300);
			BufferLength2= sp_com.Read(BufferTmp2, 512, 500);
			
		
				if (BufferTmp2[4] == 0x31)			// TDES
				{
				bDecryptMode = 1;
					StrReaderStatus += _T(" ( TDES Encryption Enabled )");
				}
				
				else if ( BufferTmp2[4] == 0x32)	// AES
				{
				bDecryptMode = 2;
					StrReaderStatus += _T(" ( AES Encryption Enabled )");
				}
			
			 Sleep(500);
			datapool[0] = 0x02;
			datapool[1] = 0x52;
			datapool[2] = 0x3E;
			datapool[3] = 0x03;
			datapool[4] = 0x6d;
		//	MSR.SendCommand(datapool, outLength, BufferTmp2, &BufferLength2);
			len = sp_com.Write(datapool,outLength,100); //sp write
			if(len != outLength)
			{
				AfxMessageBox("Fail to send command!");
				GetDlgItem(IDC_RESP)->SetFocus();
				sWaitReadCmd = false;
			//	sp_com.Close();
				return;
			}
			Sleep(300);
			BufferLength2= sp_com.Read(BufferTmp2, 512, 500);
			
			if(BufferLength2)
			{
				if (BufferTmp2[4] == 0x5a)			// TDES
					
					TypeKey = 1;
				
				
				else
				   TypeKey= 0;
				
			}
				
			
			bChecked = true;

		}

		
			//MSR.CloseMSRDevice();
			sWaitReadCmd = false;
		//	sp_com.Close();
			bChecked = false;
		
	
	}
	else if(select_mode == USB_MODE)
		{
	INTERFACE_TYPE emMyItfType; 
	ULONG emMyItfType1; 
	INTERFACE_TYPE emMyItfType2;
	CString strDevName;
	int		m_ulDevIndex = 0;
	emMyItfType1 = '1';
	emMyItfType2 = ITF_TYPE_USB_HID;
				
				
				CMSRItfUSBHID	MSR(emMyItfType2);
				for(m_ulDevIndex = 0; m_ulDevIndex < 20; m_ulDevIndex++)
				{
					if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
					{
						
						if(emMyItfType != emMyItfType2)			
							continue;
						else
						{
							if(MSR.OpenMSRDevice(m_ulDevIndex))
							{					
								KBMode = 0; // USB HID
								//		GetDlgItem(IDC_SCRIPT)->ShowWindow(FALSE);
								bConnected = true;					
							
								if (!bChecked&&openstart1)
								{
									
									// SecureMag USB HID						
									StrReaderStatus = _T("SecuRED MSR USB HID Reader Connected ");
									
									//	OutputDebugString("thread2");
									
									const int outLength = 5;
									BYTE datapool[outLength];
									
									
									datapool[0] = 0x02;
									datapool[1] = 0x52;
									datapool[2] = 0x4C;
									datapool[3] = 0x03;
									datapool[4] = 0x1F;

									MSR.SendCommand(datapool, outLength, BufferTmp2, &BufferLength2);
									
								
										if (BufferTmp2[4] == 0x31)			// TDES
										{
										bDecryptMode = 1;
											StrReaderStatus += _T(" ( TDES Encryption Enabled )");
										}
										
										else if ( BufferTmp2[4] == 0x32)	// AES
										{
										bDecryptMode = 2;
											StrReaderStatus += _T(" ( AES Encryption Enabled )");
										}
									
									 Sleep(500);
									datapool[0] = 0x02;
									datapool[1] = 0x52;
									datapool[2] = 0x3E;
									datapool[3] = 0x03;
									datapool[4] = 0x6d;
									MSR.SendCommand(datapool, outLength, BufferTmp2, &BufferLength2);
									
									if(BufferLength2)
									{
										if (BufferTmp2[4] == 0x5a)			// TDES
											
											TypeKey = 1;
										
										
										else
										   TypeKey= 0;
										
									}
										
									
									
									
									bChecked = true;
									break;
								}
							}			
						}
					}
				}
				
				if(m_ulDevIndex >= 20){
					emMyItfType2 = ITF_TYPE_USB_HID_KB;
					
					CMSRItfUSBHID	MSR(emMyItfType2);
					for(m_ulDevIndex = 0; m_ulDevIndex <20; m_ulDevIndex++)
					{
						if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
						{
							
							if(emMyItfType != emMyItfType2)
								continue;
							else
							{
								if(MSR.OpenMSRDevice(m_ulDevIndex))
								{		
								KBMode = 1; // USB KB						
									bConnected = true;
									OpenDev=1;
									if (!bChecked&&openstart1)
									{						
										
										StrReaderStatus = _T("SecuRED MSR USB KB Reader Connected ");
										
										const int outLength = 5;
										BYTE datapool[outLength];
										
										//OutputDebugString("thread1");
										
										datapool[0] = 0x02;
										datapool[1] = 0x52;
										datapool[2] = 0x4C;
										datapool[3] = 0x03;
										datapool[4] = 0x1F;
										MSR.SendCommand(datapool, outLength, BufferTmp2, &BufferLength2);
									
											if (BufferTmp2[4] == 0x31)			// TDES
											{
											bDecryptMode = 1;
												StrReaderStatus += _T(" ( TDES Encryption Enabled )");
											}
											
											else if ( BufferTmp2[4] == 0x32)	// AES
											{
											bDecryptMode = 2;
												StrReaderStatus += _T(" ( AES Encryption Enabled )");
											}
									
										
                                       
                                       Sleep(500);
										datapool[0] = 0x02;
										datapool[1] = 0x52;
										datapool[2] = 0x3E;
										datapool[3] = 0x03;
										datapool[4] = 0x6d;
										MSR.SendCommand(datapool, outLength, BufferTmp2, &BufferLength2);
										
										if(BufferLength2)
										{
											if (BufferTmp2[4] == 0x5a)			// TDES
										
												TypeKey = 1;
										
											
											else
											TypeKey= 0;
											
										}
										

										
										
										
										
										
										bChecked = true;
										break;
									}						
								}
							}
						}
					}		
				}



				if (!bConnected)
				{
					MSR.CloseMSRDevice();
					bChecked = false;
				
			
				}

		}
	
		// TODO: the result is not confirmed yet
	CDES		lcDES;
	CDUKPT		lcDUKPT;
	AesCipher	lcAES;
	CString		StrTmp,StrOut;

	BYTE KSNTmp[10];
	BYTE KeyTmp[16];
	BYTE keyt[16];
	BYTE XORKey = 240; // F0
	BOOL bError = false;

	unsigned long counter;
	unsigned char stringKSN[10];
	unsigned char  k=1;

	const int outLength = 8;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x52;
	datapool[2] = 0x80;
	datapool[3] = 0x02;
	datapool[4] = 0x00;
	datapool[5] = 0x00;
	datapool[6] = 0x03;
	datapool[7] = 0xD1;

	SendCommandRequest(datapool, outLength);


	// Check KSN from response
	for(int i=0; i<10; i++) {
		KSNTmp[i] = CardDataBuffer[2 + i]; // skip first 2 bytes
		KSNglb[i] = KSNTmp[i];
	}

	// Update challenge
	for(i=0; i<16; i++)
		challenge[i] = CardDataBuffer[12 + i]; // skip first 2+10 bytes


	for(i=0; i<16; i++)
		keyt[i] = CardDataBuffer[12 + i]; // skip first 2+10 bytes

//@@@ Need to decrypt the 16 bytes to get challeng1 and challeng2. Using TDES CBC.

	//Initial key
	if (!bIK)
	{
		m_str_initial_key = StrInitialKey;
		int len = m_str_initial_key.GetLength();

		for(i=0; i<len/2; i++)							
			m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
	}


	memcpy(stringKSN, KSNTmp,10);

	//calculate the counter
	counter = stringKSN[9] | (stringKSN[8] << 8) | ((stringKSN[7] & 0x1f) << 16);
	stringKSN[9] = stringKSN[8] = 0;
	stringKSN[7] &= 0xE0;

	GetIK(stringKSN, m_nderivation_key, m_ninitial_key, ET_TDES_DUKPT);

	//get the m_cryptoKey
	memset(m_cryptoKey, 0, 16);
	lcDUKPT.IDT_LoadInitKey(1, m_ninitial_key, stringKSN);
	
	do
	{	       
	   lcDUKPT.IDT_EncryptPIN(1,
							  lcDUKPT.IDT_ChangeCounter(counter, k),
							  stringKSN,            // returns the 10-byte KSN
							  m_cryptoKey,
							  TypeKey); 
	   k++;
	}while(k <= lcDUKPT.IDT_GetNumOfOnes(counter));

	for (i=0; i<16; i++)
		KeyTmp[i] = m_cryptoKey[i]^XORKey;



/*
	GetDlgItem(IDC_RESP)->GetWindowText(StrOut);

	StrOut += _T("\r\n\r\nKSN: ");
	for (i=0; i<10; i++)
	{
		StrTmp.Format("%02X ",KSNTmp[i]);
		StrOut += StrTmp;
	}



	StrOut += _T("\r\nm_cryptoKey: ");
	for (i=0; i<16; i++)
	{
		StrTmp.Format("%02X ",m_cryptoKey[i]);
		StrOut += StrTmp;
	}

	StrOut += _T("\r\nm_cryptoKey ^ XORKey: ");
	for (i=0; i<16; i++)
	{
		StrTmp.Format("%02X ",KeyTmp[i]);
		StrOut += StrTmp;
	}
	
	StrOut += _T("\r\n16 Byte Challenge before decryption: ");
	for (i=0; i<16; i++)
	{
		StrTmp.Format("%02X ",challenge[i]);
		StrOut += StrTmp;
	}
	
*/

	if (bDecryptMode == 1) //TDES
	{
		unsigned char init_vector[8] = {0,0,0,0,0,0,0,0};

		lcDES.des_cbc_decryption(1, challenge, KeyTmp, init_vector, (INT16U)((16) >> 3));
	}

	else //if (bDecryptMode == 2) //AES
	{
		unsigned char init_vector[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

		lcAES.setIV(init_vector);
		lcAES.makeRoundKey(KeyTmp, DEFAULT_KEY_LENGTH);
		lcAES.decryptString(challenge, challenge, 16, CBC);
	}
	
		
/*
	
	StrOut += _T("\r\n16 Byte Challenge after decryption: ");
	for (i=0; i<16; i++)
	{
		StrTmp.Format("%02X ",challenge[i]);
		StrOut += StrTmp;
	}
	

	StrOut += _T("\r\nLast 2 bytes of Challenge: ");
	for (i=8; i<10; i++)
	{
		StrTmp.Format("%02X ",challenge[i-2]);
		StrOut += StrTmp;
	}

	GetDlgItem(IDC_RESP)->SetWindowText(StrOut);
*/


// @@@ Need to verify the last 2 bytes of Challenge 1 is the last 2 bytes of KSN
	for (i=8; i<10; i++)
	{
		if (KSNTmp[i] != challenge[i-2])
		{
			MessageBox("KSN does not match!");
			break;
		}
	}
}

void CKeyInjectModuleDlg::OnActivateChallengeReply() 
{
	// TODO: the result is not confirmed yet

	CDES		lcDES;
	CDUKPT		lcDUKPT;
	AesCipher	lcAES;

	BYTE KSNTmp[10];
	BYTE DataTmp[32];
	BYTE KeyTmp[16];
	BYTE LRC = 0;
	BYTE XORKey = 60; // 3C

	unsigned long counter;
	unsigned char stringKSN[10];
	unsigned char  k=1;

	const int outLength = 22;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x82;
	datapool[3] = 0x10;

	// 6-byte challenge 1
	for(int i=0; i<6; i++)
		DataTmp[i] = challenge[i];
	// 2-byte time information
	DataTmp[6] = 0x00;
//	DataTmp[7] = 0x3C; // 60 seconds
	DataTmp[7] = 0x00; // no limit


	// Check KSN from response
//	KSNglb[9]++;
	for(i=0; i<10; i++) {
		KSNTmp[i] = KSNglb[i];
	}

	//Initial key
	if (!bIK)
	{
		m_str_initial_key = StrInitialKey;
		int len = m_str_initial_key.GetLength();

		for(i=0; i<len/2; i++)							
			m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
	}


	memcpy(stringKSN, KSNTmp,10);

	//calculate the counter
	counter = stringKSN[9] | (stringKSN[8] << 8) | ((stringKSN[7] & 0x1f) << 16);
	stringKSN[9] = stringKSN[8] = 0;
	stringKSN[7] &= 0xE0;
 
	GetIK(stringKSN, m_nderivation_key, m_ninitial_key, ET_TDES_DUKPT);

	//get the m_cryptoKey
	memset(m_cryptoKey, 0, 16);
    lcDUKPT.IDT_LoadInitKey(1, m_ninitial_key, stringKSN);

	
	do
	{	       
	   lcDUKPT.IDT_EncryptPIN(m_des_index,
							  lcDUKPT.IDT_ChangeCounter(counter, k),
							  stringKSN,            // returns the 10-byte KSN
							  m_cryptoKey,
							  TypeKey); 
	   k++;
	}while(k <= lcDUKPT.IDT_GetNumOfOnes(counter));


	// challenge
	for(i=8; i<16; i++)
		DataTmp[i] = 0xAA;

	// XOR Key
	for(i=0; i<16; i++)
		KeyTmp[i] = XORKey ^ m_cryptoKey[i];



	if (bDecryptMode == 1)	//TDES
	{
		unsigned char init_vector[8] = {0,0,0,0,0,0,0,0};

		lcDES.des_cbc_encryption(1, DataTmp, KeyTmp, init_vector, (INT16U)((16) >> 3));
	}

	else //if (bDecryptMode == 2) //AES
	{
		unsigned char init_vector[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

		lcAES.setIV(init_vector);
		lcAES.makeRoundKey(KeyTmp, DEFAULT_KEY_LENGTH);
		lcAES.encryptString(DataTmp, DataTmp, 16, CBC);
	}


	// Encrypted Challenge 
	for(i=0; i<16; i++)
		datapool[4 + i] = DataTmp[i];

	datapool[20] = 0x03;

	// calculate LRC
	for (i=0; i<21; i++)
		LRC ^= datapool[i];

	datapool[21] = LRC;


	SendCommandRequest(datapool, outLength);

	if (asctohex(StrResponse.GetAt(StrResponse.GetLength()-3),StrResponse.GetAt(StrResponse.GetLength()-2)) == 6)
	{
		bActivation = true;
	}
}
void CKeyInjectModuleDlg::OnDeactivateChallengeReply() 
{
	
	/*if(OpenDev==0)
	{
		bChecked = false;
		OpenDev=0;
		openstart1=1;
		MessageBox("Please Connect MagSwipe Reader!","Error",MB_OK);
		return;
	}*/
	
	BYTE KSNTmp[10];
	BYTE DataTmp_TDES[16];
	BYTE DataTmp_AES[16];
	BYTE KeyTmp[16];
	BYTE LRC;
	BYTE XORKey = 60; // 3C
	unsigned char  k=1;

	unsigned long   counter;
	unsigned char  stringKSN[10];

	int i;
	
	BYTE datapool_TDES[14];
	BYTE datapool_AES[22];

	
	if (bDecryptMode == 1)	//TDES
	{
		datapool_TDES[0] = 0x02;
		datapool_TDES[1] = 0x53;
		datapool_TDES[2] = 0x81;
		datapool_TDES[3] = 0x08;

		// 6-byte challenge 1
		for(i=0; i<7; i++)
			DataTmp_TDES[i] = challenge[8 + i];
		// 2-byte time information
		DataTmp_TDES[7] = 0x01;
	}

	else					//AES
	{
		datapool_AES[0] = 0x02;
		datapool_AES[1] = 0x53;
		datapool_AES[2] = 0x81;
		datapool_AES[3] = 0x10;

		// 6-byte challenge 1
		for(i=0; i<7; i++)
			DataTmp_AES[i] = challenge[8 + i];
		// 2-byte time information
		DataTmp_AES[7] = 0x01;

		for(i=8; i<15; i++)
			DataTmp_AES[i] = 0;
	}

	// Check KSN from response
//	KSNglb[9]++;
	for(i=0; i<10; i++) {
		KSNTmp[i] = KSNglb[i];
	}

	//Initial key
	if (!bIK)
	{
		m_str_initial_key = StrInitialKey;
		int len = m_str_initial_key.GetLength();

		for(i=0; i<len/2; i++)							
			m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
	}


	memcpy(stringKSN, KSNTmp,10);

	//calculate the counter
	counter = stringKSN[9] | (stringKSN[8] << 8) | ((stringKSN[7] & 0x1f) << 16);
	stringKSN[9] = stringKSN[8] = 0;
	stringKSN[7] &= 0xE0;
 
	GetIK(stringKSN, m_nderivation_key, m_ninitial_key, ET_TDES_DUKPT);

	//get the m_cryptoKey
	memset(m_cryptoKey, 0, 16);
    lcDUKPT.IDT_LoadInitKey(1, m_ninitial_key, stringKSN);

	do
	{	       
	   lcDUKPT.IDT_EncryptPIN(m_des_index,
							  lcDUKPT.IDT_ChangeCounter(counter, k),
							  stringKSN,            // returns the 10-byte KSN
							  m_cryptoKey,
							  TypeKey); 
	   k++;
	}while(k <= lcDUKPT.IDT_GetNumOfOnes(counter));


	// XOR Key
	for(i=0; i<16; i++)
		KeyTmp[i] = XORKey ^ m_cryptoKey[i];


	if (bDecryptMode == 1)	//TDES
	{
		unsigned char init_vector[8] = {0,0,0,0,0,0,0,0};

		lcDES.des_cbc_encryption(1, DataTmp_TDES, KeyTmp, init_vector, (INT16U)((16) >> 3));
		for(i=0; i<8; i++)
			datapool_TDES[4 + i] = DataTmp_TDES[i];

		datapool_TDES[12] = 0x03;

		LRC = 0;
		// calculate LRC
		for (i=0; i<13; i++)
			LRC ^= datapool_TDES[i];

		datapool_TDES[13] = LRC;

		SendCommandRequest(datapool_TDES, 14);

	}
	
	else //if (bDecryptMode == 2) //AES
	{
		unsigned char init_vector[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
		lcAES.setIV(init_vector);
		lcAES.makeRoundKey(KeyTmp, DEFAULT_KEY_LENGTH);
		lcAES.encryptString(DataTmp_AES, DataTmp_AES, 16, CBC);
	
		for(i=0; i<16; i++)
			datapool_AES[4 + i] = DataTmp_AES[i];

		datapool_AES[20] = 0x03;

		LRC = 0;
		// calculate LRC
		for (i=0; i<21; i++)
			LRC ^= datapool_AES[i];

		datapool_AES[21] = LRC;

		SendCommandRequest(datapool_AES, 22);
	}

	
	
if (asctohex(StrResponse.GetAt(StrResponse.GetLength()-3),StrResponse.GetAt(StrResponse.GetLength()-2)) == 6)
{
	bActivation = false;
}
}

void CKeyInjectModuleDlg::OnGetReaderStatus() 
{
	// TODO: the result is not confirmed yet
/*	if(OpenDev==0)
	{
		bChecked = false;
		OpenDev=0;
		openstart1=1;
		MessageBox("Please Connect MagSwipe Reader!","Error",MB_OK);
		return;
	}*/
	
	const int outLength = 5;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x52;
	datapool[2] = 0x83;
	datapool[3] = 0x03;
	datapool[4] = 0xD0;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUNewEncryptionFormat() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x85;
	datapool[3] = 0x01;
	datapool[4] = 0x31;
	datapool[5] = 0x03;
	datapool[6] = 0xE7;

	SendCommandRequest(datapool, outLength);			
}

void CKeyInjectModuleDlg::OnMENUOldEncryptionFormat() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x85;
	datapool[3] = 0x01;
	datapool[4] = 0x30;
	datapool[5] = 0x03;
	datapool[6] = 0xE6;

	SendCommandRequest(datapool, outLength);		
}

void CKeyInjectModuleDlg::OnMENUForceEncryptAllTracks() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x84;
	datapool[3] = 0x01;
	datapool[4] = 0x07;
	datapool[5] = 0x03;
	datapool[6] = 0xD0;

	SendCommandRequest(datapool, outLength);		
}

void CKeyInjectModuleDlg::OnClear() 
{
	// TODO: Add your control notification handler code here
	GetDlgItem(IDC_RESP)->SetWindowText("");
	GetDlgItem(IDC_COMMAND)->SetWindowText("");
	GetDlgItem(IDC_COMMAND)->SetFocus();
}

void CKeyInjectModuleDlg::OnMENUUSBSelect() 
{
	// TODO: Add your command handler code here
	if(sp_com.IsOpened())
		sp_com.Close();
	
	select_mode = USB_MODE;
	m_menu.EnableMenuItem(1,MF_BYPOSITION | MF_ENABLED );
	m_menu.EnableMenuItem(2,MF_BYPOSITION | MF_ENABLED );

	m_menu.EnableMenuItem(HIDIDTMode, MF_BYCOMMAND |MF_ENABLED);
	m_menu.EnableMenuItem(USBKBMode, MF_BYCOMMAND |MF_ENABLED);

	SetButtonState(true);
	
	AfxBeginThread(ThreadProc_numopen, this);
	SendMessage(MSG_SET_TEXT,NULL,NULL);
}

void CKeyInjectModuleDlg::OnMENUCOMSelect() 
{
	// TODO: Add your command handler code here
	if(sp_com.IsOpened())
	{
		return;
	}
	
	CString str_com=L"";
	com_combobox.GetWindowText(str_com);
	sprintf(settings, SETTINGS, str_com[3], 19200, 'n', 1, 8);
	if(!sp_com.Open(settings))	// open sp
	{
		int err = GetLastError();
		AfxMessageBox("Fail to detect device. Please select again!");
		GetDlgItem(IDC_RESP)->SetFocus();
		sp_com.Close();
		return ;
	}
	
	select_mode = COM_MODE;
	m_menu.EnableMenuItem(1,MF_BYPOSITION | MF_ENABLED );
	m_menu.EnableMenuItem(2,MF_BYPOSITION | MF_ENABLED );

	m_menu.EnableMenuItem(HIDIDTMode, MF_BYCOMMAND |MF_GRAYED);
	m_menu.EnableMenuItem(USBKBMode, MF_BYCOMMAND |MF_GRAYED);
	
	
	AfxBeginThread(ThreadSPReadCard, this);

	SetButtonState(true);
	SendMessage(MSG_SET_TEXT,NULL,NULL);
	
}
void CKeyInjectModuleDlg::SetButtonState(bool b_state)
{
	GetDlgItem(IDC_SEND)->EnableWindow(b_state);
	GetDlgItem(IDC_INPUT_KEY)->EnableWindow(b_state);
	GetDlgItem(IDC_SCRIPT)->EnableWindow(b_state);
	GetDlgItem(IDC_ACTAUTH)->EnableWindow(b_state);
	GetDlgItem(IDC_ACTRPLY)->EnableWindow(b_state);
	GetDlgItem(IDC_DEACTRPLY)->EnableWindow(b_state);
	GetDlgItem(IDC_STATUS)->EnableWindow(b_state);
}
LRESULT  CKeyInjectModuleDlg::OnUpdateUI(WPARAM   wParam,   LPARAM   lParam)   
{ 
	UpdateData(false);
	return   0;   
} 
void EnumerateSerialPorts(CUIntArray& ports)
{
  //Make sure we clear out any elements which may already be in the array
  ports.RemoveAll();

  //Determine what OS we are running on
  OSVERSIONINFO osvi;
  osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
  BOOL bGetVer = GetVersionEx(&osvi);

  //On NT use the QueryDosDevice API
  if (bGetVer && (osvi.dwPlatformId == VER_PLATFORM_WIN32_NT))
  {
    //Use QueryDosDevice to look for all devices of the form COMx. This is a better
    //solution as it means that no ports have to be opened at all.
    TCHAR szDevices[65535];
    DWORD dwChars = QueryDosDevice(NULL, szDevices, 65535);
    if (dwChars)
    {
      int i=0;
      for (;;)
      {
        //Get the current device name
        TCHAR* pszCurrentDevice = &szDevices[i];
        //If it looks like "COMX" then
        //add it to the array which will be returned
        int nLen = _tcslen(pszCurrentDevice);
        if (nLen > 3 && _tcsnicmp(pszCurrentDevice, _T("COM"), 3) == 0)
        {
          //Work out the port number
          int nPort = _ttoi(&pszCurrentDevice[3]);
          ports.Add(nPort);
        }
        // Go to next NULL character
        while(szDevices[i] != _T('\0'))
          i++;
        // Bump pointer to the next string
        i++;
        // The list is double-NULL terminated, so if the character is
        // now NULL, we're at the end
        if (szDevices[i] == _T('\0'))
          break;
      }
    }
    else
      TRACE(_T("Failed in call to QueryDosDevice, GetLastError:%d\n"), GetLastError());
  }
  else
  {
    //On 95/98 open up each port to determine their existence
    //Up to 255 COM ports are supported so we iterate through all of them seeing
    //if we can open them or if we fail to open them, get an access denied or general error error.
    //Both of these cases indicate that there is a COM port at that number. 
    for (UINT i=1; i<256; i++)
    {
      //Form the Raw device name
      CString sPort;
      sPort.Format(_T("\\\\.\\COM%d"), i);

      //Try to open the port
      BOOL bSuccess = FALSE;
      HANDLE hPort = ::CreateFile(sPort, GENERIC_READ | GENERIC_WRITE, 0, 0, OPEN_EXISTING, 0, 0);
      if (hPort == INVALID_HANDLE_VALUE)
      {
        DWORD dwError = GetLastError();
        //Check to see if the error was because some other app had the port open or a general failure
        if (dwError == ERROR_ACCESS_DENIED || dwError == ERROR_GEN_FAILURE)
          bSuccess = TRUE;
      }
      else
      {
        //The port was opened successfully
        bSuccess = TRUE;
        //Don't forget to close the port, since we are going to do nothing with it anyway
        CloseHandle(hPort);
      }
      //Add the port number to the array which will be returned
      if (bSuccess)
        ports.Add(i);
    }
  }
}

void ParseResponseByteToCstring(CString& strResponse1,BYTE* strIn,int ulMyRetLen)
{
	int LastByte;
	CString StringTmp;
	int i;
	BYTE MyRetBuf[1024];

	memcpy(MyRetBuf,strIn,ulMyRetLen);
	LastByte = ulMyRetLen;
	if(ulMyRetLen > 0)
	{
		strResponse1 = _T("");
		for (i=ulMyRetLen-1; i>0; i--)		
			if (MyRetBuf[i] == 0)
				LastByte = i;
			else
				break;
	}

	if(MyRetBuf[0]==0x06&&MyRetBuf[1]!=0x02)
		{
	      StringTmp.Format("%02X ",MyRetBuf[0]);
			strResponse1 += StringTmp;
		
	}
	else
	{
		int lrc=0;
	for (i=0; i<LastByte; i++)
	{
		if(MyRetBuf[i]==0x03)
		{
	
		
		for(int k=1;k<=i;k++)
        lrc=lrc^MyRetBuf[k];
		if(lrc==MyRetBuf[i+1])
		{
			StringTmp.Format("%02X %02X ",MyRetBuf[i],MyRetBuf[i+1]);
		strResponse1 += StringTmp;
			break;
		}
		else {
			
			StringTmp.Format("%02X ",MyRetBuf[i]);
			strResponse1 += StringTmp;
		}
		
		
		}
		else {
			StringTmp.Format("%02X ",MyRetBuf[i]);
			strResponse1 += StringTmp;}
		
	}
	}

	
}
void CKeyInjectModuleDlg::OnInitMenuPopup(CMenu *pPopupMenu, UINT nIndex,BOOL bSysMenu)
{
    ASSERT(pPopupMenu != NULL);
    // Check the enabled state of various menu items.

    CCmdUI state;
    state.m_pMenu = pPopupMenu;
    ASSERT(state.m_pOther == NULL);
    ASSERT(state.m_pParentMenu == NULL);

    // Determine if menu is popup in top-level menu and set m_pOther to
    // it if so (m_pParentMenu == NULL indicates that it is secondary popup).
    HMENU hParentMenu;
    if (AfxGetThreadState()->m_hTrackingMenu == pPopupMenu->m_hMenu)
        state.m_pParentMenu = pPopupMenu;    // Parent == child for tracking popup.
    else if ((hParentMenu = ::GetMenu(m_hWnd)) != NULL)
    {
        CWnd* pParent = this;
           // Child windows don't have menus--need to go to the top!
        if (pParent != NULL &&
           (hParentMenu = ::GetMenu(pParent->m_hWnd)) != NULL)
        {
           int nIndexMax = ::GetMenuItemCount(hParentMenu);
           for (int nIndex = 0; nIndex < nIndexMax; nIndex++)
           {
            if (::GetSubMenu(hParentMenu, nIndex) == pPopupMenu->m_hMenu)
            {
                // When popup is found, m_pParentMenu is containing menu.
                state.m_pParentMenu = CMenu::FromHandle(hParentMenu);
                break;
            }
           }
        }
    }

    state.m_nIndexMax = pPopupMenu->GetMenuItemCount();
    for (state.m_nIndex = 0; state.m_nIndex < state.m_nIndexMax;
      state.m_nIndex++)
    {
        state.m_nID = pPopupMenu->GetMenuItemID(state.m_nIndex);
        if (state.m_nID == 0)
           continue; // Menu separator or invalid cmd - ignore it.

        ASSERT(state.m_pOther == NULL);
        ASSERT(state.m_pMenu != NULL);
        if (state.m_nID == (UINT)-1)
        {
           // Possibly a popup menu, route to first item of that popup.
           state.m_pSubMenu = pPopupMenu->GetSubMenu(state.m_nIndex);
           if (state.m_pSubMenu == NULL ||
            (state.m_nID = state.m_pSubMenu->GetMenuItemID(0)) == 0 ||
            state.m_nID == (UINT)-1)
           {
            continue;       // First item of popup can't be routed to.
           }
           state.DoUpdate(this, TRUE);   // Popups are never auto disabled.
        }
        else
        {
           // Normal menu item.
           // Auto enable/disable if frame window has m_bAutoMenuEnable
           // set and command is _not_ a system command.
           state.m_pSubMenu = NULL;
           state.DoUpdate(this, FALSE);
        }

        // Adjust for menu deletions and additions.
        UINT nCount = pPopupMenu->GetMenuItemCount();
        if (nCount < state.m_nIndexMax)
        {
           state.m_nIndex -= (state.m_nIndexMax - nCount);
           while (state.m_nIndex < nCount &&
            pPopupMenu->GetMenuItemID(state.m_nIndex) == state.m_nID)
           {
            state.m_nIndex++;
           }
        }
        state.m_nIndexMax = nCount;
    }
}

void CKeyInjectModuleDlg::OnSelchangeCOMBOCom() 
{
	// TODO: Add your control notification handler code here
	
	int index;
	if(sp_com.IsOpened())
		sp_com.Close();
	
	if(select_mode == COM_MODE)
	{
		CString str_com=L"";
		com_combobox.GetWindowText(str_com);
		index = com_combobox.GetCurSel();
		com_combobox.GetLBText(index,str_com);// output current selection
		sprintf(settings, SETTINGS, str_com[3], 19200, 'n', 1, 8);
		if(!sp_com.Open(settings))	// open sp
		{
			int err = GetLastError();
			AfxMessageBox("Fail to detect device. Please select again!");
			GetDlgItem(IDC_RESP)->SetFocus();
			sp_com.Close();
		}
	}
	
}

void CKeyInjectModuleDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	//int cx1 = GetSystemMetrics(SM_CXFULLSCREEN);
	//int cy1 = GetSystemMetrics(SM_CYFULLSCREEN);
	//CRect temprect(0,0,cx1/3,cy1/2); 
	//CWnd::SetWindowPos(NULL,0,0,temprect.Width(),temprect.Height(),SWP_NOZORDER|SWP_NOMOVE);
	 if(nType!=SIZE_MINIMIZED )  //жϴǲСˣΪС֮ ڵĳͿ0ǰһα仯ʱͻֳ0Ĵ
	 {
		 ChangeSize(IDC_COMBO_Com,cx,cy); 
		 ChangeSize(IDC_COMMAND,cx,cy); 
		 ChangeSize(IDC_SEND,cx,cy);  //ÿһؼ
		 ChangeSize(IDC_INPUT_KEY,cx,cy);
		 ChangeSize(IDC_SCRIPT,cx,cy);
		 ChangeSize(IDC_EXIT,cx,cy); 
		 ChangeSize(IDC_Clear,cx,cy); 
		 ChangeSize(IDC_RESP,cx,cy); 
		 ChangeSize(IDC_STATIC,cx,cy);
		 //ChangeSize(IDC_COMMAND,cx,cy); 
		 //ChangeSize(IDC_COMMAND,cx,cy); 
		 //ChangeSize(IDC_COMMAND,cx,cy); 
		 GetClientRect(&m_rect);   //Ҫ¶ԻĴСһα仯ľꣻ
	 }
}

void CKeyInjectModuleDlg::ChangeSize(UINT nID, int x, int y)  //nIDΪؼIDx,yֱΪԻĵǰͿ
{
       CWnd *pWnd;
       pWnd=GetDlgItem(nID); 
       if(pWnd!=NULL)     //жǷΪգΪڴڴʱҲOnSizeǴʱؼûдPwndΪ
       {
		   CRect rec; 
		   pWnd->GetWindowRect(&rec);  //ȡؼ仯ǰĴС
		   ScreenToClient(&rec);   //ؼСװλڶԻе
		   rec.left=rec.left*x/m_rect.Width();  //ձռλ
		   rec.top=rec.top*y/m_rect.Height();
		   rec.bottom=rec.bottom*y/m_rect.Height();
		   rec.right=rec.right*x/m_rect.Width();
		   pWnd->MoveWindow(rec);   //ؼ
      }
}